import numpy
import os
import typing
from . import CompareElementsAndConditionsUtility as CompareElementsAndConditionsUtility, ConstraintUtilities as ConstraintUtilities, CreateTriangleMeshFromNodes as CreateTriangleMeshFromNodes, EntitiesUtilities as EntitiesUtilities, Expression as Expression, GeometricalTransformationUtilities as GeometricalTransformationUtilities, Globals as Globals, ModelPartOperationUtilities as ModelPartOperationUtilities, MortarUtilities as MortarUtilities, PropertiesUtilities as PropertiesUtilities, SingleImportModelPart as SingleImportModelPart, SpecificationsUtilities as SpecificationsUtilities, StringUtilities as StringUtilities, Testing as Testing, TestsUtilities as TestsUtilities, TimeDiscretization as TimeDiscretization
from _typeshed import Incomplete
from typing import ClassVar, Iterator, overload

ABSORPTION_COEFFICIENT: DoubleVariable
ACCELERATION: Array1DVariable3
ACCELERATION_MOVING_FRAME_ORIGIN: Array1DVariable3
ACCELERATION_MOVING_FRAME_ORIGIN_X: DoubleVariable
ACCELERATION_MOVING_FRAME_ORIGIN_Y: DoubleVariable
ACCELERATION_MOVING_FRAME_ORIGIN_Z: DoubleVariable
ACCELERATION_X: DoubleVariable
ACCELERATION_Y: DoubleVariable
ACCELERATION_Z: DoubleVariable
ACTIVATION_LEVEL: IntegerVariable
ACTIVE: Flags
ADDITIONAL_FORCE: Array1DVariable3
ADDITIONAL_FORCE_OLD: Array1DVariable3
ADDITIONAL_FORCE_OLD_OLD: Array1DVariable3
ADDITIONAL_FORCE_OLD_OLD_X: DoubleVariable
ADDITIONAL_FORCE_OLD_OLD_Y: DoubleVariable
ADDITIONAL_FORCE_OLD_OLD_Z: DoubleVariable
ADDITIONAL_FORCE_OLD_X: DoubleVariable
ADDITIONAL_FORCE_OLD_Y: DoubleVariable
ADDITIONAL_FORCE_OLD_Z: DoubleVariable
ADDITIONAL_FORCE_X: DoubleVariable
ADDITIONAL_FORCE_Y: DoubleVariable
ADDITIONAL_FORCE_Z: DoubleVariable
ADVPROJ: Array1DVariable3
ADVPROJ_X: DoubleVariable
ADVPROJ_Y: DoubleVariable
ADVPROJ_Z: DoubleVariable
AIR_ENTRY_VALUE: DoubleVariable
AIR_PRESSURE: DoubleVariable
AIR_SOUND_VELOCITY: DoubleVariable
ALL_DEFINED: Flags
ALL_TRUE: Flags
ALMANSI_STRAIN_TENSOR: MatrixVariable
ALMANSI_STRAIN_VECTOR: VectorVariable
ALPHA_SHEAR: DoubleVariable
AMBIENT_TEMPERATURE: DoubleVariable
ANGULAR_ACCELERATION: Array1DVariable3
ANGULAR_ACCELERATION_MOVING_FRAME: Array1DVariable3
ANGULAR_ACCELERATION_MOVING_FRAME_X: DoubleVariable
ANGULAR_ACCELERATION_MOVING_FRAME_Y: DoubleVariable
ANGULAR_ACCELERATION_MOVING_FRAME_Z: DoubleVariable
ANGULAR_ACCELERATION_X: DoubleVariable
ANGULAR_ACCELERATION_Y: DoubleVariable
ANGULAR_ACCELERATION_Z: DoubleVariable
ANGULAR_MOMENTUM: Array1DVariable3
ANGULAR_MOMENTUM_X: DoubleVariable
ANGULAR_MOMENTUM_Y: DoubleVariable
ANGULAR_MOMENTUM_Z: DoubleVariable
ANGULAR_VELOCITY: Array1DVariable3
ANGULAR_VELOCITY_MOVING_FRAME: Array1DVariable3
ANGULAR_VELOCITY_MOVING_FRAME_OLD: Array1DVariable3
ANGULAR_VELOCITY_MOVING_FRAME_OLD_X: DoubleVariable
ANGULAR_VELOCITY_MOVING_FRAME_OLD_Y: DoubleVariable
ANGULAR_VELOCITY_MOVING_FRAME_OLD_Z: DoubleVariable
ANGULAR_VELOCITY_MOVING_FRAME_X: DoubleVariable
ANGULAR_VELOCITY_MOVING_FRAME_Y: DoubleVariable
ANGULAR_VELOCITY_MOVING_FRAME_Z: DoubleVariable
ANGULAR_VELOCITY_PERIOD: DoubleVariable
ANGULAR_VELOCITY_X: DoubleVariable
ANGULAR_VELOCITY_Y: DoubleVariable
ANGULAR_VELOCITY_Z: DoubleVariable
ARRHENIUS: DoubleVariable
ARRHENIUSAUX: DoubleVariable
ARRHENIUSAUX_: DoubleVariable
ATOMIC_VOLUME: DoubleVariable
AUXILIAR_CONSTRAINT_SCALE_FACTOR: DoubleVariable
AUX_DISTANCE: DoubleVariable
AUX_INDEX: DoubleVariable
AUX_MESH_VAR: DoubleVariable
AUX_VEL: Array1DVariable3
AUX_VEL_X: DoubleVariable
AUX_VEL_Y: DoubleVariable
AUX_VEL_Z: DoubleVariable
BASSET_FORCE: Array1DVariable3
BASSET_FORCE_TYPE: IntegerVariable
BASSET_FORCE_X: DoubleVariable
BASSET_FORCE_Y: DoubleVariable
BASSET_FORCE_Z: DoubleVariable
BDF_COEFFICIENTS: VectorVariable
BLOCKED: Flags
BODY_FORCE: Array1DVariable3
BODY_FORCE_X: DoubleVariable
BODY_FORCE_Y: DoubleVariable
BODY_FORCE_Z: DoubleVariable
BOSSAK_ALPHA: DoubleVariable
BOUNDARY: Flags
BUILD_SCALE_FACTOR: DoubleVariable
BULK_AIR: DoubleVariable
BULK_MODULUS: DoubleVariable
BUOYANCY: Array1DVariable3
BUOYANCY_FORCE_TYPE: IntegerVariable
BUOYANCY_X: DoubleVariable
BUOYANCY_Y: DoubleVariable
BUOYANCY_Z: DoubleVariable
C10: DoubleVariable
C20: DoubleVariable
C30: DoubleVariable
CATION_CONCENTRATION: DoubleVariable
CAUCHY_STRESS_TENSOR: MatrixVariable
CAUCHY_STRESS_VECTOR: VectorVariable
CFL_NUMBER: DoubleVariable
CHARACTERISTIC_GEOMETRY_LENGTH: Array1DVariable3
CHARACTERISTIC_GEOMETRY_LENGTH_X: DoubleVariable
CHARACTERISTIC_GEOMETRY_LENGTH_Y: DoubleVariable
CHARACTERISTIC_GEOMETRY_LENGTH_Z: DoubleVariable
CHARACTERISTIC_LENGTH_MULTIPLIER: DoubleVariable
COEFFICIENT_THERMAL_EXPANSION: DoubleVariable
COMPUTE_DYNAMIC_TANGENT: BoolVariable
COMPUTE_LUMPED_MASS_MATRIX: BoolVariable
CONDUCTIVITY: DoubleVariable
CONSTITUTIVE_LAW: ConstitutuveLawVariable
CONSTITUTIVE_LAW_NAME: StringVariable
CONSTITUTIVE_MATRIX: MatrixVariable
CONSTITUTIVE_MATRIX_KIRCHHOFF: MatrixVariable
CONSTITUTIVE_MATRIX_PK2: MatrixVariable
CONSTRAINT_LABELS: VectorVariable
CONSTRAINT_MESHES: VectorVariable
CONSTRAINT_SCALE_FACTOR: DoubleVariable
CONTACT: Flags
CONTACT_FORCE: Array1DVariable3
CONTACT_FORCES_VECTOR: VectorVariable
CONTACT_FORCE_X: DoubleVariable
CONTACT_FORCE_Y: DoubleVariable
CONTACT_FORCE_Z: DoubleVariable
CONTACT_NORMAL: Array1DVariable3
CONTACT_NORMAL_X: DoubleVariable
CONTACT_NORMAL_Y: DoubleVariable
CONTACT_NORMAL_Z: DoubleVariable
CONTACT_PRESSURE: DoubleVariable
CONTINUUM_INI_NEIGHBOURS_IDS: IntegerVectorVariable
CONVECTION_COEFFICIENT: DoubleVariable
CONVECTION_DIFFUSION_SETTINGS: ConvectionDiffusionSettingsVariable
CONVERGENCE_ACCELERATOR_ITERATION: IntegerVariable
CONVERGENCE_RATIO: DoubleVariable
CONV_PROJ: Array1DVariable3
CONV_PROJ_X: DoubleVariable
CONV_PROJ_Y: DoubleVariable
CONV_PROJ_Z: DoubleVariable
COUPLING_TYPE: IntegerVariable
CRACK_OPENING: DoubleVariable
CRACK_TRANSLATION: DoubleVariable
CRITICAL_STATE_LINE: DoubleVariable
CROSS_WIND_STABILIZATION_FACTOR: DoubleVariable
CURRENT_COMPONENT: IntegerVariable
CUTTED_AREA: DoubleVariable
C_SMAGORINSKY: DoubleVariable
DAMAGE_THRESHOLD: DoubleVariable
DAMAGE_VARIABLE: DoubleVariable
DAMP_FORCES: Array1DVariable3
DAMP_FORCES_X: DoubleVariable
DAMP_FORCES_Y: DoubleVariable
DAMP_FORCES_Z: DoubleVariable
DEBUG_INFO: FillCommunicatorEchoLevel
DEFORMATION_GRADIENT: MatrixVariable
DELTA_PLASTIC_DISSIPATION: DoubleVariable
DELTA_PLASTIC_STRAIN: DoubleVariable
DELTA_ROTATION: Array1DVariable3
DELTA_ROTATION_X: DoubleVariable
DELTA_ROTATION_Y: DoubleVariable
DELTA_ROTATION_Z: DoubleVariable
DELTA_TIME: DoubleVariable
DELTA_TIME_QUADRATURE: DoubleVariable
DEM_DELTA_TIME: DoubleVariable
DENSITY: DoubleVariable
DENSITY_AIR: DoubleVariable
DENSITY_WATER: DoubleVariable
DETERMINANT: Array1DVariable3
DETERMINANTS_OF_JACOBIAN_PARENT: VectorVariable
DETERMINANT_F: DoubleVariable
DETERMINANT_X: DoubleVariable
DETERMINANT_Y: DoubleVariable
DETERMINANT_Z: DoubleVariable
DIAMETER: DoubleVariable
DIHEDRAL_ANGLE: DoubleVariable
DIRECTION: Array1DVariable3
DIRECTION_X: DoubleVariable
DIRECTION_Y: DoubleVariable
DIRECTION_Z: DoubleVariable
DISPERSE_FRACTION: DoubleVariable
DISPERSE_FRACTION_GRADIENT: Array1DVariable3
DISPERSE_FRACTION_GRADIENT_PROJECTED: Array1DVariable3
DISPERSE_FRACTION_GRADIENT_PROJECTED_X: DoubleVariable
DISPERSE_FRACTION_GRADIENT_PROJECTED_Y: DoubleVariable
DISPERSE_FRACTION_GRADIENT_PROJECTED_Z: DoubleVariable
DISPERSE_FRACTION_GRADIENT_X: DoubleVariable
DISPERSE_FRACTION_GRADIENT_Y: DoubleVariable
DISPERSE_FRACTION_GRADIENT_Z: DoubleVariable
DISPERSE_FRACTION_PROJECTED: DoubleVariable
DISPERSE_FRACTION_RATE: DoubleVariable
DISPLACEMENT: Array1DVariable3
DISPLACEMENT_X: DoubleVariable
DISPLACEMENT_Y: DoubleVariable
DISPLACEMENT_Z: DoubleVariable
DISTANCE: DoubleVariable
DISTANCE_GRADIENT: Array1DVariable3
DISTANCE_GRADIENT_X: DoubleVariable
DISTANCE_GRADIENT_Y: DoubleVariable
DISTANCE_GRADIENT_Z: DoubleVariable
DIVPROJ: DoubleVariable
DOMAIN_SIZE: IntegerVariable
DP_ALPHA1: DoubleVariable
DP_EPSILON: DoubleVariable
DP_K: DoubleVariable
DRAG_COEFFICIENT: DoubleVariable
DRAG_FORCE: Array1DVariable3
DRAG_FORCE_TYPE: IntegerVariable
DRAG_FORCE_X: DoubleVariable
DRAG_FORCE_Y: DoubleVariable
DRAG_FORCE_Z: DoubleVariable
DRAG_LAW_SLOPE: DoubleVariable
DRAG_MODIFIER_TYPE: IntegerVariable
DRAG_POROSITY_CORRECTION_TYPE: IntegerVariable
DRAG_REACTION: Array1DVariable3
DRAG_REACTION_X: DoubleVariable
DRAG_REACTION_Y: DoubleVariable
DRAG_REACTION_Z: DoubleVariable
DYNAMIC_TAU: DoubleVariable
DYNAMIC_VISCOSITY: DoubleVariable
EFFECTIVE_VISCOSITY: DoubleVariable
ELEMENTAL_DISTANCES: VectorVariable
ELEMENTAL_EDGE_DISTANCES: VectorVariable
ELEMENTAL_EDGE_DISTANCES_EXTRAPOLATED: VectorVariable
ELEMENTSHAPE: Array1DVariable3
ELEMENTSHAPE_X: DoubleVariable
ELEMENTSHAPE_Y: DoubleVariable
ELEMENTSHAPE_Z: DoubleVariable
ELEMENT_ERROR: DoubleVariable
ELEMENT_H: DoubleVariable
ELEMENT_TYPE: StringVariable
EMBEDDED_VELOCITY: Array1DVariable3
EMBEDDED_VELOCITY_X: DoubleVariable
EMBEDDED_VELOCITY_Y: DoubleVariable
EMBEDDED_VELOCITY_Z: DoubleVariable
EMISSIVITY: DoubleVariable
END_TIME: DoubleVariable
ENRICHED_PRESSURES: VectorVariable
ENTHALPY: DoubleVariable
ENTHAPLY_ACTIVATION: DoubleVariable
EQUILIBRIUM_POINT: DoubleVariable
EQ_STRAIN_RATE: DoubleVariable
ERROR_INTEGRATION_POINT: DoubleVariable
ERROR_RATIO: DoubleVariable
EXTERNAL_APPLIED_FORCE: Array1DVariable3
EXTERNAL_APPLIED_FORCE_X: DoubleVariable
EXTERNAL_APPLIED_FORCE_Y: DoubleVariable
EXTERNAL_APPLIED_FORCE_Z: DoubleVariable
EXTERNAL_APPLIED_MOMENT: Array1DVariable3
EXTERNAL_APPLIED_MOMENT_X: DoubleVariable
EXTERNAL_APPLIED_MOMENT_Y: DoubleVariable
EXTERNAL_APPLIED_MOMENT_Z: DoubleVariable
EXTERNAL_ENERGY: DoubleVariable
EXTERNAL_FORCE: Array1DVariable3
EXTERNAL_FORCES_VECTOR: VectorVariable
EXTERNAL_FORCE_X: DoubleVariable
EXTERNAL_FORCE_Y: DoubleVariable
EXTERNAL_FORCE_Z: DoubleVariable
EXTERNAL_PRESSURE: DoubleVariable
FACE_HEAT_FLUX: DoubleVariable
FACE_LOAD: Array1DVariable3
FACE_LOAD_X: DoubleVariable
FACE_LOAD_Y: DoubleVariable
FACE_LOAD_Z: DoubleVariable
FICTITIOUS_FLUID_DENSITY: DoubleVariable
FIRST_SATURATION_PARAM: DoubleVariable
FIRST_TIME_STEP: IntegerVariable
FIXED_MESH_OPTION: IntegerVariable
FLAG_VARIABLE: DoubleVariable
FLUID: Flags
FLUID_ACCEL_FOLLOWING_PARTICLE_PROJECTED: Array1DVariable3
FLUID_ACCEL_FOLLOWING_PARTICLE_PROJECTED_X: DoubleVariable
FLUID_ACCEL_FOLLOWING_PARTICLE_PROJECTED_Y: DoubleVariable
FLUID_ACCEL_FOLLOWING_PARTICLE_PROJECTED_Z: DoubleVariable
FLUID_ACCEL_PROJECTED: Array1DVariable3
FLUID_ACCEL_PROJECTED_X: DoubleVariable
FLUID_ACCEL_PROJECTED_Y: DoubleVariable
FLUID_ACCEL_PROJECTED_Z: DoubleVariable
FLUID_DENSITY_PROJECTED: DoubleVariable
FLUID_FRACTION: DoubleVariable
FLUID_FRACTION_FILTERED: DoubleVariable
FLUID_FRACTION_GRADIENT: Array1DVariable3
FLUID_FRACTION_GRADIENT_PROJECTED: Array1DVariable3
FLUID_FRACTION_GRADIENT_PROJECTED_X: DoubleVariable
FLUID_FRACTION_GRADIENT_PROJECTED_Y: DoubleVariable
FLUID_FRACTION_GRADIENT_PROJECTED_Z: DoubleVariable
FLUID_FRACTION_GRADIENT_X: DoubleVariable
FLUID_FRACTION_GRADIENT_Y: DoubleVariable
FLUID_FRACTION_GRADIENT_Z: DoubleVariable
FLUID_FRACTION_OLD: DoubleVariable
FLUID_FRACTION_PROJECTED: DoubleVariable
FLUID_FRACTION_RATE: DoubleVariable
FLUID_MODEL_TYPE: IntegerVariable
FLUID_VEL_LAPL_PROJECTED: Array1DVariable3
FLUID_VEL_LAPL_PROJECTED_X: DoubleVariable
FLUID_VEL_LAPL_PROJECTED_Y: DoubleVariable
FLUID_VEL_LAPL_PROJECTED_Z: DoubleVariable
FLUID_VEL_LAPL_RATE_PROJECTED: Array1DVariable3
FLUID_VEL_LAPL_RATE_PROJECTED_X: DoubleVariable
FLUID_VEL_LAPL_RATE_PROJECTED_Y: DoubleVariable
FLUID_VEL_LAPL_RATE_PROJECTED_Z: DoubleVariable
FLUID_VEL_PROJECTED: Array1DVariable3
FLUID_VEL_PROJECTED_RATE: Array1DVariable3
FLUID_VEL_PROJECTED_RATE_X: DoubleVariable
FLUID_VEL_PROJECTED_RATE_Y: DoubleVariable
FLUID_VEL_PROJECTED_RATE_Z: DoubleVariable
FLUID_VEL_PROJECTED_X: DoubleVariable
FLUID_VEL_PROJECTED_Y: DoubleVariable
FLUID_VEL_PROJECTED_Z: DoubleVariable
FLUID_VISCOSITY_PROJECTED: DoubleVariable
FLUID_VORTICITY_PROJECTED: Array1DVariable3
FLUID_VORTICITY_PROJECTED_X: DoubleVariable
FLUID_VORTICITY_PROJECTED_Y: DoubleVariable
FLUID_VORTICITY_PROJECTED_Z: DoubleVariable
FORCE: Array1DVariable3
FORCE_CM: Array1DVariable3
FORCE_CM_X: DoubleVariable
FORCE_CM_Y: DoubleVariable
FORCE_CM_Z: DoubleVariable
FORCE_RESIDUAL: Array1DVariable3
FORCE_RESIDUAL_X: DoubleVariable
FORCE_RESIDUAL_Y: DoubleVariable
FORCE_RESIDUAL_Z: DoubleVariable
FORCE_X: DoubleVariable
FORCE_Y: DoubleVariable
FORCE_Z: DoubleVariable
FRACTIONAL_STEP: IntegerVariable
FRACTURE_ENERGY: DoubleVariable
FRACT_VEL: Array1DVariable3
FRACT_VEL_X: DoubleVariable
FRACT_VEL_Y: DoubleVariable
FRACT_VEL_Z: DoubleVariable
FRAME_OF_REFERENCE_TYPE: IntegerVariable
FREE_SURFACE: Flags
FRICTION_COEFFICIENT: DoubleVariable
FSI_INTERFACE_MESH_RESIDUAL: Array1DVariable3
FSI_INTERFACE_MESH_RESIDUAL_NORM: DoubleVariable
FSI_INTERFACE_MESH_RESIDUAL_X: DoubleVariable
FSI_INTERFACE_MESH_RESIDUAL_Y: DoubleVariable
FSI_INTERFACE_MESH_RESIDUAL_Z: DoubleVariable
FSI_INTERFACE_RESIDUAL: Array1DVariable3
FSI_INTERFACE_RESIDUAL_NORM: DoubleVariable
FSI_INTERFACE_RESIDUAL_X: DoubleVariable
FSI_INTERFACE_RESIDUAL_Y: DoubleVariable
FSI_INTERFACE_RESIDUAL_Z: DoubleVariable
FUEL: DoubleVariable
GB_WIDTH: DoubleVariable
GRAVITY: Array1DVariable3
GRAVITY_X: DoubleVariable
GRAVITY_Y: DoubleVariable
GRAVITY_Z: DoubleVariable
GREEN_LAGRANGE_STRAIN_TENSOR: MatrixVariable
GREEN_LAGRANGE_STRAIN_VECTOR: VectorVariable
HARDENING_EXPONENT: DoubleVariable
HARDNESS_CONDUCTIVITY: DoubleVariable
HEAT_FLUX: DoubleVariable
HYDRODYNAMIC_FORCE: Array1DVariable3
HYDRODYNAMIC_FORCE_X: DoubleVariable
HYDRODYNAMIC_FORCE_Y: DoubleVariable
HYDRODYNAMIC_FORCE_Z: DoubleVariable
HYDRODYNAMIC_MOMENT: Array1DVariable3
HYDRODYNAMIC_MOMENT_X: DoubleVariable
HYDRODYNAMIC_MOMENT_Y: DoubleVariable
HYDRODYNAMIC_MOMENT_Z: DoubleVariable
HYDRODYNAMIC_REACTION: Array1DVariable3
HYDRODYNAMIC_REACTION_X: DoubleVariable
HYDRODYNAMIC_REACTION_Y: DoubleVariable
HYDRODYNAMIC_REACTION_Z: DoubleVariable
HYDRO_TORQUE_TYPE: IntegerVariable
Hfuel: DoubleVariable
Hox: DoubleVariable
Hpr: DoubleVariable
Hpr1: DoubleVariable
IDENTIFIER: StringVariable
IMPLEX_CONTACT: BoolVariable
IMPOSED_ANGULAR_VELOCITY_X: IntegerVariable
IMPOSED_ANGULAR_VELOCITY_X_VALUE: DoubleVariable
IMPOSED_ANGULAR_VELOCITY_Y: IntegerVariable
IMPOSED_ANGULAR_VELOCITY_Y_VALUE: DoubleVariable
IMPOSED_ANGULAR_VELOCITY_Z: IntegerVariable
IMPOSED_ANGULAR_VELOCITY_Z_VALUE: DoubleVariable
IMPOSED_PRESSURE: IntegerVariable
IMPOSED_VELOCITY_X: IntegerVariable
IMPOSED_VELOCITY_X_VALUE: DoubleVariable
IMPOSED_VELOCITY_Y: IntegerVariable
IMPOSED_VELOCITY_Y_VALUE: DoubleVariable
IMPOSED_VELOCITY_Z: IntegerVariable
IMPOSED_VELOCITY_Z_VALUE: DoubleVariable
INCIDENT_RADIATION_FUNCTION: DoubleVariable
INERTIA: MatrixVariable
INFINITY_HARDENING_MODULUS: DoubleVariable
INFO: FillCommunicatorEchoLevel
INITIAL_DEFORMATION_GRADIENT_MATRIX: MatrixVariable
INITIAL_PENALTY: DoubleVariable
INITIAL_SHEAR_MODULUS: DoubleVariable
INITIAL_STRAIN: VectorVariable
INITIAL_STRAIN_VECTOR: VectorVariable
INITIAL_STRESS_VECTOR: VectorVariable
INIT_DRAG_FORCE: DoubleVariable
INI_NEIGHBOURS_IDS: IntegerVectorVariable
INLET: Flags
INSIDE: Flags
INSITU_STRESS: VectorVariable
INTEGRATION_COORDINATES: Array1DVariable3
INTEGRATION_COORDINATES_X: DoubleVariable
INTEGRATION_COORDINATES_Y: DoubleVariable
INTEGRATION_COORDINATES_Z: DoubleVariable
INTEGRATION_WEIGHT: DoubleVariable
INTERACTION: Flags
INTERFACE: Flags
INTERNAL_ENERGY: DoubleVariable
INTERNAL_FORCE: Array1DVariable3
INTERNAL_FORCES_VECTOR: VectorVariable
INTERNAL_FORCE_X: DoubleVariable
INTERNAL_FORCE_Y: DoubleVariable
INTERNAL_FORCE_Z: DoubleVariable
INTERNAL_FRICTION_ANGLE: DoubleVariable
INTERNAL_VARIABLES: VectorVariable
INTERVAL_END_TIME: DoubleVariable
ISOLATED: Flags
ISOTROPIC_HARDENING_MODULUS: DoubleVariable
IS_AIR_EXIT: DoubleVariable
IS_BOUNDARY: DoubleVariable
IS_BURN: DoubleVariable
IS_DIVIDED: DoubleVariable
IS_DRIPPING: DoubleVariable
IS_DUPLICATED: BoolVariable
IS_EROSIONABLE: DoubleVariable
IS_ESCAPED: BoolVariable
IS_FLUID: DoubleVariable
IS_FREE_SURFACE: DoubleVariable
IS_GRAVITY_FILLING: IntegerVariable
IS_INLET: DoubleVariable
IS_INTERFACE: DoubleVariable
IS_JACK_LINK: IntegerVariable
IS_LAGRANGIAN_INLET: DoubleVariable
IS_PERMANENT: DoubleVariable
IS_POROUS: DoubleVariable
IS_RESTARTED: BoolVariable
IS_SLIP: DoubleVariable
IS_SOLIDIFIED: IntegerVariable
IS_STRUCTURE: DoubleVariable
IS_VISITED: DoubleVariable
IS_WALL: DoubleVariable
IS_WATER: DoubleVariable
IS_WATER_ELEMENT: DoubleVariable
JC_PARAMETER_A: DoubleVariable
JC_PARAMETER_B: DoubleVariable
JC_PARAMETER_C: DoubleVariable
JC_PARAMETER_K: DoubleVariable
JC_PARAMETER_m: DoubleVariable
JC_PARAMETER_n: DoubleVariable
K0: DoubleVariable
KINEMATIC_HARDENING_MODULUS: DoubleVariable
KINEMATIC_VISCOSITY: DoubleVariable
KINETIC_ENERGY: DoubleVariable
KIRCHHOFF_STRESS_TENSOR: MatrixVariable
KIRCHHOFF_STRESS_VECTOR: VectorVariable
LAGRANGE_AIR_PRESSURE: DoubleVariable
LAGRANGE_DISPLACEMENT: Array1DVariable3
LAGRANGE_DISPLACEMENT_X: DoubleVariable
LAGRANGE_DISPLACEMENT_Y: DoubleVariable
LAGRANGE_DISPLACEMENT_Z: DoubleVariable
LAGRANGE_TEMPERATURE: DoubleVariable
LAGRANGE_WATER_PRESSURE: DoubleVariable
LAMBDA: DoubleVariable
LAME_LAMBDA: DoubleVariable
LAME_MU: DoubleVariable
LAPLACIAN_DIRECTION: IntegerVariable
LARGE_VISCOSITY_COEFFICIENT: DoubleVariable
LAST_TIME_APPENDING: DoubleVariable
LATENT_HEAT: DoubleVariable
LIFT_FORCE: Array1DVariable3
LIFT_FORCE_TYPE: IntegerVariable
LIFT_FORCE_X: DoubleVariable
LIFT_FORCE_Y: DoubleVariable
LIFT_FORCE_Z: DoubleVariable
LIMITER_COEFFICIENT: DoubleVariable
LINEAR_MOMENTUM: Array1DVariable3
LINEAR_MOMENTUM_X: DoubleVariable
LINEAR_MOMENTUM_Y: DoubleVariable
LINEAR_MOMENTUM_Z: DoubleVariable
LIN_DARCY_COEF: DoubleVariable
LOAD_LABELS: VectorVariable
LOAD_MESHES: VectorVariable
LOAD_RESTART: IntegerVariable
LOCAL_AXES_MATRIX: MatrixVariable
LOCAL_AXIS_1: Array1DVariable3
LOCAL_AXIS_1_X: DoubleVariable
LOCAL_AXIS_1_Y: DoubleVariable
LOCAL_AXIS_1_Z: DoubleVariable
LOCAL_AXIS_2: Array1DVariable3
LOCAL_AXIS_2_X: DoubleVariable
LOCAL_AXIS_2_Y: DoubleVariable
LOCAL_AXIS_2_Z: DoubleVariable
LOCAL_AXIS_3: Array1DVariable3
LOCAL_AXIS_3_X: DoubleVariable
LOCAL_AXIS_3_Y: DoubleVariable
LOCAL_AXIS_3_Z: DoubleVariable
LOCAL_CONSTITUTIVE_MATRIX: MatrixVariable
LOCAL_INERTIA_TENSOR: MatrixVariable
LOCAL_TANGENT: Array1DVariable3
LOCAL_TANGENT_MATRIX: MatrixVariable
LOCAL_TANGENT_X: DoubleVariable
LOCAL_TANGENT_Y: DoubleVariable
LOCAL_TANGENT_Z: DoubleVariable
M: DoubleVariable
MAGNUS_FORCE_TYPE: IntegerVariable
MANUALLY_IMPOSED_DRAG_LAW_OPTION: IntegerVariable
MAPPER_SCALAR_PROJECTION_RHS: DoubleVariable
MAPPER_VECTOR_PROJECTION_RHS: Array1DVariable3
MAPPER_VECTOR_PROJECTION_RHS_X: DoubleVariable
MAPPER_VECTOR_PROJECTION_RHS_Y: DoubleVariable
MAPPER_VECTOR_PROJECTION_RHS_Z: DoubleVariable
MARKER: Flags
MARKER_LABELS: VectorVariable
MARKER_MESHES: VectorVariable
MASS: Array1DVariable3
MASS_X: DoubleVariable
MASS_Y: DoubleVariable
MASS_Z: DoubleVariable
MASTER: Flags
MATERIAL_ACCELERATION: Array1DVariable3
MATERIAL_ACCELERATION_X: DoubleVariable
MATERIAL_ACCELERATION_Y: DoubleVariable
MATERIAL_ACCELERATION_Z: DoubleVariable
MATERIAL_FLUID_ACCEL_PROJECTED: Array1DVariable3
MATERIAL_FLUID_ACCEL_PROJECTED_X: DoubleVariable
MATERIAL_FLUID_ACCEL_PROJECTED_Y: DoubleVariable
MATERIAL_FLUID_ACCEL_PROJECTED_Z: DoubleVariable
MATERIAL_ORIENTATION_DX: Array1DVariable3
MATERIAL_ORIENTATION_DX_X: DoubleVariable
MATERIAL_ORIENTATION_DX_Y: DoubleVariable
MATERIAL_ORIENTATION_DX_Z: DoubleVariable
MATERIAL_ORIENTATION_DY: Array1DVariable3
MATERIAL_ORIENTATION_DY_X: DoubleVariable
MATERIAL_ORIENTATION_DY_Y: DoubleVariable
MATERIAL_ORIENTATION_DY_Z: DoubleVariable
MATERIAL_ORIENTATION_DZ: Array1DVariable3
MATERIAL_ORIENTATION_DZ_X: DoubleVariable
MATERIAL_ORIENTATION_DZ_Y: DoubleVariable
MATERIAL_ORIENTATION_DZ_Z: DoubleVariable
MATERIAL_PARAMETERS: VectorVariable
MATERIAL_VARIABLE: DoubleVariable
MAX_DT: DoubleVariable
MEAN_HYDRODYNAMIC_REACTION: Array1DVariable3
MEAN_HYDRODYNAMIC_REACTION_X: DoubleVariable
MEAN_HYDRODYNAMIC_REACTION_Y: DoubleVariable
MEAN_HYDRODYNAMIC_REACTION_Z: DoubleVariable
MELD_TEMPERATURE: DoubleVariable
MESH_ACCELERATION: Array1DVariable3
MESH_ACCELERATION_X: DoubleVariable
MESH_ACCELERATION_Y: DoubleVariable
MESH_ACCELERATION_Z: DoubleVariable
MESH_DISPLACEMENT: Array1DVariable3
MESH_DISPLACEMENT_X: DoubleVariable
MESH_DISPLACEMENT_Y: DoubleVariable
MESH_DISPLACEMENT_Z: DoubleVariable
MESH_POISSON_RATIO: DoubleVariable
MESH_REACTION: Array1DVariable3
MESH_REACTION_X: DoubleVariable
MESH_REACTION_Y: DoubleVariable
MESH_REACTION_Z: DoubleVariable
MESH_RHS: Array1DVariable3
MESH_RHS_X: DoubleVariable
MESH_RHS_Y: DoubleVariable
MESH_RHS_Z: DoubleVariable
MESH_VELOCITY: Array1DVariable3
MESH_VELOCITY_X: DoubleVariable
MESH_VELOCITY_Y: DoubleVariable
MESH_VELOCITY_Z: DoubleVariable
MIN_DT: DoubleVariable
MIU: DoubleVariable
MIXTURE_FRACTION: DoubleVariable
MODIFIED: Flags
MOLECULAR_VISCOSITY: DoubleVariable
MOMENT: Array1DVariable3
MOMENTUM: Array1DVariable3
MOMENTUM_CM: Array1DVariable3
MOMENTUM_CM_X: DoubleVariable
MOMENTUM_CM_Y: DoubleVariable
MOMENTUM_CM_Z: DoubleVariable
MOMENTUM_X: DoubleVariable
MOMENTUM_Y: DoubleVariable
MOMENTUM_Z: DoubleVariable
MOMENT_RESIDUAL: Array1DVariable3
MOMENT_RESIDUAL_X: DoubleVariable
MOMENT_RESIDUAL_Y: DoubleVariable
MOMENT_RESIDUAL_Z: DoubleVariable
MOMENT_X: DoubleVariable
MOMENT_Y: DoubleVariable
MOMENT_Z: DoubleVariable
MPI_BOUNDARY: Flags
MU: DoubleVariable
NAGATIVE_DISTANCE: DoubleVariable
NEGATIVE_FACE_PRESSURE: DoubleVariable
NEGATIVE_MAPPED_VECTOR_VARIABLE: Array1DVariable3
NEGATIVE_MAPPED_VECTOR_VARIABLE_X: DoubleVariable
NEGATIVE_MAPPED_VECTOR_VARIABLE_Y: DoubleVariable
NEGATIVE_MAPPED_VECTOR_VARIABLE_Z: DoubleVariable
NEIGHBOURS_IDS: IntegerVectorVariable
NEIGHBOURS_IDS_DOUBLE: VectorVariable
NET_INPUT_MATERIAL: DoubleVariable
NEWMARK_BETA: DoubleVariable
NEWMARK_GAMMA: DoubleVariable
NEW_ENTITY: Flags
NL_ITERATION_NUMBER: IntegerVariable
NODAL_AREA: DoubleVariable
NODAL_ERROR: DoubleVariable
NODAL_ERROR_COMPONENTS: Array1DVariable3
NODAL_ERROR_COMPONENTS_X: DoubleVariable
NODAL_ERROR_COMPONENTS_Y: DoubleVariable
NODAL_ERROR_COMPONENTS_Z: DoubleVariable
NODAL_H: DoubleVariable
NODAL_INERTIA_TENSOR: Array1DVariable6
NODAL_INERTIA_TENSOR_XX: DoubleVariable
NODAL_INERTIA_TENSOR_XY: DoubleVariable
NODAL_INERTIA_TENSOR_XZ: DoubleVariable
NODAL_INERTIA_TENSOR_YY: DoubleVariable
NODAL_INERTIA_TENSOR_YZ: DoubleVariable
NODAL_INERTIA_TENSOR_ZZ: DoubleVariable
NODAL_MASS: DoubleVariable
NODAL_MAUX: DoubleVariable
NODAL_PAUX: DoubleVariable
NODAL_SWITCH: DoubleVariable
NODAL_VAUX: Array1DVariable3
NODAL_VAUX_X: DoubleVariable
NODAL_VAUX_Y: DoubleVariable
NODAL_VAUX_Z: DoubleVariable
NODAL_VOLUME: DoubleVariable
NODE_PROPERTY_ID: IntegerVariable
NONLIN_DARCY_COEF: DoubleVariable
NON_NEWTONIAN_OPTION: IntegerVariable
NORMAL: Array1DVariable3
NORMAL_COMPRESSION_SLOPE: DoubleVariable
NORMAL_CONTACT_STRESS: DoubleVariable
NORMAL_SENSITIVITY: DoubleVariable
NORMAL_SHAPE_DERIVATIVE: MatrixVariable
NORMAL_STRESS: VectorVariable
NORMAL_TO_WALL: Array1DVariable3
NORMAL_TO_WALL_X: DoubleVariable
NORMAL_TO_WALL_Y: DoubleVariable
NORMAL_TO_WALL_Z: DoubleVariable
NORMAL_X: DoubleVariable
NORMAL_Y: DoubleVariable
NORMAL_Z: DoubleVariable
NORM_ISOCHORIC_STRESS: DoubleVariable
NO_PRINTING: FillCommunicatorEchoLevel
NUMBER_OF_CYCLES: IntegerVariable
NUMBER_OF_INIT_BASSET_STEPS: IntegerVariable
NUMBER_OF_NEIGHBOUR_ELEMENTS: DoubleVariable
OLD_ENTITY: Flags
OLD_NEIGHBOURS_IDS: IntegerVectorVariable
OLD_RELAXED_DISPLACEMENT: Array1DVariable3
OLD_RELAXED_DISPLACEMENT_X: DoubleVariable
OLD_RELAXED_DISPLACEMENT_Y: DoubleVariable
OLD_RELAXED_DISPLACEMENT_Z: DoubleVariable
OLD_RELAXED_SCALAR: DoubleVariable
OLD_RELAXED_SCALAR_TRACTION: DoubleVariable
OLD_RELAXED_TRACTION: Array1DVariable3
OLD_RELAXED_TRACTION_X: DoubleVariable
OLD_RELAXED_TRACTION_Y: DoubleVariable
OLD_RELAXED_TRACTION_Z: DoubleVariable
ORIENTATION: DoubleQuaternionVariable
OSS_SWITCH: IntegerVariable
OUTLET: Flags
OVER_CONSOLIDATION_RATIO: DoubleVariable
PARAMETER_2D_COORDINATES: Array1DVariable3
PARAMETER_2D_COORDINATES_X: DoubleVariable
PARAMETER_2D_COORDINATES_Y: DoubleVariable
PARAMETER_2D_COORDINATES_Z: DoubleVariable
PARTICLE_MASS: DoubleVariable
PARTICLE_MATERIAL: IntegerVariable
PARTICLE_RADIUS: DoubleVariable
PARTICLE_ROTATE_SPRING_FAILURE_TYPE: VectorVariable
PARTICLE_SPHERICITY: DoubleVariable
PARTICLE_VEL_FILTERED: Array1DVariable3
PARTICLE_VEL_FILTERED_X: DoubleVariable
PARTICLE_VEL_FILTERED_Y: DoubleVariable
PARTICLE_VEL_FILTERED_Z: DoubleVariable
PARTITION_INDEX: IntegerVariable
PARTITION_MASK: IntegerVariable
PENALTY: VectorVariable
PENALTY_COEFFICIENT: DoubleVariable
PERIODIC: Flags
PERIODIC_PAIR_INDEX: IntegerVariable
PERMEABILITY: MatrixVariable
PERMEABILITY_AIR: DoubleVariable
PERMEABILITY_WATER: DoubleVariable
PHASE_FRACTION: DoubleVariable
PHASE_FRACTION_GRADIENT: Array1DVariable3
PHASE_FRACTION_GRADIENT_X: DoubleVariable
PHASE_FRACTION_GRADIENT_Y: DoubleVariable
PHASE_FRACTION_GRADIENT_Z: DoubleVariable
PHASE_FRACTION_RATE: DoubleVariable
PK2_STRESS_TENSOR: MatrixVariable
PK2_STRESS_VECTOR: VectorVariable
PLASTIC_DISSIPATION: DoubleVariable
PLASTIC_STRAIN: DoubleVariable
PLASTIC_STRAIN_RATE: DoubleVariable
POISSON_RATIO: DoubleVariable
POISSON_RATIO_XY: DoubleVariable
POISSON_RATIO_XZ: DoubleVariable
POISSON_RATIO_YZ: DoubleVariable
POROSITY: DoubleVariable
POSETIVE_DISTANCE: DoubleVariable
POSITIVE_FACE_PRESSURE: DoubleVariable
POSITIVE_MAPPED_VECTOR_VARIABLE: Array1DVariable3
POSITIVE_MAPPED_VECTOR_VARIABLE_X: DoubleVariable
POSITIVE_MAPPED_VECTOR_VARIABLE_Y: DoubleVariable
POSITIVE_MAPPED_VECTOR_VARIABLE_Z: DoubleVariable
POWER_LAW_K: DoubleVariable
POWER_LAW_N: DoubleVariable
POWER_LAW_TOLERANCE: DoubleVariable
PRESSURE: DoubleVariable
PRESSUREAUX: DoubleVariable
PRESSURE_COEFFICIENT: DoubleVariable
PRESSURE_GRADIENT: Array1DVariable3
PRESSURE_GRADIENT_X: DoubleVariable
PRESSURE_GRADIENT_Y: DoubleVariable
PRESSURE_GRADIENT_Z: DoubleVariable
PRESSURE_GRAD_PROJECTED: Array1DVariable3
PRESSURE_GRAD_PROJECTED_X: DoubleVariable
PRESSURE_GRAD_PROJECTED_Y: DoubleVariable
PRESSURE_GRAD_PROJECTED_Z: DoubleVariable
PRESSURE_OLD_IT: DoubleVariable
PRESS_PROJ: Array1DVariable3
PRESS_PROJ_X: DoubleVariable
PRESS_PROJ_Y: DoubleVariable
PRESS_PROJ_Z: DoubleVariable
PREVIOUS_DELTA_TIME: DoubleVariable
PRE_CONSOLIDATION_STRESS: DoubleVariable
PRE_EXP_DIFFUSION_COEFFICIENT: DoubleVariable
PRINTED_RESTART_STEP: IntegerVariable
PRINTED_STEP: IntegerVariable
PR_ART_VISC: DoubleVariable
QUADRATURE_ORDER: IntegerVariable
QUASI_STATIC_ANALYSIS: IntegerVariable
RADIATION_SETTINGS: RadiationSettingsVariable
RADIATIVE_INTENSITY: DoubleVariable
RADIATIVE_INTENSITY_1: DoubleVariable
RADIATIVE_INTENSITY_10: DoubleVariable
RADIATIVE_INTENSITY_11: DoubleVariable
RADIATIVE_INTENSITY_12: DoubleVariable
RADIATIVE_INTENSITY_13: DoubleVariable
RADIATIVE_INTENSITY_14: DoubleVariable
RADIATIVE_INTENSITY_15: DoubleVariable
RADIATIVE_INTENSITY_16: DoubleVariable
RADIATIVE_INTENSITY_17: DoubleVariable
RADIATIVE_INTENSITY_18: DoubleVariable
RADIATIVE_INTENSITY_19: DoubleVariable
RADIATIVE_INTENSITY_2: DoubleVariable
RADIATIVE_INTENSITY_20: DoubleVariable
RADIATIVE_INTENSITY_21: DoubleVariable
RADIATIVE_INTENSITY_22: DoubleVariable
RADIATIVE_INTENSITY_23: DoubleVariable
RADIATIVE_INTENSITY_24: DoubleVariable
RADIATIVE_INTENSITY_3: DoubleVariable
RADIATIVE_INTENSITY_4: DoubleVariable
RADIATIVE_INTENSITY_5: DoubleVariable
RADIATIVE_INTENSITY_6: DoubleVariable
RADIATIVE_INTENSITY_7: DoubleVariable
RADIATIVE_INTENSITY_8: DoubleVariable
RADIATIVE_INTENSITY_9: DoubleVariable
RADIUS: DoubleVariable
REACTION: Array1DVariable3
REACTION_AIR_PRESSURE: DoubleVariable
REACTION_FLUX: DoubleVariable
REACTION_MOMENT: Array1DVariable3
REACTION_MOMENT_X: DoubleVariable
REACTION_MOMENT_Y: DoubleVariable
REACTION_MOMENT_Z: DoubleVariable
REACTION_WATER_PRESSURE: DoubleVariable
REACTION_X: DoubleVariable
REACTION_Y: DoubleVariable
REACTION_Z: DoubleVariable
RECOVERED_STRESS: VectorVariable
REFERENCE_CONDUCTIVITY: DoubleVariable
REFERENCE_HARDENING_MODULUS: DoubleVariable
REFERENCE_TEMPERATURE: DoubleVariable
REFINEMENT_LEVEL: IntegerVariable
REF_ID: IntegerVariable
RELAXATION_TIME: DoubleVariable
RELAXED_ACCELERATION: Array1DVariable3
RELAXED_ACCELERATION_X: DoubleVariable
RELAXED_ACCELERATION_Y: DoubleVariable
RELAXED_ACCELERATION_Z: DoubleVariable
RELAXED_DISPLACEMENT: Array1DVariable3
RELAXED_DISPLACEMENT_X: DoubleVariable
RELAXED_DISPLACEMENT_Y: DoubleVariable
RELAXED_DISPLACEMENT_Z: DoubleVariable
RELAXED_SCALAR: DoubleVariable
RELAXED_SCALAR_TRACTION: DoubleVariable
RELAXED_TRACTION: Array1DVariable3
RELAXED_TRACTION_X: DoubleVariable
RELAXED_TRACTION_Y: DoubleVariable
RELAXED_TRACTION_Z: DoubleVariable
RESIDUAL_NORM: DoubleVariable
RESIDUAL_STRENGTH: DoubleVariable
RESIDUAL_VECTOR: VectorVariable
REYNOLDS_NUMBER: DoubleVariable
RHS: Array1DVariable3
RHS_AIR: DoubleVariable
RHS_WATER: DoubleVariable
RHS_X: DoubleVariable
RHS_Y: DoubleVariable
RHS_Z: DoubleVariable
RIGID: Flags
RIGID_BODY_ID: IntegerVariable
ROTATION: Array1DVariable3
ROTATION_CENTER: Array1DVariable3
ROTATION_CENTER_X: DoubleVariable
ROTATION_CENTER_Y: DoubleVariable
ROTATION_CENTER_Z: DoubleVariable
ROTATION_X: DoubleVariable
ROTATION_Y: DoubleVariable
ROTATION_Z: DoubleVariable
RUNGE_KUTTA_STEP: IntegerVariable
SATURATION: DoubleVariable
SCALAR_INTERFACE_RESIDUAL: DoubleVariable
SCALAR_LAGRANGE_MULTIPLIER: DoubleVariable
SCALAR_PROJECTED: DoubleVariable
SCALAR_TRACTION_INTERFACE_RESIDUAL: DoubleVariable
SCALE: IntegerVariable
SCALE_FACTOR: DoubleVariable
SEARCH_RADIUS: DoubleVariable
SEARCH_RADIUS_INCREMENT: DoubleVariable
SEARCH_RADIUS_INCREMENT_FOR_WALLS: DoubleVariable
SECOND_SATURATION_PARAM: DoubleVariable
SEEPAGE_DRAG: Array1DVariable3
SEEPAGE_DRAG_X: DoubleVariable
SEEPAGE_DRAG_Y: DoubleVariable
SEEPAGE_DRAG_Z: DoubleVariable
SELECTED: Flags
SERIALIZER_NO_TRACE: SerializerTraceType
SERIALIZER_TRACE_ALL: SerializerTraceType
SERIALIZER_TRACE_ERROR: SerializerTraceType
SHAPE_FUNCTIONS_GRADIENT_MATRIX: MatrixVariable
SHAPE_FUNCTIONS_VECTOR: VectorVariable
SHAPE_SENSITIVITY: Array1DVariable3
SHAPE_SENSITIVITY_X: DoubleVariable
SHAPE_SENSITIVITY_Y: DoubleVariable
SHAPE_SENSITIVITY_Z: DoubleVariable
SHEAR_MODULUS: DoubleVariable
SHEAR_MODULUS_GAMMA12: DoubleVariable
SHEAR_MODULUS_GAMMA12_2: DoubleVariable
SHEAR_MODULUS_GAMMA12_3: DoubleVariable
SHEAR_MODULUS_GAMMA12_4: DoubleVariable
SHEAR_MODULUS_XY: DoubleVariable
SHEAR_MODULUS_XZ: DoubleVariable
SHEAR_MODULUS_YZ: DoubleVariable
SHEAR_RATE_PROJECTED: DoubleVariable
SINTERING_START_TEMPERATURE: DoubleVariable
SLAVE: Flags
SLIP: Flags
SLIP_VELOCITY: Array1DVariable3
SLIP_VELOCITY_X: DoubleVariable
SLIP_VELOCITY_Y: DoubleVariable
SLIP_VELOCITY_Z: DoubleVariable
SOFTENING_SLOPE: DoubleVariable
SOLID: Flags
SOUND_VELOCITY: DoubleVariable
SPACE_DIMENSION: IntegerVariable
SPECIFIC_HEAT: DoubleVariable
SPLIT_ELEMENT: BoolVariable
SPLIT_NODAL: BoolVariable
STABILIZATION_FACTOR: DoubleVariable
START_TIME: DoubleVariable
STATIONARY: IntegerVariable
STEFAN_BOLTZMANN_CONSTANT: DoubleVariable
STEP: IntegerVariable
STRAIN: VectorVariable
STRAIN_ENERGY: DoubleVariable
STRENGTH_RATIO: DoubleVariable
STRESSES: VectorVariable
STRUCTURE: Flags
STRUCTURE_VELOCITY: Array1DVariable3
STRUCTURE_VELOCITY_X: DoubleVariable
STRUCTURE_VELOCITY_Y: DoubleVariable
STRUCTURE_VELOCITY_Z: DoubleVariable
SURFACE_ENERGY: DoubleVariable
SWELLING_SLOPE: DoubleVariable
SWITCH_TEMPERATURE: DoubleVariable
StrainMeasure_Deformation_Gradient: StrainMeasure
StrainMeasure_GreenLagrange: StrainMeasure
StrainMeasure_Hencky_Material: StrainMeasure
StrainMeasure_Hencky_Spatial: StrainMeasure
StrainMeasure_Infinitesimal: StrainMeasure
StrainMeasure_Left_CauchyGreen: StrainMeasure
StrainMeasure_Right_CauchyGreen: StrainMeasure
StressMeasure_Cauchy: StressMeasure
StressMeasure_Kirchhoff: StressMeasure
StressMeasure_PK1: StressMeasure
StressMeasure_PK2: StressMeasure
TANGENTIAL_CONTACT_STRESS: DoubleVariable
TANGENTIAL_STRESS: VectorVariable
TANGENT_ETA: Array1DVariable3
TANGENT_ETA_X: DoubleVariable
TANGENT_ETA_Y: DoubleVariable
TANGENT_ETA_Z: DoubleVariable
TANGENT_FACTOR: DoubleVariable
TANGENT_XI: Array1DVariable3
TANGENT_XI_X: DoubleVariable
TANGENT_XI_Y: DoubleVariable
TANGENT_XI_Z: DoubleVariable
TAU: DoubleVariable
TC: DoubleVariable
TEMPERATURE: DoubleVariable
TEMPERATURE_GRADIENT: Array1DVariable3
TEMPERATURE_GRADIENT_X: DoubleVariable
TEMPERATURE_GRADIENT_Y: DoubleVariable
TEMPERATURE_GRADIENT_Z: DoubleVariable
TEMPERATURE_OLD_IT: DoubleVariable
TEMP_CONV_PROJ: DoubleVariable
THAWONE: DoubleVariable
THAWTWO: DoubleVariable
THERMAL: Flags
THERMAL_EXPANSION_COEFFICIENT: DoubleVariable
THICKNESS: DoubleVariable
TIME: DoubleVariable
TIME_AVERAGED_ARRAY_3: Array1DVariable3
TIME_AVERAGED_ARRAY_3_X: DoubleVariable
TIME_AVERAGED_ARRAY_3_Y: DoubleVariable
TIME_AVERAGED_ARRAY_3_Z: DoubleVariable
TIME_AVERAGED_DOUBLE: DoubleVariable
TIME_INTEGRATION_THETA: DoubleVariable
TIME_STEPS: IntegerVariable
TIME_STEPS_PER_QUADRATURE_STEP: IntegerVariable
TORQUE: Array1DVariable3
TORQUE_X: DoubleVariable
TORQUE_Y: DoubleVariable
TORQUE_Z: DoubleVariable
TOTAL_ENERGY: DoubleVariable
TOTAL_FORCES: Array1DVariable3
TOTAL_FORCES_X: DoubleVariable
TOTAL_FORCES_Y: DoubleVariable
TOTAL_FORCES_Z: DoubleVariable
TO_ERASE: Flags
TO_REFINE: Flags
TO_SPLIT: Flags
TRACTION_INTERFACE_RESIDUAL: Array1DVariable3
TRACTION_INTERFACE_RESIDUAL_X: DoubleVariable
TRACTION_INTERFACE_RESIDUAL_Y: DoubleVariable
TRACTION_INTERFACE_RESIDUAL_Z: DoubleVariable
TURBULENT_VISCOSITY: DoubleVariable
UPDATE_SENSITIVITIES: BoolVariable
VARIATIONAL_REDISTANCE_COEFFICIENT_FIRST: DoubleVariable
VARIATIONAL_REDISTANCE_COEFFICIENT_SECOND: DoubleVariable
VAUX_EQ_TRACTION: Array1DVariable3
VAUX_EQ_TRACTION_X: DoubleVariable
VAUX_EQ_TRACTION_Y: DoubleVariable
VAUX_EQ_TRACTION_Z: DoubleVariable
VECTOR_LAGRANGE_MULTIPLIER: Array1DVariable3
VECTOR_LAGRANGE_MULTIPLIER_X: DoubleVariable
VECTOR_LAGRANGE_MULTIPLIER_Y: DoubleVariable
VECTOR_LAGRANGE_MULTIPLIER_Z: DoubleVariable
VECTOR_PROJECTED: Array1DVariable3
VECTOR_PROJECTED_X: DoubleVariable
VECTOR_PROJECTED_Y: DoubleVariable
VECTOR_PROJECTED_Z: DoubleVariable
VELOCITY: Array1DVariable3
VELOCITY_COMPONENT_GRADIENT: Array1DVariable3
VELOCITY_COMPONENT_GRADIENT_X: DoubleVariable
VELOCITY_COMPONENT_GRADIENT_Y: DoubleVariable
VELOCITY_COMPONENT_GRADIENT_Z: DoubleVariable
VELOCITY_LAPLACIAN: Array1DVariable3
VELOCITY_LAPLACIAN_RATE: Array1DVariable3
VELOCITY_LAPLACIAN_RATE_X: DoubleVariable
VELOCITY_LAPLACIAN_RATE_Y: DoubleVariable
VELOCITY_LAPLACIAN_RATE_Z: DoubleVariable
VELOCITY_LAPLACIAN_X: DoubleVariable
VELOCITY_LAPLACIAN_Y: DoubleVariable
VELOCITY_LAPLACIAN_Z: DoubleVariable
VELOCITY_OLD: Array1DVariable3
VELOCITY_OLD_OLD: Array1DVariable3
VELOCITY_OLD_OLD_X: DoubleVariable
VELOCITY_OLD_OLD_Y: DoubleVariable
VELOCITY_OLD_OLD_Z: DoubleVariable
VELOCITY_OLD_X: DoubleVariable
VELOCITY_OLD_Y: DoubleVariable
VELOCITY_OLD_Z: DoubleVariable
VELOCITY_PERIOD: DoubleVariable
VELOCITY_X: DoubleVariable
VELOCITY_X_GRADIENT: Array1DVariable3
VELOCITY_X_GRADIENT_X: DoubleVariable
VELOCITY_X_GRADIENT_Y: DoubleVariable
VELOCITY_X_GRADIENT_Z: DoubleVariable
VELOCITY_Y: DoubleVariable
VELOCITY_Y_GRADIENT: Array1DVariable3
VELOCITY_Y_GRADIENT_X: DoubleVariable
VELOCITY_Y_GRADIENT_Y: DoubleVariable
VELOCITY_Y_GRADIENT_Z: DoubleVariable
VELOCITY_Z: DoubleVariable
VELOCITY_Z_GRADIENT: Array1DVariable3
VELOCITY_Z_GRADIENT_X: DoubleVariable
VELOCITY_Z_GRADIENT_Y: DoubleVariable
VELOCITY_Z_GRADIENT_Z: DoubleVariable
VEL_ART_VISC: DoubleVariable
VIRTUAL_MASS_FORCE: Array1DVariable3
VIRTUAL_MASS_FORCE_TYPE: IntegerVariable
VIRTUAL_MASS_FORCE_X: DoubleVariable
VIRTUAL_MASS_FORCE_Y: DoubleVariable
VIRTUAL_MASS_FORCE_Z: DoubleVariable
VISCOSITY: DoubleVariable
VISCOSITY_AIR: DoubleVariable
VISCOSITY_WATER: DoubleVariable
VISITED: Flags
VOLUMETRIC_STRAIN: DoubleVariable
VOLUME_ACCELERATION: Array1DVariable3
VOLUME_ACCELERATION_X: DoubleVariable
VOLUME_ACCELERATION_Y: DoubleVariable
VOLUME_ACCELERATION_Z: DoubleVariable
VORTICITY: Array1DVariable3
VORTICITY_X: DoubleVariable
VORTICITY_Y: DoubleVariable
VORTICITY_Z: DoubleVariable
WALL: Flags
WATER_PRESSURE: DoubleVariable
WATER_PRESSURE_ACCELERATION: DoubleVariable
WATER_SOUND_VELOCITY: DoubleVariable
WEIGHT_FATHER_NODES: DoubleVariable
WET_VOLUME: DoubleVariable
Y: Array1DVariable3
Y1: DoubleVariable
Y2: DoubleVariable
YCH4: DoubleVariable
YCO2: DoubleVariable
YF: DoubleVariable
YH2O: DoubleVariable
YI: DoubleVariable
YIELD_STRESS: DoubleVariable
YN2: DoubleVariable
YO: DoubleVariable
YO2: DoubleVariable
YOUNG_MODULUS: DoubleVariable
YOUNG_MODULUS_X: DoubleVariable
YOUNG_MODULUS_Y: DoubleVariable
YOUNG_MODULUS_Z: DoubleVariable
YP: DoubleVariable
Y_WALL: DoubleVariable
Y_X: DoubleVariable
Y_Y: DoubleVariable
Y_Z: DoubleVariable
Yfuel: DoubleVariable
Yox: DoubleVariable
Ypr: DoubleVariable
a: DoubleVariable
b: DoubleVariable
rhoD: DoubleVariable
xi: DoubleVariable
xi_c: Array1DVariable3
xi_c_X: DoubleVariable
xi_c_Y: DoubleVariable
xi_c_Z: DoubleVariable

class AMGCLCoarseningType:
    __members__: ClassVar[dict] = ...  # read-only
    AGGREGATION: ClassVar[AMGCLCoarseningType] = ...
    RUGE_STUBEN: ClassVar[AMGCLCoarseningType] = ...
    SA: ClassVar[AMGCLCoarseningType] = ...
    SA_EMIN: ClassVar[AMGCLCoarseningType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class AMGCLIterativeSolverType:
    __members__: ClassVar[dict] = ...  # read-only
    BICGSTAB: ClassVar[AMGCLIterativeSolverType] = ...
    BICGSTAB2: ClassVar[AMGCLIterativeSolverType] = ...
    BICGSTAB_WITH_GMRES_FALLBACK: ClassVar[AMGCLIterativeSolverType] = ...
    CG: ClassVar[AMGCLIterativeSolverType] = ...
    FGMRES: ClassVar[AMGCLIterativeSolverType] = ...
    GMRES: ClassVar[AMGCLIterativeSolverType] = ...
    LGMRES: ClassVar[AMGCLIterativeSolverType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class AMGCLSmoother:
    __members__: ClassVar[dict] = ...  # read-only
    CHEBYSHEV: ClassVar[AMGCLSmoother] = ...
    DAMPED_JACOBI: ClassVar[AMGCLSmoother] = ...
    GAUSS_SEIDEL: ClassVar[AMGCLSmoother] = ...
    ILU0: ClassVar[AMGCLSmoother] = ...
    SPAI0: ClassVar[AMGCLSmoother] = ...
    SPAI1: ClassVar[AMGCLSmoother] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class AMGCLSolver(LinearSolver):
    @overload
    def __init__(self, arg0: AMGCLSmoother, arg1: AMGCLIterativeSolverType, arg2: float, arg3: int, arg4: int, arg5: int) -> None: ...
    @overload
    def __init__(self, arg0: AMGCLSmoother, arg1: AMGCLIterativeSolverType, arg2: AMGCLCoarseningType, arg3: float, arg4: int, arg5: int, arg6: int, arg7: bool) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...
    def GetResidualNorm(self) -> float: ...

class AMGCL_NS_Solver(LinearSolver):
    def __init__(self, arg0) -> None: ...

class Accessor:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def Create() -> Accessor: ...

class ActivationUtilities:
    def __init__(self) -> None: ...
    def ActivateElementsAndConditions(self, arg0: ModelPart, arg1: DoubleVariable, arg2: float, arg3: bool) -> None: ...

class AdaptiveResidualBasedNewtonRaphsonStrategy(ImplicitSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4: int, arg5: int, arg6: bool, arg7: bool, arg8: bool, arg9: float, arg10: float, arg11: int) -> None: ...

class AdjointResponseFunction:
    def __init__(self) -> None: ...
    @overload
    def CalculateFirstDerivativesGradient(self, arg0: Condition, arg1: Matrix, arg2: Vector, arg3: ProcessInfo) -> None: ...
    @overload
    def CalculateFirstDerivativesGradient(self, arg0: Element, arg1: Matrix, arg2: Vector, arg3: ProcessInfo) -> None: ...
    @overload
    def CalculateGradient(self, arg0: Condition, arg1: Matrix, arg2: Vector, arg3: ProcessInfo) -> None: ...
    @overload
    def CalculateGradient(self, arg0: Element, arg1: Matrix, arg2: Vector, arg3: ProcessInfo) -> None: ...
    @overload
    def CalculatePartialSensitivity(self, arg0: Condition, arg1: DoubleVariable, arg2: Matrix, arg3: Vector, arg4: ProcessInfo) -> None: ...
    @overload
    def CalculatePartialSensitivity(self, arg0: Element, arg1: DoubleVariable, arg2: Matrix, arg3: Vector, arg4: ProcessInfo) -> None: ...
    @overload
    def CalculatePartialSensitivity(self, arg0: Condition, arg1: Array1DVariable3, arg2: Matrix, arg3: Vector, arg4: ProcessInfo) -> None: ...
    @overload
    def CalculatePartialSensitivity(self, arg0: Element, arg1: Array1DVariable3, arg2: Matrix, arg3: Vector, arg4: ProcessInfo) -> None: ...
    @overload
    def CalculateSecondDerivativesGradient(self, arg0: Condition, arg1: Matrix, arg2: Vector, arg3: ProcessInfo) -> None: ...
    @overload
    def CalculateSecondDerivativesGradient(self, arg0: Element, arg1: Matrix, arg2: Vector, arg3: ProcessInfo) -> None: ...
    def CalculateValue(self, arg0: ModelPart) -> float: ...
    def FinalizeSolutionStep(self) -> None: ...
    def Initialize(self) -> None: ...
    def InitializeSolutionStep(self) -> None: ...

class AndCriteria(ConvergenceCriteria):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0: ConvergenceCriteria, arg1: ConvergenceCriteria) -> None: ...

class ApplyConstantScalarValueProcess(Process):
    VARIABLE_IS_FIXED: ClassVar[Flags] = ...  # read-only
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: float, arg3: int, arg4: Flags) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: IntegerVariable, arg2: int, arg3: int, arg4: Flags) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: BoolVariable, arg2: bool, arg3: int, arg4: Flags) -> None: ...
    def ExecuteInitialize(self) -> None: ...

class ApplyConstantVectorValueProcess(Process):
    X_COMPONENT_FIXED: ClassVar[Flags] = ...  # read-only
    Y_COMPONENT_FIXED: ClassVar[Flags] = ...  # read-only
    Z_COMPONENT_FIXED: ClassVar[Flags] = ...  # read-only
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: float, arg3: Vector, arg4: int, arg5: Flags) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class ApplyFunctionToNodesUtility:
    def __init__(self, arg0: NodesArray, arg1: GenericFunctionUtility) -> None: ...
    def ApplyFunction(self, arg0: DoubleVariable, arg1: float) -> None: ...
    def ReturnFunction(self, arg0: float) -> list[float]: ...

class ApplyPeriodicConditionProcess(Process):
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...

class ApplyRayCastingInterfaceRecognitionProcess2D(Process):
    def __init__(self, arg0, arg1) -> None: ...

class ApplyRayCastingInterfaceRecognitionProcess3D(Process):
    def __init__(self, arg0, arg1) -> None: ...

class ApplyRayCastingProcess2D(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...

class ApplyRayCastingProcess3D(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...

class ArcLengthStrategy(ResidualBasedNewtonRaphsonStrategy):
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: ConvergenceCriteria, arg3: BuilderAndSolver, arg4) -> None: ...

class Array1DVariable3(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class Array1DVariable4(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class Array1DVariable6(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class Array1DVariable9(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class Array3:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Array3) -> None: ...
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    @overload
    def __init__(self, arg0: Array3) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: float) -> None: ...
    def norm_1(self) -> float: ...
    def norm_2(self) -> float: ...
    def norm_inf(self) -> float: ...
    def __add__(self, arg0: Array3) -> Array3: ...
    def __div__(self, arg0: float) -> Array3: ...
    def __getitem__(self, arg0: int) -> float: ...
    @overload
    def __iadd__(self, arg0: float) -> Array3: ...
    @overload
    def __iadd__(self, arg0: Array3) -> Array3: ...
    def __imul__(self, arg0: float) -> Array3: ...
    @overload
    def __isub__(self, arg0: float) -> Array3: ...
    @overload
    def __isub__(self, arg0: Array3) -> Array3: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: float) -> Array3: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> Array3: ...
    def __rdiv__(self, arg0: float) -> None: ...
    def __rmul__(self, arg0: float) -> Array3: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: Array3) -> None: ...
    def __sub__(self, arg0: Array3) -> Array3: ...
    def __truediv__(self, arg0: float) -> Array3: ...

class Array4:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Array4) -> None: ...
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    @overload
    def __init__(self, arg0: Array4) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: float) -> None: ...
    def norm_1(self) -> float: ...
    def norm_2(self) -> float: ...
    def norm_inf(self) -> float: ...
    def __add__(self, arg0: Array4) -> Array4: ...
    def __div__(self, arg0: float) -> Array4: ...
    def __getitem__(self, arg0: int) -> float: ...
    @overload
    def __iadd__(self, arg0: float) -> Array4: ...
    @overload
    def __iadd__(self, arg0: Array4) -> Array4: ...
    def __imul__(self, arg0: float) -> Array4: ...
    @overload
    def __isub__(self, arg0: float) -> Array4: ...
    @overload
    def __isub__(self, arg0: Array4) -> Array4: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: float) -> Array4: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> Array4: ...
    def __rdiv__(self, arg0: float) -> None: ...
    def __rmul__(self, arg0: float) -> Array4: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: Array4) -> None: ...
    def __sub__(self, arg0: Array4) -> Array4: ...
    def __truediv__(self, arg0: float) -> Array4: ...

class Array6:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Array6) -> None: ...
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    @overload
    def __init__(self, arg0: Array6) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: float) -> None: ...
    def norm_1(self) -> float: ...
    def norm_2(self) -> float: ...
    def norm_inf(self) -> float: ...
    def __add__(self, arg0: Array6) -> Array6: ...
    def __div__(self, arg0: float) -> Array6: ...
    def __getitem__(self, arg0: int) -> float: ...
    @overload
    def __iadd__(self, arg0: float) -> Array6: ...
    @overload
    def __iadd__(self, arg0: Array6) -> Array6: ...
    def __imul__(self, arg0: float) -> Array6: ...
    @overload
    def __isub__(self, arg0: float) -> Array6: ...
    @overload
    def __isub__(self, arg0: Array6) -> Array6: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: float) -> Array6: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> Array6: ...
    def __rdiv__(self, arg0: float) -> None: ...
    def __rmul__(self, arg0: float) -> Array6: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: Array6) -> None: ...
    def __sub__(self, arg0: Array6) -> Array6: ...
    def __truediv__(self, arg0: float) -> Array6: ...

class Array9:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Array9) -> None: ...
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    @overload
    def __init__(self, arg0: Array9) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: float) -> None: ...
    def norm_1(self) -> float: ...
    def norm_2(self) -> float: ...
    def norm_inf(self) -> float: ...
    def __add__(self, arg0: Array9) -> Array9: ...
    def __div__(self, arg0: float) -> Array9: ...
    def __getitem__(self, arg0: int) -> float: ...
    @overload
    def __iadd__(self, arg0: float) -> Array9: ...
    @overload
    def __iadd__(self, arg0: Array9) -> Array9: ...
    def __imul__(self, arg0: float) -> Array9: ...
    @overload
    def __isub__(self, arg0: float) -> Array9: ...
    @overload
    def __isub__(self, arg0: Array9) -> Array9: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: float) -> Array9: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> Array9: ...
    def __rdiv__(self, arg0: float) -> None: ...
    def __rmul__(self, arg0: float) -> Array9: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: Array9) -> None: ...
    def __sub__(self, arg0: Array9) -> Array9: ...
    def __truediv__(self, arg0: float) -> Array9: ...

class AssignMasterSlaveConstraintsToNeighboursUtility:
    def __init__(self, arg0: NodesArray) -> None: ...
    def AssignMasterSlaveConstraintsToNodes(self, arg0: NodesArray, arg1: float, arg2: ModelPart, arg3: list[DoubleVariable], arg4: float) -> None: ...

class AssignScalarFieldHistoricalToNodesProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarFieldToConditionsProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarFieldToElementsProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarFieldToNodesProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarInputHistoricalToNodesProcess(Process):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarInputToConditionsProcess(Process):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarInputToElementsProcess(Process):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarInputToNodesProcess(Process):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarVariableHistoricalToNodesProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarVariableToConditionsProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarVariableToElementsProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarVariableToMasterSlaveConstraintsProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignScalarVariableToNodesProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class AssignUniqueModelPartCollectionTagUtility:
    def __init__(self, arg0: ModelPart) -> None: ...
    def DebugAssignUniqueModelPartCollectionTag(self) -> None: ...
    def GetRecursiveSubModelPart(self, arg0: str) -> ModelPart: ...
    def GetRecursiveSubModelPartNames(self, arg0: str) -> list[str]: ...

class AuxiliarModelPartUtilities:
    def __init__(self, arg0: ModelPart) -> None: ...
    def AddConditionWithNodes(self, arg0: Condition) -> None: ...
    def AddElementWithNodes(self, arg0: Element) -> None: ...
    def CopySubModelPartStructure(self, arg0: ModelPart) -> None: ...
    @overload
    def EnsureModelPartOwnsProperties(self) -> None: ...
    @overload
    def EnsureModelPartOwnsProperties(self, arg0: bool) -> None: ...
    @overload
    def RecursiveEnsureModelPartOwnsProperties(self) -> None: ...
    @overload
    def RecursiveEnsureModelPartOwnsProperties(self, arg0: bool) -> None: ...
    @overload
    def RemoveConditionAndBelongings(self, arg0: int, arg1: Flags) -> None: ...
    @overload
    def RemoveConditionAndBelongings(self, arg0: int, arg1: Flags, arg2: int) -> None: ...
    @overload
    def RemoveConditionAndBelongings(self, arg0: Condition, arg1: Flags) -> None: ...
    @overload
    def RemoveConditionAndBelongings(self, arg0: Condition, arg1: Flags, arg2: int) -> None: ...
    @overload
    def RemoveConditionAndBelongingsFromAllLevels(self, arg0: int, arg1: Flags) -> None: ...
    @overload
    def RemoveConditionAndBelongingsFromAllLevels(self, arg0: int, arg1: Flags, arg2: int) -> None: ...
    @overload
    def RemoveConditionAndBelongingsFromAllLevels(self, arg0: Condition, arg1: Flags) -> None: ...
    @overload
    def RemoveConditionAndBelongingsFromAllLevels(self, arg0: Condition, arg1: Flags, arg2: int) -> None: ...
    def RemoveConditionsAndBelongings(self, arg0: Flags) -> None: ...
    def RemoveConditionsAndBelongingsFromAllLevels(self, arg0: Flags) -> None: ...
    @overload
    def RemoveElementAndBelongings(self, arg0: int, arg1: Flags) -> None: ...
    @overload
    def RemoveElementAndBelongings(self, arg0: int, arg1: Flags, arg2: int) -> None: ...
    @overload
    def RemoveElementAndBelongings(self, arg0: Element, arg1: Flags) -> None: ...
    @overload
    def RemoveElementAndBelongings(self, arg0: Element, arg1: Flags, arg2: int) -> None: ...
    @overload
    def RemoveElementAndBelongingsFromAllLevels(self, arg0: int, arg1: Flags) -> None: ...
    @overload
    def RemoveElementAndBelongingsFromAllLevels(self, arg0: int, arg1: Flags, arg2: int) -> None: ...
    @overload
    def RemoveElementAndBelongingsFromAllLevels(self, arg0: Element, arg1: Flags) -> None: ...
    @overload
    def RemoveElementAndBelongingsFromAllLevels(self, arg0: Element, arg1: Flags, arg2: int) -> None: ...
    def RemoveElementsAndBelongings(self, arg0: Flags) -> None: ...
    def RemoveElementsAndBelongingsFromAllLevels(self, arg0: Flags) -> None: ...
    def RemoveOrphanNodesFromSubModelParts(self) -> None: ...
    def RetrieveConditionsNeighbourConditionsIds(self) -> dict[int, list[int]]: ...
    def RetrieveElementsNeighbourElementsIds(self) -> dict[int, list[int]]: ...

class BICGSTABSolver(IterativeSolver):
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: Preconditioner) -> None: ...
    @overload
    def __init__(self, arg0, arg1: Preconditioner) -> None: ...
    def SetTolerance(self, arg0: float) -> None: ...

class BaseSolvingStrategy:
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool) -> None: ...
    def CalculateOutputData(self) -> None: ...
    def Check(self) -> int: ...
    def Clear(self) -> None: ...
    def Create(self, arg0: ModelPart, arg1) -> BaseSolvingStrategy: ...
    def FinalizeSolutionStep(self) -> None: ...
    def GetDefaultParameters(self, *args, **kwargs): ...
    def GetEchoLevel(self) -> int: ...
    def GetModelPart(self) -> ModelPart: ...
    def GetMoveMeshFlag(self) -> bool: ...
    def GetRebuildLevel(self) -> int: ...
    def GetSolutionVector(self) -> Vector: ...
    def GetSystemMatrix(self) -> CompressedMatrix: ...
    def GetSystemVector(self) -> Vector: ...
    def Info(self) -> str: ...
    def Initialize(self) -> None: ...
    def InitializeSolutionStep(self) -> None: ...
    def IsConverged(self) -> bool: ...
    def MoveMesh(self) -> None: ...
    def MoveMeshFlag(self) -> bool: ...
    def Predict(self) -> None: ...
    def SetEchoLevel(self, arg0: int) -> None: ...
    def SetMoveMeshFlag(self, arg0: bool) -> None: ...
    def SetRebuildLevel(self, arg0: int) -> None: ...
    def Solve(self) -> float: ...
    def SolveSolutionStep(self) -> bool: ...

class BasicGenericFunctionUtility:
    def __init__(self, arg0: str) -> None: ...
    def CallFunction(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float, arg6: float) -> float: ...
    def DependsOnSpace(self) -> bool: ...
    def FunctionBody(self) -> str: ...
    def RotateAndCallFunction(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: float, arg5: float, arg6: float) -> float: ...
    def UseLocalSystem(self) -> bool: ...

class BinBasedFastPointLocator2D:
    def __init__(self, arg0: ModelPart) -> None: ...
    def FindPointOnMesh(self, arg0: Array3) -> tuple[bool, Vector, Element]: ...
    def UpdateSearchDatabase(self) -> None: ...
    def UpdateSearchDatabaseAssignedSize(self, arg0: float) -> None: ...

class BinBasedFastPointLocator3D:
    def __init__(self, arg0: ModelPart) -> None: ...
    def FindPointOnMesh(self, arg0: Array3) -> tuple[bool, Vector, Element]: ...
    def UpdateSearchDatabase(self) -> None: ...
    def UpdateSearchDatabaseAssignedSize(self, arg0: float) -> None: ...

class BinBasedFastPointLocatorConditions2D:
    def __init__(self, arg0: ModelPart) -> None: ...
    def FindPointOnMesh(self, arg0: Array3) -> tuple[bool, Vector, Condition]: ...
    def UpdateSearchDatabase(self) -> None: ...
    def UpdateSearchDatabaseAssignedSize(self, arg0: float) -> None: ...

class BinBasedFastPointLocatorConditions3D:
    def __init__(self, arg0: ModelPart) -> None: ...
    def FindPointOnMesh(self, arg0: Array3) -> tuple[bool, Vector, Condition]: ...
    def UpdateSearchDatabase(self) -> None: ...
    def UpdateSearchDatabaseAssignedSize(self, arg0: float) -> None: ...

class BinBasedNodesInElementLocator2D:
    def __init__(self, arg0: ModelPart) -> None: ...
    def FindNodesInElement(self, *args, **kwargs): ...
    def UpdateSearchDatabase(self) -> None: ...
    def UpdateSearchDatabaseAssignedSize(self, arg0: float) -> None: ...

class BinBasedNodesInElementLocator3D:
    def __init__(self, arg0: ModelPart) -> None: ...
    def FindNodesInElement(self, *args, **kwargs): ...
    def UpdateSearchDatabase(self) -> None: ...
    def UpdateSearchDatabaseAssignedSize(self, arg0: float) -> None: ...

class BodyDistanceCalculationUtils:
    def __init__(self) -> None: ...
    def CalculateDistances2D(self, arg0: ElementsArray, arg1: DoubleVariable, arg2: float) -> None: ...
    def CalculateDistances3D(self, arg0: ElementsArray, arg1: DoubleVariable, arg2: float) -> None: ...

class BodyNormalCalculationUtils:
    def __init__(self) -> None: ...
    def CalculateBodyNormals(self, arg0: ModelPart, arg1: int) -> None: ...

class BoolVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class BoolVector:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: BoolVector) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: bool) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def __getitem__(self, arg0: int) -> bool: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __setitem__(self, arg0: int, arg1: bool) -> None: ...

class BoundingBox:
    @overload
    def __init__(self, arg0: Point, arg1: Point) -> None: ...
    @overload
    def __init__(self, arg0: NodesArray) -> None: ...
    @overload
    def Extend(self, arg0: float) -> None: ...
    @overload
    def Extend(self, arg0: NodesArray) -> None: ...
    def GetMaxPoint(self) -> Point: ...
    def GetMinPoint(self) -> Point: ...
    def GetPoints(self) -> tuple[Point, Point]: ...
    def Set(self, arg0: NodesArray) -> None: ...

class BruteForcePointLocator:
    def __init__(self, arg0: ModelPart) -> None: ...
    def FindCondition(self, arg0: Point, arg1: Vector, arg2: Configuration, arg3: float) -> int: ...
    def FindElement(self, arg0: Point, arg1: Vector, arg2: Configuration, arg3: float) -> int: ...
    def FindNode(self, arg0: Point, arg1: Configuration, arg2: float) -> int: ...

class BuilderAndSolver:
    @overload
    def __init__(self, arg0: LinearSolver) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver) -> None: ...
    def ApplyConstraints(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix, arg3: Vector) -> None: ...
    def ApplyDirichletConditions(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def Build(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix, arg3: Vector) -> None: ...
    def BuildAndSolve(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def BuildAndSolveLinearizedOnPreviousIteration(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix, arg3: Vector, arg4: Vector, arg5: bool) -> None: ...
    def BuildLHS(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix) -> None: ...
    def BuildRHS(self, arg0: Scheme, arg1: ModelPart, arg2: Vector) -> None: ...
    def BuildRHSAndSolve(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def CalculateReactions(self, arg0: Scheme, arg1: ModelPart, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def Check(self, arg0: ModelPart) -> int: ...
    def Clear(self) -> None: ...
    def Create(self, arg0: LinearSolver, arg1) -> BuilderAndSolver: ...
    def FinalizeSolutionStep(self, arg0: ModelPart, arg1: CompressedMatrix, arg2: Vector, arg3: Vector) -> None: ...
    def GetCalculateReactionsFlag(self) -> bool: ...
    def GetDefaultParameters(self, *args, **kwargs): ...
    def GetDofSet(self) -> DofsArrayType: ...
    def GetDofSetIsInitializedFlag(self) -> bool: ...
    def GetEchoLevel(self) -> int: ...
    def GetEquationSystemSize(self) -> int: ...
    def GetReshapeMatrixFlag(self) -> bool: ...
    def Info(self) -> str: ...
    def InitializeSolutionStep(self, arg0: ModelPart, arg1: CompressedMatrix, arg2: Vector, arg3: Vector) -> None: ...
    def ResizeAndInitializeVectors(self, arg0: Scheme, arg1: CompressedMatrix, arg2: Vector, arg3: Vector, arg4: ModelPart) -> None: ...
    def SetCalculateReactionsFlag(self, arg0: bool) -> None: ...
    def SetDofSetIsInitializedFlag(self, arg0: bool) -> None: ...
    def SetEchoLevel(self, arg0: int) -> None: ...
    def SetReshapeMatrixFlag(self, arg0: bool) -> None: ...
    def SetUpDofSet(self, arg0: Scheme, arg1: ModelPart) -> None: ...
    def SetUpSystem(self, arg0: ModelPart) -> None: ...
    def SystemSolve(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...

class CGSolver(IterativeSolver):
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: Preconditioner) -> None: ...
    @overload
    def __init__(self, arg0, arg1: Preconditioner) -> None: ...

class CadJsonInput:
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0, arg1: int) -> None: ...
    def ReadModelPart(self, arg0: ModelPart) -> None: ...

class CalculateDiscontinuousDistanceToSkinProcess2D(Process):
    CALCULATE_ELEMENTAL_EDGE_DISTANCES: ClassVar[Flags] = ...  # read-only
    CALCULATE_ELEMENTAL_EDGE_DISTANCES_EXTRAPOLATED: ClassVar[Flags] = ...  # read-only
    USE_POSITIVE_EPSILON_FOR_ZERO_VALUES: ClassVar[Flags] = ...  # read-only
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Flags) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...

class CalculateDiscontinuousDistanceToSkinProcess3D(Process):
    CALCULATE_ELEMENTAL_EDGE_DISTANCES: ClassVar[Flags] = ...  # read-only
    CALCULATE_ELEMENTAL_EDGE_DISTANCES_EXTRAPOLATED: ClassVar[Flags] = ...  # read-only
    USE_POSITIVE_EPSILON_FOR_ZERO_VALUES: ClassVar[Flags] = ...  # read-only
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Flags) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...

class CalculateDistanceToPathNonHistoricalProcess(Process):
    def __init__(self, arg0, arg1) -> None: ...

class CalculateDistanceToPathProcess(Process):
    def __init__(self, arg0, arg1) -> None: ...

class CalculateDistanceToSkinProcess2D(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...

class CalculateDistanceToSkinProcess3D(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def CalculateEmbeddedVariableFromSkin(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...

class CalculateEmbeddedNodalVariableFromSkinProcessArray(Process):
    def __init__(self, arg0, arg1) -> None: ...

class CalculateEmbeddedNodalVariableFromSkinProcessDouble(Process):
    def __init__(self, arg0, arg1) -> None: ...

class CalculateEmbeddedSignedDistanceTo3DSkinProcess(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: bool) -> None: ...

class CalculateNodalAreaProcess(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: int) -> None: ...

class CalculateNodalDistanceToSkinProcess(Process):
    def __init__(self, arg0, arg1) -> None: ...

class CalculateNonHistoricalNodalAreaProcess(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: int) -> None: ...

class CalculateSignedDistanceTo3DConditionSkinProcess(Process):
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...

class CalculateSignedDistanceTo3DSkinProcess(Process):
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    def GenerateSkinModelPart(self, arg0: ModelPart) -> None: ...
    def MappingPressureToStructure(self, *args, **kwargs): ...

class CheckSameModelPartUsingSkinDistanceProcess2D(Process):
    def __init__(self, arg0, arg1) -> None: ...

class CheckSameModelPartUsingSkinDistanceProcess3D(Process):
    def __init__(self, arg0, arg1) -> None: ...

class CheckSkinProcess(Process):
    def __init__(self, arg0: ModelPart, arg1: Flags) -> None: ...

class CombineModelPartModeler(Modeler):
    def __init__(self, arg0: Model, arg1) -> None: ...

class Communicator:
    def __init__(self) -> None: ...
    @overload
    def AssembleCurrentData(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def AssembleCurrentData(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def AssembleCurrentData(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def AssembleCurrentData(self, arg0: VectorVariable) -> bool: ...
    @overload
    def AssembleCurrentData(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def AssembleNonHistoricalData(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def AssembleNonHistoricalData(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def AssembleNonHistoricalData(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def AssembleNonHistoricalData(self, arg0: VectorVariable) -> bool: ...
    @overload
    def AssembleNonHistoricalData(self, arg0: MatrixVariable) -> bool: ...
    def GetDataCommunicator(self, *args, **kwargs): ...
    def GetNumberOfColors(self) -> int: ...
    @overload
    def GhostMesh(self) -> Mesh: ...
    @overload
    def GhostMesh(self, arg0: int) -> Mesh: ...
    def GlobalNumberOfConditions(self) -> int: ...
    def GlobalNumberOfElements(self) -> int: ...
    def GlobalNumberOfMasterSlaveConstraints(self) -> int: ...
    def GlobalNumberOfNodes(self) -> int: ...
    @overload
    def InterfaceMesh(self) -> Mesh: ...
    @overload
    def InterfaceMesh(self, arg0: int) -> Mesh: ...
    @overload
    def LocalMesh(self) -> Mesh: ...
    @overload
    def LocalMesh(self, arg0: int) -> Mesh: ...
    def MyPID(self) -> int: ...
    def NeighbourIndices(self) -> DenseVectorInt: ...
    def SynchronizeAndNodalFlags(self, arg0: Flags) -> bool: ...
    def SynchronizeDofs(self) -> bool: ...
    def SynchronizeNodalFlags(self) -> bool: ...
    def SynchronizeNodalSolutionStepsData(self) -> bool: ...
    @overload
    def SynchronizeNonHistoricalVariable(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def SynchronizeNonHistoricalVariable(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def SynchronizeNonHistoricalVariable(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def SynchronizeNonHistoricalVariable(self, arg0: VectorVariable) -> bool: ...
    @overload
    def SynchronizeNonHistoricalVariable(self, arg0: MatrixVariable) -> bool: ...
    def SynchronizeOrNodalFlags(self, arg0: Flags) -> bool: ...
    @overload
    def SynchronizeVariable(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def SynchronizeVariable(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def SynchronizeVariable(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def SynchronizeVariable(self, arg0: VectorVariable) -> bool: ...
    @overload
    def SynchronizeVariable(self, arg0: MatrixVariable) -> bool: ...
    def TotalProcesses(self) -> int: ...

class ComplexCompressedMatrix:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ComplexCompressedMatrix) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: CompressedMatrix) -> None: ...
    @overload
    def __init__(self, arg0: ComplexCompressedMatrix) -> None: ...
    def Resize(self, arg0: int, arg1: int) -> None: ...
    def Size1(self) -> int: ...
    def Size2(self) -> int: ...
    def index1_data(self) -> list[int]: ...
    def index2_data(self) -> list[int]: ...
    def value_data(self) -> list[complex]: ...
    def __add__(self, arg0: ComplexCompressedMatrix) -> ComplexCompressedMatrix: ...
    def __getitem__(self, arg0: tuple[int, int]) -> complex: ...
    def __imul__(self, arg0: complex) -> ComplexCompressedMatrix: ...
    def __itruediv__(self, arg0: complex) -> ComplexCompressedMatrix: ...
    def __len__(self) -> int: ...
    @overload
    def __mul__(self, arg0: ComplexCompressedMatrix) -> ComplexCompressedMatrix: ...
    @overload
    def __mul__(self, arg0: complex) -> ComplexCompressedMatrix: ...
    def __setitem__(self, arg0: tuple[int, int], arg1: complex) -> None: ...
    def __sub__(self, arg0: ComplexCompressedMatrix) -> ComplexCompressedMatrix: ...
    def __truediv__(self, arg0: complex) -> ComplexCompressedMatrix: ...

class ComplexDirectSolver(ComplexLinearSolver):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class ComplexLinearSolver:
    def __init__(self) -> None: ...
    def Clear(self) -> None: ...
    def Initialize(self, arg0: ComplexCompressedMatrix, arg1: ComplexVector, arg2: ComplexVector) -> None: ...
    @overload
    def Solve(self, arg0: ComplexCompressedMatrix, arg1: ComplexVector, arg2: ComplexVector) -> bool: ...
    @overload
    def Solve(self, arg0: ComplexCompressedMatrix, arg1: ComplexCompressedMatrix, arg2: ComplexVector, arg3: ComplexMatrix) -> None: ...

class ComplexLinearSolverFactory:
    def __init__(self) -> None: ...
    def Create(self, arg0) -> ComplexLinearSolver: ...
    def Has(self, arg0: str) -> bool: ...

class ComplexMatrix:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ComplexMatrix) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: complex) -> None: ...
    @overload
    def __init__(self, arg0: ComplexMatrix) -> None: ...
    def Resize(self, arg0: int, arg1: int) -> None: ...
    def Size1(self) -> int: ...
    def Size2(self) -> int: ...
    def fill(self, arg0: complex) -> None: ...
    def fill_identity(self) -> None: ...
    def __add__(self, arg0: ComplexMatrix) -> ComplexMatrix: ...
    def __getitem__(self, arg0: tuple[int, int]) -> complex: ...
    def __imul__(self, arg0: complex) -> ComplexMatrix: ...
    def __itruediv__(self, arg0: complex) -> ComplexMatrix: ...
    def __len__(self) -> int: ...
    @overload
    def __mul__(self, arg0: ComplexMatrix) -> ComplexMatrix: ...
    @overload
    def __mul__(self, arg0: complex) -> ComplexMatrix: ...
    @overload
    def __mul__(self, arg0: ComplexVector) -> ComplexVector: ...
    def __setitem__(self, arg0: tuple[int, int], arg1: complex) -> None: ...
    def __sub__(self, arg0: ComplexMatrix) -> ComplexMatrix: ...
    def __truediv__(self, arg0: complex) -> ComplexMatrix: ...

class ComplexSkylineLUSolver(ComplexDirectSolver):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class ComplexVector:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: ComplexVector) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: complex) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    @overload
    def __init__(self, arg0: ComplexVector) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: complex) -> None: ...
    def norm_1(self) -> float: ...
    def norm_2(self) -> float: ...
    def norm_inf(self) -> float: ...
    def __add__(self, arg0: ComplexVector) -> ComplexVector: ...
    def __div__(self, arg0: complex) -> ComplexVector: ...
    def __getitem__(self, arg0: int) -> complex: ...
    @overload
    def __iadd__(self, arg0: complex) -> ComplexVector: ...
    @overload
    def __iadd__(self, arg0: ComplexVector) -> ComplexVector: ...
    def __imul__(self, arg0: complex) -> ComplexVector: ...
    @overload
    def __isub__(self, arg0: complex) -> ComplexVector: ...
    @overload
    def __isub__(self, arg0: ComplexVector) -> ComplexVector: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: complex) -> ComplexVector: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: complex) -> ComplexVector: ...
    def __rdiv__(self, arg0: complex) -> None: ...
    def __rmul__(self, arg0: complex) -> ComplexVector: ...
    @overload
    def __setitem__(self, arg0: int, arg1: complex) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: ComplexVector) -> None: ...
    def __sub__(self, arg0: ComplexVector) -> ComplexVector: ...
    def __truediv__(self, arg0: complex) -> ComplexVector: ...

class CompressedMatrix:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: CompressedMatrix) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: CompressedMatrix) -> None: ...
    def Resize(self, arg0: int, arg1: int) -> None: ...
    def Size1(self) -> int: ...
    def Size2(self) -> int: ...
    def index1_data(self) -> list[int]: ...
    def index2_data(self) -> list[int]: ...
    def value_data(self) -> list[float]: ...
    def __add__(self, arg0: CompressedMatrix) -> CompressedMatrix: ...
    def __getitem__(self, arg0: tuple[int, int]) -> float: ...
    def __imul__(self, arg0: float) -> CompressedMatrix: ...
    def __itruediv__(self, arg0: float) -> CompressedMatrix: ...
    def __len__(self) -> int: ...
    @overload
    def __mul__(self, arg0: CompressedMatrix) -> CompressedMatrix: ...
    @overload
    def __mul__(self, arg0: float) -> CompressedMatrix: ...
    def __setitem__(self, arg0: tuple[int, int], arg1: float) -> None: ...
    def __sub__(self, arg0: CompressedMatrix) -> CompressedMatrix: ...
    def __truediv__(self, arg0: float) -> CompressedMatrix: ...

class ComputeNodalGradientProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNodalGradientProcess2D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNodalGradientProcess3D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNodalGradientProcessComp2D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNodalGradientProcessComp3D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNodalNormalDivergenceProcess(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: DoubleVariable, arg4: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: DoubleVariable, arg4: bool, arg5: bool) -> None: ...

class ComputeNonHistoricalNodalGradientProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNonHistoricalNodalGradientProcess2D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNonHistoricalNodalGradientProcess3D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNonHistoricalNodalGradientProcessComp2D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNonHistoricalNodalGradientProcessComp3D(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: DoubleVariable, arg2: Array1DVariable3, arg3: DoubleVariable, arg4: bool) -> None: ...

class ComputeNonHistoricalNodalNormalDivergenceProcess(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: DoubleVariable, arg4: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: DoubleVariable, arg4: bool, arg5: bool) -> None: ...

class Condition(GeometricalObject):
    Properties: Properties
    def __init__(self, arg0: int) -> None: ...
    @overload
    def Calculate(self, arg0: DoubleVariable, arg1) -> float: ...
    @overload
    def Calculate(self, arg0: Array1DVariable3, arg1) -> Array3: ...
    @overload
    def Calculate(self, arg0: VectorVariable, arg1) -> Vector: ...
    @overload
    def Calculate(self, arg0: MatrixVariable, arg1) -> Matrix: ...
    def CalculateDampingMatrix(self, arg0: Matrix, arg1) -> None: ...
    def CalculateFirstDerivativesLHS(self, arg0: Matrix, arg1) -> None: ...
    def CalculateLocalSystem(self, arg0: Matrix, arg1: Vector, arg2) -> None: ...
    def CalculateLocalVelocityContribution(self, arg0: Matrix, arg1: Vector, arg2) -> None: ...
    def CalculateMassMatrix(self, arg0: Matrix, arg1) -> None: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: BoolVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: IntegerVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: DoubleVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable3, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable4, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable6, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable9, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: VectorVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: MatrixVariable, arg1) -> list: ...
    def CalculateRightHandSide(self, arg0: Vector, arg1) -> None: ...
    def CalculateSecondDerivativesLHS(self, arg0: Matrix, arg1) -> None: ...
    @overload
    def CalculateSensitivityMatrix(self, arg0: DoubleVariable, arg1: Matrix, arg2) -> None: ...
    @overload
    def CalculateSensitivityMatrix(self, arg0: Array1DVariable3, arg1: Matrix, arg2) -> None: ...
    def EquationIdVector(self, arg0) -> list[int]: ...
    def GetDofList(self, arg0) -> list[Dof]: ...
    @overload
    def GetFirstDerivativesVector(self, arg0: Vector) -> None: ...
    @overload
    def GetFirstDerivativesVector(self, arg0: Vector, arg1: int) -> None: ...
    def GetGeometry(self, *args, **kwargs): ...
    def GetNode(self, arg0: int) -> Node: ...
    def GetNodes(self) -> list: ...
    @overload
    def GetSecondDerivativesVector(self, arg0: Vector) -> None: ...
    @overload
    def GetSecondDerivativesVector(self, arg0: Vector, arg1: int) -> None: ...
    def GetSpecifications(self, *args, **kwargs): ...
    @overload
    def GetValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetValue(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def GetValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def GetValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetValue(self, arg0: IntegerVectorVariable) -> DenseVectorInt: ...
    @overload
    def GetValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def GetValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetValue(self, arg0: StringVariable) -> str: ...
    def GetValuesOnIntegrationPoints(self, arg0: VectorVariable, arg1) -> None: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: StringVariable) -> bool: ...
    def Info(self) -> str: ...
    def Initialize(self, arg0) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVectorVariable, arg1: DenseVectorInt) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetValue(self, arg0: StringVariable, arg1: str) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: BoolVariable, arg1: list[bool], arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: IntegerVariable, arg1: list[int], arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: DoubleVariable, arg1: list[float], arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: VectorVariable, arg1: list, arg2: int, arg3) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable3, arg1: list, arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable4, arg1: list, arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable6, arg1: list, arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable9, arg1: list, arg2) -> None: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def __getitem__(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def __getitem__(self, arg0: IntegerVectorVariable) -> DenseVectorInt: ...
    @overload
    def __getitem__(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def __getitem__(self, arg0: IntegerVariable) -> int: ...
    @overload
    def __getitem__(self, arg0: DoubleVariable) -> float: ...
    @overload
    def __getitem__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: StringVariable) -> str: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def __setitem__(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVectorVariable, arg1: DenseVectorInt) -> None: ...
    @overload
    def __setitem__(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def __setitem__(self, arg0: StringVariable, arg1: str) -> None: ...

class ConditionEraseProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...

class ConditionNumberUtility:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1: LinearSolver) -> None: ...
    @overload
    def GetConditionNumber(self, arg0: CompressedMatrix, arg1: LinearSolver, arg2: LinearSolver) -> float: ...
    @overload
    def GetConditionNumber(self, arg0: CompressedMatrix) -> float: ...

class ConditionsArray:
    def __init__(self) -> None: ...
    def append(self, arg0: Condition) -> None: ...
    def clear(self) -> None: ...
    @overload
    def __contains__(self, arg0: Condition) -> bool: ...
    @overload
    def __contains__(self, arg0: int) -> bool: ...
    def __getitem__(self, arg0: int) -> Condition: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    @overload
    def __setitem__(self, arg0: Condition) -> None: ...
    @overload
    def __setitem__(self, arg0: Condition) -> None: ...

class Configuration:
    __members__: ClassVar[dict] = ...  # read-only
    Current: ClassVar[Configuration] = ...
    Initial: ClassVar[Configuration] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class ConnectivityPreserveModeler(Modeler):
    def __init__(self) -> None: ...
    @overload
    def GenerateModelPart(self, arg0: ModelPart, arg1: ModelPart, arg2: str, arg3: str) -> None: ...
    @overload
    def GenerateModelPart(self, arg0: ModelPart, arg1: ModelPart, arg2: str) -> None: ...

class ConstitutiveLaw(Flags):
    ANISOTROPIC: ClassVar[Flags] = ...  # read-only
    AXISYMMETRIC_LAW: ClassVar[Flags] = ...  # read-only
    COMPUTE_CONSTITUTIVE_TENSOR: ClassVar[Flags] = ...  # read-only
    COMPUTE_STRAIN_ENERGY: ClassVar[Flags] = ...  # read-only
    COMPUTE_STRESS: ClassVar[Flags] = ...  # read-only
    FINALIZE_MATERIAL_RESPONSE: ClassVar[Flags] = ...  # read-only
    FINITE_STRAINS: ClassVar[Flags] = ...  # read-only
    INCREMENTAL_STRAIN_MEASURE: ClassVar[Flags] = ...  # read-only
    INFINITESIMAL_STRAINS: ClassVar[Flags] = ...  # read-only
    INITIALIZE_MATERIAL_RESPONSE: ClassVar[Flags] = ...  # read-only
    ISOCHORIC_TENSOR_ONLY: ClassVar[Flags] = ...  # read-only
    ISOTROPIC: ClassVar[Flags] = ...  # read-only
    MECHANICAL_RESPONSE_ONLY: ClassVar[Flags] = ...  # read-only
    PLANE_STRAIN_LAW: ClassVar[Flags] = ...  # read-only
    PLANE_STRESS_LAW: ClassVar[Flags] = ...  # read-only
    THERMAL_RESPONSE_ONLY: ClassVar[Flags] = ...  # read-only
    THREE_DIMENSIONAL_LAW: ClassVar[Flags] = ...  # read-only
    USE_ELEMENT_PROVIDED_STRAIN: ClassVar[Flags] = ...  # read-only
    U_P_LAW: ClassVar[Flags] = ...  # read-only
    VOLUMETRIC_TENSOR_ONLY: ClassVar[Flags] = ...  # read-only
    def __init__(self) -> None: ...
    def CalculateMaterialResponse(self, arg0: ConstitutiveLawParameters, arg1: StressMeasure) -> None: ...
    def CalculateMaterialResponseCauchy(self, arg0: ConstitutiveLawParameters) -> None: ...
    def CalculateMaterialResponseKirchhoff(self, arg0: ConstitutiveLawParameters) -> None: ...
    def CalculateMaterialResponsePK1(self, arg0: ConstitutiveLawParameters) -> None: ...
    def CalculateMaterialResponsePK2(self, arg0: ConstitutiveLawParameters) -> None: ...
    @overload
    def CalculateValue(self, arg0: ConstitutiveLawParameters, arg1: BoolVariable, arg2: bool) -> bool: ...
    @overload
    def CalculateValue(self, arg0: ConstitutiveLawParameters, arg1: IntegerVariable, arg2: int) -> int: ...
    @overload
    def CalculateValue(self, arg0: ConstitutiveLawParameters, arg1: DoubleVariable, arg2: float) -> float: ...
    @overload
    def CalculateValue(self, arg0: ConstitutiveLawParameters, arg1: Array1DVariable3, arg2: Array3) -> Array3: ...
    @overload
    def CalculateValue(self, arg0: ConstitutiveLawParameters, arg1: VectorVariable, arg2: Vector) -> Vector: ...
    @overload
    def CalculateValue(self, arg0: ConstitutiveLawParameters, arg1: MatrixVariable, arg2: Matrix) -> Matrix: ...
    def Check(self, arg0: Properties, arg1, arg2: ProcessInfo) -> int: ...
    def Clone(self) -> ConstitutiveLaw: ...
    @overload
    def Create(self, arg0) -> ConstitutiveLaw: ...
    @overload
    def Create(self, arg0, arg1: Properties) -> ConstitutiveLaw: ...
    def FinalizeMaterialResponse(self, arg0: ConstitutiveLawParameters, arg1: StressMeasure) -> None: ...
    def FinalizeMaterialResponseCauchy(self, arg0: ConstitutiveLawParameters) -> None: ...
    def FinalizeMaterialResponseKirchhoff(self, arg0: ConstitutiveLawParameters) -> None: ...
    def FinalizeMaterialResponsePK1(self, arg0: ConstitutiveLawParameters) -> None: ...
    def FinalizeMaterialResponsePK2(self, arg0: ConstitutiveLawParameters) -> None: ...
    def GetLawFeatures(self, arg0: ConstitutiveLawFeatures) -> None: ...
    def GetStrainSize(self) -> int: ...
    def GetStressMeasure(self) -> StressMeasure: ...
    @overload
    def GetValue(self, arg0: BoolVariable, arg1: bool) -> bool: ...
    @overload
    def GetValue(self, arg0: IntegerVariable, arg1: int) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable, arg1: float) -> float: ...
    @overload
    def GetValue(self, arg0: Array1DVariable3, arg1: Array3) -> Array3: ...
    @overload
    def GetValue(self, arg0: VectorVariable, arg1: Vector) -> Vector: ...
    @overload
    def GetValue(self, arg0: MatrixVariable, arg1: Matrix) -> Matrix: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    def InitializeMaterial(self, arg0: Properties, arg1, arg2: Vector) -> None: ...
    def InitializeMaterialResponse(self, arg0: ConstitutiveLawParameters, arg1: StressMeasure) -> None: ...
    def InitializeMaterialResponseCauchy(self, arg0: ConstitutiveLawParameters) -> None: ...
    def InitializeMaterialResponseKirchhoff(self, arg0: ConstitutiveLawParameters) -> None: ...
    def InitializeMaterialResponsePK1(self, arg0: ConstitutiveLawParameters) -> None: ...
    def InitializeMaterialResponsePK2(self, arg0: ConstitutiveLawParameters) -> None: ...
    def IsIncremental(self) -> bool: ...
    def PullBackConstitutiveMatrix(self, arg0: Matrix, arg1: Matrix) -> None: ...
    def PushForwardConstitutiveMatrix(self, arg0: Matrix, arg1: Matrix) -> None: ...
    def ResetMaterial(self, arg0: Properties, arg1, arg2: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int, arg2: ProcessInfo) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float, arg2: ProcessInfo) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3, arg2: ProcessInfo) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector, arg2: ProcessInfo) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix, arg2: ProcessInfo) -> None: ...
    def TransformCauchyStresses(self, arg0: Vector, arg1: Matrix, arg2: float, arg3: StressMeasure) -> Vector: ...
    def TransformKirchhoffStresses(self, arg0: Vector, arg1: Matrix, arg2: float, arg3: StressMeasure) -> Vector: ...
    def TransformPK1Stresses(self, arg0: Vector, arg1: Matrix, arg2: float, arg3: StressMeasure) -> Vector: ...
    def TransformPK2Stresses(self, arg0: Vector, arg1: Matrix, arg2: float, arg3: StressMeasure) -> Vector: ...
    def TransformStrains(self, arg0: Vector, arg1: Matrix, arg2: StrainMeasure, arg3: StrainMeasure) -> Vector: ...
    @overload
    def WorkingSpaceDimension(self) -> int: ...
    @overload
    def WorkingSpaceDimension(self) -> int: ...

class ConstitutiveLawFeatures:
    def __init__(self) -> None: ...
    def GetOptions(self) -> Flags: ...
    def GetSpaceDimension(self) -> int: ...
    def GetStrainMeasures(self) -> list[StrainMeasure]: ...
    def GetStrainSize(self) -> int: ...
    def SetOptions(self, arg0: Flags) -> None: ...
    def SetSpaceDimension(self, arg0: int) -> None: ...
    def SetStrainMeasure(self, arg0: StrainMeasure) -> None: ...
    def SetStrainMeasures(self, arg0: list[StrainMeasure]) -> None: ...
    def SetStrainSize(self, arg0: int) -> None: ...

class ConstitutiveLawParameters:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0, arg1: Properties, arg2: ProcessInfo) -> None: ...
    def CheckAllParameters(self) -> bool: ...
    def CheckInfoMaterialGeometry(self) -> bool: ...
    def CheckMechanicalVariables(self) -> bool: ...
    def CheckShapeFunctions(self) -> bool: ...
    @overload
    def GetConstitutiveMatrix(self) -> Matrix: ...
    @overload
    def GetConstitutiveMatrix(self, arg0: Matrix) -> Matrix: ...
    @overload
    def GetDeformationGradientF(self) -> Matrix: ...
    @overload
    def GetDeformationGradientF(self, arg0: Matrix) -> Matrix: ...
    def GetDeterminantF(self) -> float: ...
    def GetElementGeometry(self, *args, **kwargs): ...
    def GetMaterialProperties(self) -> Properties: ...
    def GetOptions(self) -> Flags: ...
    def GetProcessInfo(self) -> ProcessInfo: ...
    def GetShapeFunctionsValues(self) -> Vector: ...
    @overload
    def GetStrainVector(self) -> Vector: ...
    @overload
    def GetStrainVector(self, arg0: Vector) -> Vector: ...
    @overload
    def GetStressVector(self) -> Vector: ...
    @overload
    def GetStressVector(self, arg0: Vector) -> Vector: ...
    def Reset(self, arg0: Flags) -> None: ...
    def Set(self, arg0: Flags) -> None: ...
    def SetConstitutiveMatrix(self, arg0: Matrix) -> None: ...
    def SetDeformationGradientF(self, arg0: Matrix) -> None: ...
    def SetDeterminantF(self, arg0: float) -> None: ...
    def SetElementGeometry(self, arg0) -> None: ...
    def SetMaterialProperties(self, arg0: Properties) -> None: ...
    def SetOptions(self, arg0: Flags) -> None: ...
    def SetProcessInfo(self, arg0: ProcessInfo) -> None: ...
    def SetShapeFunctionsDerivatives(self, arg0: Matrix) -> None: ...
    def SetShapeFunctionsValues(self, arg0: Vector) -> None: ...
    def SetStrainVector(self, arg0: Vector) -> None: ...
    def SetStressVector(self, arg0: Vector) -> None: ...

class ConstitutuveLawVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class Controller:
    def __init__(self) -> None: ...
    def Check(self) -> int: ...
    def Create(self, model, parameters) -> Controller: ...
    def Evaluate(self) -> bool: ...
    def GetDefaultParameters(self, *args, **kwargs): ...
    def Update(self) -> None: ...

class ConvectionDiffusionSettings:
    def __init__(self) -> None: ...
    def GetConvectionVariable(self) -> Array1DVariable3: ...
    def GetDensityVariable(self) -> DoubleVariable: ...
    def GetDiffusionVariable(self) -> DoubleVariable: ...
    def GetGradientVariable(self) -> Array1DVariable3: ...
    def GetMeshVelocityVariable(self) -> Array1DVariable3: ...
    def GetProjectionVariable(self) -> DoubleVariable: ...
    def GetReactionGradientVariable(self) -> Array1DVariable3: ...
    def GetReactionVariable(self) -> DoubleVariable: ...
    def GetSpecificHeatVariable(self) -> DoubleVariable: ...
    def GetSurfaceSourceVariable(self) -> DoubleVariable: ...
    def GetTransferCoefficientVariable(self) -> DoubleVariable: ...
    def GetUnknownVariable(self) -> DoubleVariable: ...
    def GetVelocityVariable(self) -> Array1DVariable3: ...
    def GetVolumeSourceVariable(self) -> DoubleVariable: ...
    def IsDefinedConvectionVariable(self) -> bool: ...
    def IsDefinedDensityVariable(self) -> bool: ...
    def IsDefinedDiffusionVariable(self) -> bool: ...
    def IsDefinedGradientVariable(self) -> bool: ...
    def IsDefinedMeshVelocityVariable(self) -> bool: ...
    def IsDefinedProjectionVariable(self) -> bool: ...
    def IsDefinedReactionGradientVariable(self) -> bool: ...
    def IsDefinedReactionVariable(self) -> bool: ...
    def IsDefinedSpecificHeatVariable(self) -> bool: ...
    def IsDefinedSurfaceSourceVariable(self) -> bool: ...
    def IsDefinedTransferCoefficientVariable(self) -> bool: ...
    def IsDefinedUnknownVariable(self) -> bool: ...
    def IsDefinedVelocityVariable(self) -> bool: ...
    def IsDefinedVolumeSourceVariable(self) -> bool: ...
    def SetConvectionVariable(self, arg0: Array1DVariable3) -> None: ...
    def SetDensityVariable(self, arg0: DoubleVariable) -> None: ...
    def SetDiffusionVariable(self, arg0: DoubleVariable) -> None: ...
    def SetGradientVariable(self, arg0: Array1DVariable3) -> None: ...
    def SetMeshVelocityVariable(self, arg0: Array1DVariable3) -> None: ...
    def SetProjectionVariable(self, arg0: DoubleVariable) -> None: ...
    def SetReactionGradientVariable(self, arg0: Array1DVariable3) -> None: ...
    def SetReactionVariable(self, arg0: DoubleVariable) -> None: ...
    def SetSpecificHeatVariable(self, arg0: DoubleVariable) -> None: ...
    def SetSurfaceSourceVariable(self, arg0: DoubleVariable) -> None: ...
    def SetTransferCoefficientVariable(self, arg0: DoubleVariable) -> None: ...
    def SetUnknownVariable(self, arg0: DoubleVariable) -> None: ...
    def SetVelocityVariable(self, arg0: Array1DVariable3) -> None: ...
    def SetVolumeSourceVariable(self, arg0: DoubleVariable) -> None: ...

class ConvectionDiffusionSettingsVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class ConvergenceAccelerator:
    def __init__(self, arg0) -> None: ...
    def Finalize(self) -> None: ...
    def FinalizeNonLinearIteration(self) -> None: ...
    def FinalizeSolutionStep(self) -> None: ...
    def GetEchoLevel(self) -> int: ...
    def Initialize(self) -> None: ...
    def InitializeNonLinearIteration(self) -> None: ...
    def InitializeSolutionStep(self) -> None: ...
    def IsBlockNewton(self) -> bool: ...
    def SetEchoLevel(self, arg0: int) -> None: ...
    def UpdateSolution(self, arg0: Vector, arg1: Vector) -> None: ...

class ConvergenceCriteria:
    def __init__(self) -> None: ...
    def Check(self, arg0: ModelPart) -> int: ...
    def Create(self, arg0) -> ConvergenceCriteria: ...
    def FinalizeNonLinearIteration(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def FinalizeSolutionStep(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def GetActualizeRHSflag(self) -> bool: ...
    def GetDefaultParameters(self, *args, **kwargs): ...
    def Info(self) -> str: ...
    def Initialize(self, arg0: ModelPart) -> None: ...
    def InitializeNonLinearIteration(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def InitializeSolutionStep(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def PostCriteria(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> bool: ...
    def PreCriteria(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> bool: ...
    def SetActualizeRHSFlag(self, arg0: bool) -> None: ...
    def SetEchoLevel(self, arg0: int) -> None: ...

class CoordinateTransformationUtils:
    def __init__(self, arg0: int, arg1: int, arg2: Flags) -> None: ...
    @overload
    def ApplySlipCondition(self, arg0: Matrix, arg1: Vector, arg2) -> None: ...
    @overload
    def ApplySlipCondition(self, arg0: Vector, arg1) -> None: ...
    def CalculateRotationOperatorPure(self, arg0: Matrix, arg1: Node) -> None: ...
    def CalculateRotationOperatorPureShapeSensitivities(self, arg0: Matrix, arg1: int, arg2: int, arg3: Node) -> None: ...
    def RecoverVelocities(self, arg0: ModelPart) -> None: ...
    @overload
    def Rotate(self, arg0: Matrix, arg1: Vector, arg2) -> None: ...
    @overload
    def Rotate(self, arg0: Vector, arg1) -> None: ...
    def RotateVelocities(self, arg0: ModelPart) -> None: ...

class CopyPropertiesModeler(Modeler):
    @overload
    def __init__(self, arg0: Model, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...

class CppRegistry:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def GetItem(arg0: str) -> RegistryItem: ...
    @staticmethod
    def GetModeler(arg0: str) -> Modeler: ...
    @staticmethod
    def GetOperation(arg0: str) -> Operation: ...
    @staticmethod
    def GetProcess(arg0: str) -> Process: ...
    @staticmethod
    def HasItem(arg0: str) -> bool: ...
    @staticmethod
    def HasItems(arg0: str) -> bool: ...
    @staticmethod
    def HasValue(arg0: str) -> bool: ...
    @staticmethod
    def RemoveItem(arg0: str) -> None: ...
    @staticmethod
    def keys() -> list: ...
    @staticmethod
    def size() -> int: ...

class CreateEntitiesFromGeometriesModeler(Modeler):
    def __init__(self, arg0: Model, arg1) -> None: ...

class CsrMatrix:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DataCommunicator) -> None: ...
    @overload
    def __init__(self, arg0: CsrMatrix) -> None: ...
    @overload
    def __init__(self, arg0: SparseGraph) -> None: ...
    @overload
    def __init__(self, arg0: SparseContiguousRowGraph) -> None: ...
    def ApplyHomogeneousDirichlet(self, arg0: Vector, arg1: float, arg2: Vector) -> None: ...
    @overload
    def Assemble(self, arg0: Matrix, arg1: list[int]) -> None: ...
    @overload
    def Assemble(self, arg0: Matrix, arg1: list[int], arg2: list[int]) -> None: ...
    def AssembleEntry(self, arg0: float, arg1: int, arg2: int) -> None: ...
    def BeginAssemble(self) -> None: ...
    def FinalizeAssemble(self) -> None: ...
    def GetComm(self) -> DataCommunicator: ...
    def SetValue(self, arg0: float) -> None: ...
    def Size1(self) -> int: ...
    def Size2(self) -> int: ...
    def SpMM(self, arg0: CsrMatrix) -> CsrMatrix: ...
    def SpMV(self, arg0: Vector, arg1: Vector) -> None: ...
    def Transpose(self) -> CsrMatrix: ...
    def TransposeSpMV(self, *args, **kwargs): ...
    def copy(self) -> CsrMatrix: ...
    def index1_data(self) -> numpy.ndarray[numpy.uint64]: ...
    def index2_data(self) -> numpy.ndarray[numpy.uint64]: ...
    def nnz(self) -> int: ...
    def size1(self) -> int: ...
    def size2(self) -> int: ...
    def value_data(self) -> numpy.ndarray[numpy.float64]: ...
    def __getitem__(self, arg0: tuple[int, int]) -> float: ...
    def __matmul__(self, arg0: CsrMatrix) -> CsrMatrix: ...
    def __setitem__(self, arg0: tuple[int, int], arg1: float) -> None: ...

class CuttingUtility:
    def __init__(self) -> None: ...
    def AddSkinConditions(self, arg0: ModelPart, arg1: ModelPart, arg2: int) -> None: ...
    def AddVariablesToCutModelPart(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    def FindSmallestEdge(self, arg0: ModelPart) -> None: ...
    def GenerateCut(self, arg0: ModelPart, arg1: ModelPart, arg2: Array3, arg3: Array3, arg4: int, arg5: float) -> None: ...
    def UpdateCutData(self, arg0: ModelPart, arg1: ModelPart) -> None: ...

class DataCommunicator:
    def __init__(self, *args, **kwargs) -> None: ...
    def AllGatherArray3s(self, list_of_Array3s: list[Array3]) -> list[Array3]: ...
    def AllGatherArray4s(self, list_of_Array4s: list[Array4]) -> list[Array4]: ...
    def AllGatherArray6s(self, list_of_Array6s: list[Array6]) -> list[Array6]: ...
    def AllGatherArray9s(self, list_of_Array9s: list[Array9]) -> list[Array9]: ...
    def AllGatherDoubles(self, list_of_Doubles: list[float]) -> list[float]: ...
    def AllGatherInts(self, list_of_Ints: list[int]) -> list[int]: ...
    def AllGatherMatrices(self, list_of_Matrices: list[Matrix]) -> list[Matrix]: ...
    def AllGatherVectors(self, list_of_Vectors: list[Vector]) -> list[Vector]: ...
    def AllGathervArray3s(self, list_of_Array3s: list[Array3]) -> list[list[Array3]]: ...
    def AllGathervArray4s(self, list_of_Array4s: list[Array4]) -> list[list[Array4]]: ...
    def AllGathervArray6s(self, list_of_Array6s: list[Array6]) -> list[list[Array6]]: ...
    def AllGathervArray9s(self, list_of_Array9s: list[Array9]) -> list[list[Array9]]: ...
    def AllGathervDoubles(self, list_of_Doubles: list[float]) -> list[list[float]]: ...
    def AllGathervInts(self, list_of_Ints: list[int]) -> list[list[int]]: ...
    def AllGathervMatrices(self, list_of_Matrices: list[Matrix]) -> list[list[Matrix]]: ...
    def AllGathervVectors(self, list_of_Vectors: list[Vector]) -> list[list[Vector]]: ...
    def Barrier(self) -> None: ...
    @overload
    def Broadcast(self, Int_value: int, source_rank: int) -> int: ...
    @overload
    def Broadcast(self, Double_value: float, source_rank: int) -> float: ...
    @overload
    def Broadcast(self, Array3_value: Array3, source_rank: int) -> Array3: ...
    @overload
    def Broadcast(self, Array4_value: Array4, source_rank: int) -> Array4: ...
    @overload
    def Broadcast(self, Array6_value: Array6, source_rank: int) -> Array6: ...
    @overload
    def Broadcast(self, Array9_value: Array9, source_rank: int) -> Array9: ...
    @overload
    def Broadcast(self, Vector_value: Vector, source_rank: int) -> Vector: ...
    @overload
    def Broadcast(self, Matrix_value: Matrix, source_rank: int) -> Matrix: ...
    @overload
    def Broadcast(self, arg0: str, arg1: int) -> str: ...
    def BroadcastArray3s(self, list_of_Array3s: list[Array3], source_rank: int) -> list[Array3]: ...
    def BroadcastArray4s(self, list_of_Array4s: list[Array4], source_rank: int) -> list[Array4]: ...
    def BroadcastArray6s(self, list_of_Array6s: list[Array6], source_rank: int) -> list[Array6]: ...
    def BroadcastArray9s(self, list_of_Array9s: list[Array9], source_rank: int) -> list[Array9]: ...
    def BroadcastDoubles(self, list_of_Doubles: list[float], source_rank: int) -> list[float]: ...
    def BroadcastInts(self, list_of_Ints: list[int], source_rank: int) -> list[int]: ...
    def BroadcastMatrices(self, list_of_Matrices: list[Matrix], source_rank: int) -> list[Matrix]: ...
    def BroadcastStrings(self, arg0: list[str], arg1: int) -> list[str]: ...
    def BroadcastVectors(self, list_of_Vectors: list[Vector], source_rank: int) -> list[Vector]: ...
    def GatherArray3s(self, list_of_Array3s: list[Array3], destination_rank: int) -> list[Array3]: ...
    def GatherArray4s(self, list_of_Array4s: list[Array4], destination_rank: int) -> list[Array4]: ...
    def GatherArray6s(self, list_of_Array6s: list[Array6], destination_rank: int) -> list[Array6]: ...
    def GatherArray9s(self, list_of_Array9s: list[Array9], destination_rank: int) -> list[Array9]: ...
    def GatherDoubles(self, list_of_Doubles: list[float], destination_rank: int) -> list[float]: ...
    def GatherInts(self, list_of_Ints: list[int], destination_rank: int) -> list[int]: ...
    def GatherMatrices(self, list_of_Matrices: list[Matrix], destination_rank: int) -> list[Matrix]: ...
    def GatherVectors(self, list_of_Vectors: list[Vector], destination_rank: int) -> list[Vector]: ...
    def GathervArray3s(self, list_of_Array3s: list[Array3], destination_rank: int) -> list[list[Array3]]: ...
    def GathervArray4s(self, list_of_Array4s: list[Array4], destination_rank: int) -> list[list[Array4]]: ...
    def GathervArray6s(self, list_of_Array6s: list[Array6], destination_rank: int) -> list[list[Array6]]: ...
    def GathervArray9s(self, list_of_Array9s: list[Array9], destination_rank: int) -> list[list[Array9]]: ...
    def GathervDoubles(self, list_of_Doubles: list[float], destination_rank: int) -> list[list[float]]: ...
    def GathervInts(self, list_of_Ints: list[int], destination_rank: int) -> list[list[int]]: ...
    def GathervMatrices(self, list_of_Matrices: list[Matrix], destination_rank: int) -> list[list[Matrix]]: ...
    def GathervVectors(self, list_of_Vectors: list[Vector], destination_rank: int) -> list[list[Vector]]: ...
    @staticmethod
    def GetDefault() -> DataCommunicator: ...
    def IsDefinedOnThisRank(self) -> bool: ...
    def IsDistributed(self) -> bool: ...
    def IsNullOnThisRank(self) -> bool: ...
    @overload
    def Max(self, Int_value: int, root: int) -> int: ...
    @overload
    def Max(self, Double_value: float, root: int) -> float: ...
    @overload
    def Max(self, Array3_value: Array3, root: int) -> Array3: ...
    @overload
    def Max(self, Array4_value: Array4, root: int) -> Array4: ...
    @overload
    def Max(self, Array6_value: Array6, root: int) -> Array6: ...
    @overload
    def Max(self, Array9_value: Array9, root: int) -> Array9: ...
    @overload
    def Max(self, Vector_value: Vector, root: int) -> Vector: ...
    @overload
    def Max(self, Matrix_value: Matrix, root: int) -> Matrix: ...
    @overload
    def MaxAll(self, Int_value: int) -> int: ...
    @overload
    def MaxAll(self, Double_value: float) -> float: ...
    @overload
    def MaxAll(self, Array3_value: Array3) -> Array3: ...
    @overload
    def MaxAll(self, Array4_value: Array4) -> Array4: ...
    @overload
    def MaxAll(self, Array6_value: Array6) -> Array6: ...
    @overload
    def MaxAll(self, Array9_value: Array9) -> Array9: ...
    @overload
    def MaxAll(self, Vector_value: Vector) -> Vector: ...
    @overload
    def MaxAll(self, Matrix_value: Matrix) -> Matrix: ...
    def MaxAllArray3s(self, list_of_Array3s: list[Array3]) -> list[Array3]: ...
    def MaxAllArray4s(self, list_of_Array4s: list[Array4]) -> list[Array4]: ...
    def MaxAllArray6s(self, list_of_Array6s: list[Array6]) -> list[Array6]: ...
    def MaxAllArray9s(self, list_of_Array9s: list[Array9]) -> list[Array9]: ...
    def MaxAllDoubles(self, list_of_Doubles: list[float]) -> list[float]: ...
    def MaxAllInts(self, list_of_Ints: list[int]) -> list[int]: ...
    def MaxAllMatrices(self, list_of_Matrices: list[Matrix]) -> list[Matrix]: ...
    def MaxAllVectors(self, list_of_Vectors: list[Vector]) -> list[Vector]: ...
    def MaxArray3s(self, list_of_Array3s: list[Array3], root: int) -> list[Array3]: ...
    def MaxArray4s(self, list_of_Array4s: list[Array4], root: int) -> list[Array4]: ...
    def MaxArray6s(self, list_of_Array6s: list[Array6], root: int) -> list[Array6]: ...
    def MaxArray9s(self, list_of_Array9s: list[Array9], root: int) -> list[Array9]: ...
    def MaxDoubles(self, list_of_Doubles: list[float], root: int) -> list[float]: ...
    def MaxInts(self, list_of_Ints: list[int], root: int) -> list[int]: ...
    @overload
    def MaxLocAll(self, Int_value: int) -> tuple[int, int]: ...
    @overload
    def MaxLocAll(self, Double_value: float) -> tuple[float, int]: ...
    def MaxMatrices(self, list_of_Matrices: list[Matrix], root: int) -> list[Matrix]: ...
    def MaxVectors(self, list_of_Vectors: list[Vector], root: int) -> list[Vector]: ...
    @overload
    def Min(self, Int_value: int, root: int) -> int: ...
    @overload
    def Min(self, Double_value: float, root: int) -> float: ...
    @overload
    def Min(self, Array3_value: Array3, root: int) -> Array3: ...
    @overload
    def Min(self, Array4_value: Array4, root: int) -> Array4: ...
    @overload
    def Min(self, Array6_value: Array6, root: int) -> Array6: ...
    @overload
    def Min(self, Array9_value: Array9, root: int) -> Array9: ...
    @overload
    def Min(self, Vector_value: Vector, root: int) -> Vector: ...
    @overload
    def Min(self, Matrix_value: Matrix, root: int) -> Matrix: ...
    @overload
    def MinAll(self, Int_value: int) -> int: ...
    @overload
    def MinAll(self, Double_value: float) -> float: ...
    @overload
    def MinAll(self, Array3_value: Array3) -> Array3: ...
    @overload
    def MinAll(self, Array4_value: Array4) -> Array4: ...
    @overload
    def MinAll(self, Array6_value: Array6) -> Array6: ...
    @overload
    def MinAll(self, Array9_value: Array9) -> Array9: ...
    @overload
    def MinAll(self, Vector_value: Vector) -> Vector: ...
    @overload
    def MinAll(self, Matrix_value: Matrix) -> Matrix: ...
    def MinAllArray3s(self, list_of_Array3s: list[Array3]) -> list[Array3]: ...
    def MinAllArray4s(self, list_of_Array4s: list[Array4]) -> list[Array4]: ...
    def MinAllArray6s(self, list_of_Array6s: list[Array6]) -> list[Array6]: ...
    def MinAllArray9s(self, list_of_Array9s: list[Array9]) -> list[Array9]: ...
    def MinAllDoubles(self, list_of_Doubles: list[float]) -> list[float]: ...
    def MinAllInts(self, list_of_Ints: list[int]) -> list[int]: ...
    def MinAllMatrices(self, list_of_Matrices: list[Matrix]) -> list[Matrix]: ...
    def MinAllVectors(self, list_of_Vectors: list[Vector]) -> list[Vector]: ...
    def MinArray3s(self, list_of_Array3s: list[Array3], root: int) -> list[Array3]: ...
    def MinArray4s(self, list_of_Array4s: list[Array4], root: int) -> list[Array4]: ...
    def MinArray6s(self, list_of_Array6s: list[Array6], root: int) -> list[Array6]: ...
    def MinArray9s(self, list_of_Array9s: list[Array9], root: int) -> list[Array9]: ...
    def MinDoubles(self, list_of_Doubles: list[float], root: int) -> list[float]: ...
    def MinInts(self, list_of_Ints: list[int], root: int) -> list[int]: ...
    @overload
    def MinLocAll(self, Int_value: int) -> tuple[int, int]: ...
    @overload
    def MinLocAll(self, Double_value: float) -> tuple[float, int]: ...
    def MinMatrices(self, list_of_Matrices: list[Matrix], root: int) -> list[Matrix]: ...
    def MinVectors(self, list_of_Vectors: list[Vector], root: int) -> list[Vector]: ...
    def Rank(self) -> int: ...
    @overload
    def ScanSum(self, Int_value: int) -> int: ...
    @overload
    def ScanSum(self, Double_value: float) -> float: ...
    @overload
    def ScanSum(self, Array3_value: Array3) -> Array3: ...
    @overload
    def ScanSum(self, Array4_value: Array4) -> Array4: ...
    @overload
    def ScanSum(self, Array6_value: Array6) -> Array6: ...
    @overload
    def ScanSum(self, Array9_value: Array9) -> Array9: ...
    @overload
    def ScanSum(self, Vector_value: Vector) -> Vector: ...
    @overload
    def ScanSum(self, Matrix_value: Matrix) -> Matrix: ...
    def ScanSumArray3s(self, list_of_Array3s: list[Array3]) -> list[Array3]: ...
    def ScanSumArray4s(self, list_of_Array4s: list[Array4]) -> list[Array4]: ...
    def ScanSumArray6s(self, list_of_Array6s: list[Array6]) -> list[Array6]: ...
    def ScanSumArray9s(self, list_of_Array9s: list[Array9]) -> list[Array9]: ...
    def ScanSumDoubles(self, list_of_Doubles: list[float]) -> list[float]: ...
    def ScanSumInts(self, list_of_Ints: list[int]) -> list[int]: ...
    def ScanSumMatrices(self, list_of_Matrices: list[Matrix]) -> list[Matrix]: ...
    def ScanSumVectors(self, list_of_Vectors: list[Vector]) -> list[Vector]: ...
    def ScatterArray3s(self, list_of_Array3s: list[Array3], source_rank: int) -> list[Array3]: ...
    def ScatterArray4s(self, list_of_Array4s: list[Array4], source_rank: int) -> list[Array4]: ...
    def ScatterArray6s(self, list_of_Array6s: list[Array6], source_rank: int) -> list[Array6]: ...
    def ScatterArray9s(self, list_of_Array9s: list[Array9], source_rank: int) -> list[Array9]: ...
    def ScatterDoubles(self, list_of_Doubles: list[float], source_rank: int) -> list[float]: ...
    def ScatterInts(self, list_of_Ints: list[int], source_rank: int) -> list[int]: ...
    def ScatterMatrices(self, list_of_Matrices: list[Matrix], source_rank: int) -> list[Matrix]: ...
    def ScatterVectors(self, list_of_Vectors: list[Vector], source_rank: int) -> list[Vector]: ...
    def ScattervArray3s(self, list_of_Array3s_per_ranks: list[list[Array3]], source_rank: int) -> list[Array3]: ...
    def ScattervArray4s(self, list_of_Array4s_per_ranks: list[list[Array4]], source_rank: int) -> list[Array4]: ...
    def ScattervArray6s(self, list_of_Array6s_per_ranks: list[list[Array6]], source_rank: int) -> list[Array6]: ...
    def ScattervArray9s(self, list_of_Array9s_per_ranks: list[list[Array9]], source_rank: int) -> list[Array9]: ...
    def ScattervDoubles(self, list_of_Doubles_per_ranks: list[list[float]], source_rank: int) -> list[float]: ...
    def ScattervInts(self, list_of_Ints_per_ranks: list[list[int]], source_rank: int) -> list[int]: ...
    def ScattervMatrices(self, list_of_Matrices_per_ranks: list[list[Matrix]], source_rank: int) -> list[Matrix]: ...
    def ScattervVectors(self, list_of_Vectors_per_ranks: list[list[Vector]], source_rank: int) -> list[Vector]: ...
    def SendRecvArray3s(self, list_of_Array3s: list[Array3], send_destination: int, recv_source: int) -> list[Array3]: ...
    def SendRecvArray4s(self, list_of_Array4s: list[Array4], send_destination: int, recv_source: int) -> list[Array4]: ...
    def SendRecvArray6s(self, list_of_Array6s: list[Array6], send_destination: int, recv_source: int) -> list[Array6]: ...
    def SendRecvArray9s(self, list_of_Array9s: list[Array9], send_destination: int, recv_source: int) -> list[Array9]: ...
    def SendRecvDoubles(self, list_of_Doubles: list[float], send_destination: int, recv_source: int) -> list[float]: ...
    def SendRecvInts(self, list_of_Ints: list[int], send_destination: int, recv_source: int) -> list[int]: ...
    def SendRecvMatrices(self, list_of_Matrices: list[Matrix], send_destination: int, recv_source: int) -> list[Matrix]: ...
    def SendRecvString(self, arg0: str, arg1: int, arg2: int) -> str: ...
    def SendRecvVectors(self, list_of_Vectors: list[Vector], send_destination: int, recv_source: int) -> list[Vector]: ...
    def Size(self) -> int: ...
    @overload
    def Sum(self, Int_value: int, root: int) -> int: ...
    @overload
    def Sum(self, Double_value: float, root: int) -> float: ...
    @overload
    def Sum(self, Array3_value: Array3, root: int) -> Array3: ...
    @overload
    def Sum(self, Array4_value: Array4, root: int) -> Array4: ...
    @overload
    def Sum(self, Array6_value: Array6, root: int) -> Array6: ...
    @overload
    def Sum(self, Array9_value: Array9, root: int) -> Array9: ...
    @overload
    def Sum(self, Vector_value: Vector, root: int) -> Vector: ...
    @overload
    def Sum(self, Matrix_value: Matrix, root: int) -> Matrix: ...
    @overload
    def SumAll(self, Int_value: int) -> int: ...
    @overload
    def SumAll(self, Double_value: float) -> float: ...
    @overload
    def SumAll(self, Array3_value: Array3) -> Array3: ...
    @overload
    def SumAll(self, Array4_value: Array4) -> Array4: ...
    @overload
    def SumAll(self, Array6_value: Array6) -> Array6: ...
    @overload
    def SumAll(self, Array9_value: Array9) -> Array9: ...
    @overload
    def SumAll(self, Vector_value: Vector) -> Vector: ...
    @overload
    def SumAll(self, Matrix_value: Matrix) -> Matrix: ...
    def SumAllArray3s(self, list_of_Array3s: list[Array3]) -> list[Array3]: ...
    def SumAllArray4s(self, list_of_Array4s: list[Array4]) -> list[Array4]: ...
    def SumAllArray6s(self, list_of_Array6s: list[Array6]) -> list[Array6]: ...
    def SumAllArray9s(self, list_of_Array9s: list[Array9]) -> list[Array9]: ...
    def SumAllDoubles(self, list_of_Doubles: list[float]) -> list[float]: ...
    def SumAllInts(self, list_of_Ints: list[int]) -> list[int]: ...
    def SumAllMatrices(self, list_of_Matrices: list[Matrix]) -> list[Matrix]: ...
    def SumAllVectors(self, list_of_Vectors: list[Vector]) -> list[Vector]: ...
    def SumArray3s(self, list_of_Array3s: list[Array3], root: int) -> list[Array3]: ...
    def SumArray4s(self, list_of_Array4s: list[Array4], root: int) -> list[Array4]: ...
    def SumArray6s(self, list_of_Array6s: list[Array6], root: int) -> list[Array6]: ...
    def SumArray9s(self, list_of_Array9s: list[Array9], root: int) -> list[Array9]: ...
    def SumDoubles(self, list_of_Doubles: list[float], root: int) -> list[float]: ...
    def SumInts(self, list_of_Ints: list[int], root: int) -> list[int]: ...
    def SumMatrices(self, list_of_Matrices: list[Matrix], root: int) -> list[Matrix]: ...
    def SumVectors(self, list_of_Vectors: list[Vector], root: int) -> list[Vector]: ...
    @overload
    def SynchronizeShape(self, Int_value: int) -> int: ...
    @overload
    def SynchronizeShape(self, Double_value: float) -> float: ...
    @overload
    def SynchronizeShape(self, Array3_value: Array3) -> Array3: ...
    @overload
    def SynchronizeShape(self, Array4_value: Array4) -> Array4: ...
    @overload
    def SynchronizeShape(self, Array6_value: Array6) -> Array6: ...
    @overload
    def SynchronizeShape(self, Array9_value: Array9) -> Array9: ...
    @overload
    def SynchronizeShape(self, Vector_value: Vector) -> Vector: ...
    @overload
    def SynchronizeShape(self, Matrix_value: Matrix) -> Matrix: ...

class DataValueContainer:
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Erase(self, arg0: BoolVariable) -> None: ...
    @overload
    def Erase(self, arg0: IntegerVariable) -> None: ...
    @overload
    def Erase(self, arg0: DoubleVariable) -> None: ...
    @overload
    def Erase(self, arg0: Array1DVariable3) -> None: ...
    @overload
    def Erase(self, arg0: Array1DVariable4) -> None: ...
    @overload
    def Erase(self, arg0: Array1DVariable6) -> None: ...
    @overload
    def Erase(self, arg0: Array1DVariable9) -> None: ...
    @overload
    def Erase(self, arg0: VectorVariable) -> None: ...
    @overload
    def Erase(self, arg0: MatrixVariable) -> None: ...
    @overload
    def Erase(self, arg0: ConvectionDiffusionSettingsVariable) -> None: ...
    @overload
    def Erase(self, arg0: RadiationSettingsVariable) -> None: ...
    @overload
    def Erase(self, arg0: DoubleQuaternionVariable) -> None: ...
    @overload
    def Erase(self, arg0: StringVariable) -> None: ...
    @overload
    def GetValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetValue(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def GetValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def GetValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def GetValue(self, arg0: StringVariable) -> str: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def Has(self, arg0: ConvectionDiffusionSettingsVariable) -> bool: ...
    @overload
    def Has(self, arg0: RadiationSettingsVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def Has(self, arg0: StringVariable) -> bool: ...
    @overload
    def SetValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SetValue(self, arg0: ConvectionDiffusionSettingsVariable, arg1) -> None: ...
    @overload
    def SetValue(self, arg0: RadiationSettingsVariable, arg1) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleQuaternionVariable, arg1) -> None: ...
    @overload
    def SetValue(self, arg0: StringVariable, arg1: str) -> None: ...
    @overload
    def __contains__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def __contains__(self, arg0: VectorVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: ConvectionDiffusionSettingsVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: RadiationSettingsVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: StringVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: IntegerVariable) -> int: ...
    @overload
    def __getitem__(self, arg0: DoubleVariable) -> float: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def __getitem__(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def __getitem__(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def __getitem__(self, arg0: StringVariable) -> str: ...
    def __len__(self) -> int: ...
    @overload
    def __setitem__(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def __setitem__(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def __setitem__(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def __setitem__(self, arg0: ConvectionDiffusionSettingsVariable, arg1) -> None: ...
    @overload
    def __setitem__(self, arg0: RadiationSettingsVariable, arg1) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleQuaternionVariable, arg1) -> None: ...
    @overload
    def __setitem__(self, arg0: StringVariable, arg1: str) -> None: ...

class DeflatedCGSolver(IterativeSolver):
    @overload
    def __init__(self, arg0: float, arg1: bool, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: bool, arg3: int) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: Preconditioner, arg3: bool, arg4: int) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class DeflationUtils:
    def __init__(self) -> None: ...
    def VisualizeAggregates(self, arg0: NodesArray, arg1: DoubleVariable, arg2: int) -> None: ...

class DenseQRDecompositionType:
    def __init__(self, *args, **kwargs) -> None: ...

class DenseSingularValueDecomposition:
    def __init__(self, *args, **kwargs) -> None: ...

class DenseVectorInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DenseVectorInt) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: DenseVectorInt) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: int) -> None: ...
    def norm_1(self) -> int: ...
    def norm_2(self) -> int: ...
    def norm_inf(self) -> int: ...
    def __add__(self, arg0: DenseVectorInt) -> DenseVectorInt: ...
    def __div__(self, arg0: int) -> DenseVectorInt: ...
    def __getitem__(self, arg0: int) -> int: ...
    @overload
    def __iadd__(self, arg0: int) -> DenseVectorInt: ...
    @overload
    def __iadd__(self, arg0: DenseVectorInt) -> DenseVectorInt: ...
    def __imul__(self, arg0: int) -> DenseVectorInt: ...
    @overload
    def __isub__(self, arg0: int) -> DenseVectorInt: ...
    @overload
    def __isub__(self, arg0: DenseVectorInt) -> DenseVectorInt: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: int) -> DenseVectorInt: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: int) -> DenseVectorInt: ...
    def __rdiv__(self, arg0: int) -> None: ...
    def __rmul__(self, arg0: int) -> DenseVectorInt: ...
    @overload
    def __setitem__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: DenseVectorInt) -> None: ...
    def __sub__(self, arg0: DenseVectorInt) -> DenseVectorInt: ...
    def __truediv__(self, arg0: int) -> DenseVectorInt: ...

class DenseVectorUnsignedInt:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: DenseVectorUnsignedInt) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: DenseVectorUnsignedInt) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: int) -> None: ...
    def norm_1(self) -> int: ...
    def norm_2(self) -> int: ...
    def norm_inf(self) -> int: ...
    def __add__(self, arg0: DenseVectorUnsignedInt) -> DenseVectorUnsignedInt: ...
    def __div__(self, arg0: int) -> DenseVectorUnsignedInt: ...
    def __getitem__(self, arg0: int) -> int: ...
    @overload
    def __iadd__(self, arg0: int) -> DenseVectorUnsignedInt: ...
    @overload
    def __iadd__(self, arg0: DenseVectorUnsignedInt) -> DenseVectorUnsignedInt: ...
    def __imul__(self, arg0: int) -> DenseVectorUnsignedInt: ...
    @overload
    def __isub__(self, arg0: int) -> DenseVectorUnsignedInt: ...
    @overload
    def __isub__(self, arg0: DenseVectorUnsignedInt) -> DenseVectorUnsignedInt: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: int) -> DenseVectorUnsignedInt: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: int) -> DenseVectorUnsignedInt: ...
    def __rdiv__(self, arg0: int) -> None: ...
    def __rmul__(self, arg0: int) -> DenseVectorUnsignedInt: ...
    @overload
    def __setitem__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: DenseVectorUnsignedInt) -> None: ...
    def __sub__(self, arg0: DenseVectorUnsignedInt) -> DenseVectorUnsignedInt: ...
    def __truediv__(self, arg0: int) -> DenseVectorUnsignedInt: ...

class DiagonalPreconditioner(Preconditioner):
    def __init__(self) -> None: ...

class DirectSolver(LinearSolver):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class DisplacementCriteria(ConvergenceCriteria):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float) -> None: ...

class Dof:
    EquationId: int
    def __init__(self, *args, **kwargs) -> None: ...
    def Fix(self) -> None: ...
    def Free(self) -> None: ...
    def GetReaction(self) -> VariableData: ...
    def GetSolutionStepValue(self) -> float: ...
    def GetVariable(self) -> VariableData: ...
    def Id(self) -> int: ...
    def IsFixed(self) -> bool: ...
    def SetSolutionStepValue(self, arg0: float) -> float: ...
    def __eq__(self, arg0: Dof) -> bool: ...
    def __ge__(self, arg0: Dof) -> bool: ...
    def __gt__(self, arg0: Dof) -> bool: ...
    def __le__(self, arg0: Dof) -> bool: ...
    def __lt__(self, arg0: Dof) -> bool: ...
    def __ne__(self, arg0: Dof) -> bool: ...

class DofsArrayType:
    def __init__(self) -> None: ...
    def GetEquationIds(self) -> list[int]: ...
    def GetValues(self) -> Vector: ...
    def SetValues(self, arg0: Vector) -> None: ...
    def append(self, arg0: Dof) -> None: ...
    def unique(self) -> None: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...

class DoubleQuaternionVariable:
    def __init__(self, *args, **kwargs) -> None: ...

class DoubleVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class DuplicateMeshModeler(Modeler):
    def __init__(self, arg0: ModelPart) -> None: ...

class EdgeBasedGradientRecoveryProcessArray(Process):
    def __init__(self, *args, **kwargs) -> None: ...

class EdgeBasedGradientRecoveryProcessScalar(Process):
    def __init__(self, *args, **kwargs) -> None: ...

class EdgeSwapping2DModeler(Modeler):
    def __init__(self) -> None: ...
    def ReGenerateMesh(self, arg0: ModelPart) -> None: ...

class Element(GeometricalObject):
    Properties: Properties
    def __init__(self, arg0: int) -> None: ...
    @overload
    def Calculate(self, arg0: DoubleVariable, arg1) -> float: ...
    @overload
    def Calculate(self, arg0: Array1DVariable3, arg1) -> Array3: ...
    @overload
    def Calculate(self, arg0: VectorVariable, arg1) -> Vector: ...
    @overload
    def Calculate(self, arg0: MatrixVariable, arg1) -> Matrix: ...
    def CalculateDampingMatrix(self, arg0: Matrix, arg1) -> None: ...
    def CalculateFirstDerivativesLHS(self, arg0: Matrix, arg1) -> None: ...
    @overload
    def CalculateLocalSystem(self, arg0: Matrix, arg1: Vector, arg2) -> None: ...
    @overload
    def CalculateLocalSystem(self, arg0: Matrix, arg1: Vector, arg2) -> None: ...
    def CalculateLocalVelocityContribution(self, arg0: Matrix, arg1: Vector, arg2) -> None: ...
    def CalculateLumpedMassVector(self, arg0: Vector, arg1) -> None: ...
    def CalculateMassMatrix(self, arg0: Matrix, arg1) -> None: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: BoolVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: IntegerVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: DoubleVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable3, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable4, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable6, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: Array1DVariable9, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: VectorVariable, arg1) -> list: ...
    @overload
    def CalculateOnIntegrationPoints(self, arg0: MatrixVariable, arg1) -> list: ...
    def CalculateRightHandSide(self, arg0: Vector, arg1) -> None: ...
    def CalculateSecondDerivativesLHS(self, arg0: Matrix, arg1) -> None: ...
    @overload
    def CalculateSensitivityMatrix(self, arg0: DoubleVariable, arg1: Matrix, arg2) -> None: ...
    @overload
    def CalculateSensitivityMatrix(self, arg0: Array1DVariable3, arg1: Matrix, arg2) -> None: ...
    def EquationIdVector(self, arg0) -> list[int]: ...
    def GetDofList(self, arg0) -> list[Dof]: ...
    @overload
    def GetFirstDerivativesVector(self, arg0: Vector) -> None: ...
    @overload
    def GetFirstDerivativesVector(self, arg0: Vector, arg1: int) -> None: ...
    def GetGeometry(self, *args, **kwargs): ...
    def GetIntegrationPoints(self) -> list: ...
    def GetNode(self, arg0: int) -> Node: ...
    def GetNodes(self) -> list: ...
    @overload
    def GetSecondDerivativesVector(self, arg0: Vector) -> None: ...
    @overload
    def GetSecondDerivativesVector(self, arg0: Vector, arg1: int) -> None: ...
    def GetSpecifications(self, *args, **kwargs): ...
    @overload
    def GetValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetValue(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def GetValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def GetValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetValue(self, arg0: IntegerVectorVariable) -> DenseVectorInt: ...
    @overload
    def GetValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def GetValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetValue(self, arg0: StringVariable) -> str: ...
    def GetValuesOnIntegrationPoints(self, arg0: VectorVariable, arg1) -> None: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: StringVariable) -> bool: ...
    def Info(self) -> str: ...
    def Initialize(self, arg0) -> None: ...
    def ResetConstitutiveLaw(self) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVectorVariable, arg1: DenseVectorInt) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetValue(self, arg0: StringVariable, arg1: str) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: BoolVariable, arg1: list[bool], arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: IntegerVariable, arg1: list[int], arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: VectorVariable, arg1: list, arg2: int, arg3) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: ConstitutuveLawVariable, arg1: list, arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: DoubleVariable, arg1: list[float], arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable3, arg1: list, arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable4, arg1: list, arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable6, arg1: list, arg2) -> None: ...
    @overload
    def SetValuesOnIntegrationPoints(self, arg0: Array1DVariable9, arg1: list, arg2) -> None: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def __getitem__(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def __getitem__(self, arg0: IntegerVectorVariable) -> DenseVectorInt: ...
    @overload
    def __getitem__(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def __getitem__(self, arg0: IntegerVariable) -> int: ...
    @overload
    def __getitem__(self, arg0: DoubleVariable) -> float: ...
    @overload
    def __getitem__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: StringVariable) -> str: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def __setitem__(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVectorVariable, arg1: DenseVectorInt) -> None: ...
    @overload
    def __setitem__(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def __setitem__(self, arg0: StringVariable, arg1: str) -> None: ...

class ElementEraseProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...

class ElementsArray:
    def __init__(self) -> None: ...
    def append(self, arg0: Element) -> None: ...
    def clear(self) -> None: ...
    @overload
    def __contains__(self, arg0: Element) -> bool: ...
    @overload
    def __contains__(self, arg0: int) -> bool: ...
    def __getitem__(self, arg0: int) -> Element: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    @overload
    def __setitem__(self, arg0: Element) -> None: ...
    @overload
    def __setitem__(self, arg0: Element) -> None: ...

class EliminateIsolatedNodesProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...

class EmbeddedSkinUtility2D:
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: str) -> None: ...
    def GenerateSkin(self) -> None: ...
    @overload
    def InterpolateDiscontinuousMeshVariableToSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: str) -> None: ...
    @overload
    def InterpolateDiscontinuousMeshVariableToSkin(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: str) -> None: ...
    @overload
    def InterpolateMeshVariableToSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def InterpolateMeshVariableToSkin(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...

class EmbeddedSkinUtility3D:
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: str) -> None: ...
    def GenerateSkin(self) -> None: ...
    @overload
    def InterpolateDiscontinuousMeshVariableToSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: str) -> None: ...
    @overload
    def InterpolateDiscontinuousMeshVariableToSkin(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: str) -> None: ...
    @overload
    def InterpolateMeshVariableToSkin(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def InterpolateMeshVariableToSkin(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...

class ExactMortarIntegrationUtility2D2N:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float, arg4: bool) -> None: ...
    def GetConsiderDelaunator(self) -> bool: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: ModelPart, arg1: Condition) -> float: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: Condition, arg1: Condition) -> float: ...
    def TestGetExactIntegration(self, arg0: Condition, arg1: Condition, arg2: Matrix) -> bool: ...

class ExactMortarIntegrationUtility3D3N:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float, arg4: bool) -> None: ...
    def GetConsiderDelaunator(self) -> bool: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: ModelPart, arg1: Condition) -> float: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: Condition, arg1: Condition) -> float: ...
    def TestGetExactIntegration(self, arg0: Condition, arg1: Condition, arg2: Matrix) -> bool: ...
    def TestIODebug(self, arg0: ModelPart, arg1: str) -> None: ...

class ExactMortarIntegrationUtility3D3N4N:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float, arg4: bool) -> None: ...
    def GetConsiderDelaunator(self) -> bool: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: ModelPart, arg1: Condition) -> float: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: Condition, arg1: Condition) -> float: ...
    def TestGetExactIntegration(self, arg0: Condition, arg1: Condition, arg2: Matrix) -> bool: ...
    def TestIODebug(self, arg0: ModelPart, arg1: str) -> None: ...

class ExactMortarIntegrationUtility3D4N:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float, arg4: bool) -> None: ...
    def GetConsiderDelaunator(self) -> bool: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: ModelPart, arg1: Condition) -> float: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: Condition, arg1: Condition) -> float: ...
    def TestGetExactIntegration(self, arg0: Condition, arg1: Condition, arg2: Matrix) -> bool: ...
    def TestIODebug(self, arg0: ModelPart, arg1: str) -> None: ...

class ExactMortarIntegrationUtility3D4N3N:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: int, arg3: float, arg4: bool) -> None: ...
    def GetConsiderDelaunator(self) -> bool: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: ModelPart, arg1: Condition) -> float: ...
    @overload
    def TestGetExactAreaIntegration(self, arg0: Condition, arg1: Condition) -> float: ...
    def TestGetExactIntegration(self, arg0: Condition, arg1: Condition, arg2: Matrix) -> bool: ...
    def TestIODebug(self, arg0: ModelPart, arg1: str) -> None: ...

class ExplicitBuilder:
    def __init__(self) -> None: ...
    def ApplyConstraints(self, arg0: ModelPart) -> None: ...
    def BuildRHS(self, arg0: ModelPart) -> None: ...
    def Check(self, arg0: ModelPart) -> int: ...
    def Clear(self) -> None: ...
    def FinalizeSolutionStep(self, arg0: ModelPart) -> None: ...
    def GetCalculateReactionsFlag(self) -> bool: ...
    def GetDefaultParameters(self, *args, **kwargs): ...
    def GetDofSet(self) -> DofsArrayType: ...
    def GetDofSetIsInitializedFlag(self) -> bool: ...
    def GetEchoLevel(self) -> int: ...
    def GetEquationSystemSize(self) -> int: ...
    def GetLumpedMassMatrixVector(self) -> Vector: ...
    def GetResetDofSetFlag(self) -> bool: ...
    def GetResetLumpedMassVectorFlag(self) -> bool: ...
    def Info(self) -> str: ...
    def Initialize(self, arg0: ModelPart) -> None: ...
    def InitializeSolutionStep(self, arg0: ModelPart) -> None: ...
    def SetCalculateReactionsFlag(self, arg0: bool) -> None: ...
    def SetDofSetIsInitializedFlag(self, arg0: bool) -> None: ...
    def SetEchoLevel(self, arg0: int) -> None: ...
    def SetResetDofSetFlag(self, arg0: bool) -> None: ...
    def SetResetLumpedMassVectorFlag(self, arg0: bool) -> None: ...

class ExplicitBuilderFactory(FactoryBase):
    def __init__(self) -> None: ...
    def Create(self, *args, **kwargs): ...

class ExplicitSolvingStrategy(BaseSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ExplicitBuilder, arg2: bool, arg3: int) -> None: ...

class ExplicitSolvingStrategyBFECC(ExplicitSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ExplicitBuilder, arg2: bool, arg3: int) -> None: ...

class ExplicitSolvingStrategyRungeKutta1(ExplicitSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ExplicitBuilder, arg2: bool, arg3: int) -> None: ...

class ExplicitSolvingStrategyRungeKutta3TVD(ExplicitSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ExplicitBuilder, arg2: bool, arg3: int) -> None: ...

class ExplicitSolvingStrategyRungeKutta4(ExplicitSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ExplicitBuilder, arg2: bool, arg3: int) -> None: ...

class FactoryBase:
    def __init__(self, *args, **kwargs) -> None: ...
    def Has(self, arg0: str) -> bool: ...

class FastTransferBetweenModelPartsProcess(Process):
    class EntityTransfered:
        __members__: ClassVar[dict] = ...  # read-only
        ALL: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        CONDITIONS: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        CONSTRAINTS: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        ELEMENTS: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        NODES: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        NODESANDCONDITIONS: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        NODESANDCONSTRAINTS: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        NODESANDELEMENTS: ClassVar[FastTransferBetweenModelPartsProcess.EntityTransfered] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2, arg3: Flags) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2, arg3: Flags, arg4: bool) -> None: ...

class FileLoggerOutput(LoggerOutput):
    def __init__(self, arg0: str) -> None: ...

class FileNameDataCollector:
    class FileNameData:
        @overload
        def __init__(self) -> None: ...
        @overload
        def __init__(self, arg0: str, arg1: int, arg2: int, arg3: float) -> None: ...
        def Clear(self) -> None: ...
        def GetFileName(self) -> str: ...
        def GetRank(self) -> int: ...
        def GetStep(self) -> int: ...
        def GetTime(self) -> float: ...
        def SetFileName(self, arg0: str) -> None: ...
        def SetRank(self, arg0: int) -> None: ...
        def SetStep(self, arg0: int) -> None: ...
        def SetTime(self, arg0: float) -> None: ...
        def __eq__(self, arg0: FileNameDataCollector.FileNameData) -> bool: ...
    def __init__(self, arg0: ModelPart, arg1: str, arg2: dict[str, str]) -> None: ...
    @staticmethod
    def ExtractFileNamePattern(arg0: str, arg1: list[str]) -> tuple[bool, str]: ...
    def GetFileName(self) -> str: ...
    def GetFileNameDataList(self, *args, **kwargs): ...
    def GetPath(self) -> str: ...
    def GetSortedFileNamesList(self, arg0: list[str]) -> list[str]: ...
    @staticmethod
    def GetSortedListOfFileNameData(arg0, arg1: list[str]) -> list: ...
    def RetrieveFileNameData(self, arg0, arg1: str) -> bool: ...

class FileSerializer(Serializer):
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1) -> None: ...

class FilesystemExtensions:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def MPISafeCreateDirectories(arg0: os.PathLike) -> None: ...

class FillCommunicator:
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    def Execute(self) -> None: ...
    def GetEchoLevel(self) -> FillCommunicatorEchoLevel: ...
    def PrintDebugInfo(self) -> None: ...
    def SetEchoLevel(self, arg0: FillCommunicatorEchoLevel) -> None: ...

class FillCommunicatorEchoLevel:
    __members__: ClassVar[dict] = ...  # read-only
    DEBUG_INFO: ClassVar[FillCommunicatorEchoLevel] = ...
    INFO: ClassVar[FillCommunicatorEchoLevel] = ...
    NO_PRINTING: ClassVar[FillCommunicatorEchoLevel] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class FindConditionsNeighboursProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: int, arg2: int) -> None: ...
    def ClearNeighbours(self) -> None: ...

class FindGlobalNodalConditionNeighboursProcess(Process):
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    def ClearNeighbours(self) -> None: ...
    def GetNeighbourIds(self, arg0: NodesArray) -> dict[int, list[int]]: ...

class FindGlobalNodalElementalNeighboursProcess(Process):
    @overload
    def __init__(self, arg0, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    def ClearNeighbours(self) -> None: ...
    def GetNeighbourIds(self, arg0: NodesArray) -> dict[int, list[int]]: ...

class FindGlobalNodalNeighboursForConditionsProcess(Process):
    @overload
    def __init__(self, arg0, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    def ClearNeighbours(self) -> None: ...
    def GetNeighbourIds(self, arg0: NodesArray) -> dict[int, list[int]]: ...

class FindGlobalNodalNeighboursProcess(Process):
    @overload
    def __init__(self, arg0, arg1: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    def ClearNeighbours(self) -> None: ...
    def GetNeighbourIds(self, arg0: NodesArray) -> dict[int, list[int]]: ...

class FindIntersectedGeometricalObjectsProcess(Process):
    def __init__(self, arg0, arg1) -> None: ...

class FindNodalHNonHistoricalProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...

class FindNodalHProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...

class FindNodalNeighboursProcess(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: int, arg2: int) -> None: ...
    def ClearNeighbours(self) -> None: ...

class Flags:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Flags) -> None: ...
    def AsFalse(self) -> Flags: ...
    def Clear(self) -> None: ...
    def Flip(self, arg0: Flags) -> None: ...
    def Is(self, arg0: Flags) -> bool: ...
    def IsDefined(self, arg0: Flags) -> bool: ...
    def IsNot(self, arg0: Flags) -> bool: ...
    def IsNotDefined(self, arg0: Flags) -> bool: ...
    def Reset(self, arg0: Flags) -> None: ...
    @overload
    def Set(self, arg0: Flags) -> None: ...
    @overload
    def Set(self, arg0: Flags, arg1: bool) -> None: ...
    def __and__(self, arg0: Flags) -> Flags: ...
    def __or__(self, arg0: Flags) -> Flags: ...

class FluxCorrectedTransportConvectionProcess2D(Process):
    def __init__(self, arg0, arg1) -> None: ...

class FluxCorrectedTransportConvectionProcess3D(Process):
    def __init__(self, arg0, arg1) -> None: ...

class ForceAndTorqueUtils:
    def __init__(self) -> None: ...
    @staticmethod
    def ComputeEquivalentForceAndTorque(arg0: ModelPart, arg1: Array3, arg2: Array1DVariable3, arg3: Array1DVariable3) -> list[Array3[2]]: ...
    @staticmethod
    def SumForce(arg0: ModelPart, arg1: Array1DVariable3) -> Array3: ...
    @staticmethod
    def SumForceAndTorque(arg0: ModelPart, arg1: Array1DVariable3, arg2: Array1DVariable3) -> list[Array3[2]]: ...

class FromJSONCheckResultProcess(Process):
    CHECK_ONLY_LOCAL_ENTITIES: ClassVar[Flags] = ...
    CORRECT_RESULT: ClassVar[Flags] = ...
    HISTORICAL_VALUE: ClassVar[Flags] = ...
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    def GetErrorMessage(self) -> str: ...
    def IsCorrectResult(self) -> bool: ...

class GenericFindElementalNeighboursProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...
    def HasNeighboursInFaces(self, arg0: Element) -> list[bool]: ...

class GenericFunctionUtility(BasicGenericFunctionUtility):
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1) -> None: ...

class GeometricalObject(IndexedObject, Flags):
    def __init__(self, arg0: int) -> None: ...
    def IsActive(self) -> bool: ...

class GeometricalObjectsBins:
    @overload
    def __init__(self, arg0: ElementsArray) -> None: ...
    @overload
    def __init__(self, arg0: ConditionsArray) -> None: ...
    @overload
    def __init__(self, arg0: ElementsArray, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: ConditionsArray, arg1: float) -> None: ...
    def GetBoundingBox(self) -> BoundingBox: ...
    def GetCellSizes(self) -> Array3: ...
    def GetNumberOfCells(self, *args, **kwargs): ...
    def GetTotalNumberOfCells(self) -> int: ...
    @overload
    def SearchInRadius(self, arg0: Point, arg1: float) -> list: ...
    @overload
    def SearchInRadius(self, arg0: NodesArray, arg1: float) -> list: ...
    @overload
    def SearchIsInside(self, arg0: Point) -> ResultType: ...
    @overload
    def SearchIsInside(self, arg0: NodesArray) -> list: ...
    @overload
    def SearchNearest(self, arg0: Point) -> ResultType: ...
    @overload
    def SearchNearest(self, arg0: NodesArray) -> list: ...
    @overload
    def SearchNearestInRadius(self, arg0: Point, arg1: float) -> ResultType: ...
    @overload
    def SearchNearestInRadius(self, arg0: NodesArray, arg1: float) -> list: ...

class GeometriesMapType:
    def __init__(self) -> None: ...
    def clear(self) -> None: ...
    @overload
    def __contains__(self, arg0) -> bool: ...
    @overload
    def __contains__(self, arg0: int) -> bool: ...
    def __getitem__(self, index): ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __setitem__(self, arg0: int, arg1) -> None: ...

class GeometriesVector:
    def __init__(self) -> None: ...
    def append(self, arg0: Geometry) -> None: ...
    def __getitem__(self, arg0: int) -> Geometry: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __setitem__(self, arg0: int, arg1: Geometry) -> None: ...

class Geometry:
    BACKGROUND_GEOMETRY_INDEX: ClassVar[int] = ...  # read-only
    Id: int
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    def Area(self) -> float: ...
    @overload
    def Assign(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def Assign(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def Assign(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def Assign(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def Assign(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def Assign(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def Assign(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def Calculate(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Calculate(self, arg0: IntegerVariable) -> int: ...
    @overload
    def Calculate(self, arg0: DoubleVariable) -> float: ...
    @overload
    def Calculate(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def Calculate(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def Calculate(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def Calculate(self, arg0: MatrixVariable) -> Matrix: ...
    def Center(self) -> Point: ...
    def CreateQuadraturePointGeometries(self, *args, **kwargs): ...
    @overload
    def DeterminantOfJacobian(self) -> Vector: ...
    @overload
    def DeterminantOfJacobian(self, arg0: int) -> float: ...
    def DomainSize(self) -> float: ...
    def EdgesNumber(self) -> int: ...
    @staticmethod
    def GenerateId(arg0: str) -> int: ...
    def GetDefaultIntegrationMethod(self) -> GeometryData_IntegrationMethod: ...
    def GetGeometryFamily(self) -> GeometryData_KratosGeometryFamily: ...
    def GetGeometryPart(self, arg0: int) -> Geometry: ...
    def GetGeometryType(self) -> GeometryData_KratosGeometryType: ...
    def GlobalCoordinates(self, arg0: Array3) -> Array3: ...
    def Info(self) -> str: ...
    def IntegrationPointsNumber(self) -> int: ...
    def IsIdGeneratedFromString(self) -> bool: ...
    def IsIdSelfAssigned(self) -> bool: ...
    def Jacobian(self, arg0: int) -> Matrix: ...
    def Length(self) -> float: ...
    def LocalSpaceDimension(self) -> int: ...
    @overload
    def Normal(self) -> Array3: ...
    @overload
    def Normal(self, arg0: Array3) -> Array3: ...
    @overload
    def Normal(self, arg0: int) -> Array3: ...
    def PointsNumber(self) -> int: ...
    def PointsNumberInDirection(self, arg0: int) -> int: ...
    def PolynomialDegree(self, arg0: int) -> int: ...
    @overload
    def SetId(self, arg0: int) -> None: ...
    @overload
    def SetId(self, arg0: str) -> None: ...
    def ShapeFunctionDerivatives(self, arg0: int, arg1: int) -> Matrix: ...
    def ShapeFunctionsValues(self) -> Matrix: ...
    @overload
    def UnitNormal(self) -> Array3: ...
    @overload
    def UnitNormal(self, arg0: Array3) -> Array3: ...
    @overload
    def UnitNormal(self, arg0: int) -> Array3: ...
    def Volume(self) -> float: ...
    def WorkingSpaceDimension(self) -> int: ...
    def __getitem__(self, arg0: int) -> Node: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...

class GeometryData:
    IntegrationMethod: ClassVar[type[GeometryData_IntegrationMethod]] = ...  # read-only
    KratosGeometryFamily: ClassVar[type[GeometryData_KratosGeometryFamily]] = ...  # read-only
    KratosGeometryType: ClassVar[type[GeometryData_KratosGeometryType]] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class GeometryData_IntegrationMethod:
    __members__: ClassVar[dict] = ...  # read-only
    GI_EXTENDED_GAUSS_1: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_EXTENDED_GAUSS_2: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_EXTENDED_GAUSS_3: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_EXTENDED_GAUSS_4: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_EXTENDED_GAUSS_5: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_GAUSS_1: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_GAUSS_2: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_GAUSS_3: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_GAUSS_4: ClassVar[GeometryData_IntegrationMethod] = ...
    GI_GAUSS_5: ClassVar[GeometryData_IntegrationMethod] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class GeometryData_KratosGeometryFamily:
    __members__: ClassVar[dict] = ...  # read-only
    Kratos_Brep: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Composite: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Hexahedra: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Linear: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_NoElement: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Nurbs: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Point: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Prism: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Pyramid: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Quadrature_Geometry: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Quadrilateral: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Tetrahedra: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_Triangle: ClassVar[GeometryData_KratosGeometryFamily] = ...
    Kratos_generic_family: ClassVar[GeometryData_KratosGeometryFamily] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class GeometryData_KratosGeometryType:
    __members__: ClassVar[dict] = ...  # read-only
    Kratos_Brep_Curve: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Brep_Curve_On_Surface: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Brep_Surface: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Coupling_Geometry: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Hexahedra3D20: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Hexahedra3D27: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Hexahedra3D8: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Line2D2: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Line2D3: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Line2D4: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Line2D5: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Line3D2: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Line3D3: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Nurbs_Curve: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Nurbs_Curve_On_Surface: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Nurbs_Surface: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Nurbs_Volume: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Point2D: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Point3D: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Prism3D15: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Prism3D6: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Pyramid3D13: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Pyramid3D5: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrature_Point_Curve_On_Surface_Geometry: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrature_Point_Geometry: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrature_Point_Surface_In_Volume_Geometry: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrilateral2D4: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrilateral2D8: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrilateral2D9: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrilateral3D4: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrilateral3D8: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Quadrilateral3D9: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Sphere3D1: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Surface_In_Nurbs_Volume: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Tetrahedra3D10: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Tetrahedra3D4: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Triangle2D10: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Triangle2D15: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Triangle2D3: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Triangle2D6: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Triangle3D3: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_Triangle3D6: ClassVar[GeometryData_KratosGeometryType] = ...
    Kratos_generic_type: ClassVar[GeometryData_KratosGeometryType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class GeometryTesterUtility:
    def __init__(self) -> None: ...
    def RunTest(self, arg0: Model) -> bool: ...
    def TestHexahedra3D20N(self, arg0: ModelPart) -> bool: ...
    def TestHexahedra3D27N(self, arg0: ModelPart) -> bool: ...
    def TestHexahedra3D8N(self, arg0: ModelPart) -> bool: ...
    def TestHexahedraInterface3D8N(self, arg0: ModelPart) -> bool: ...
    def TestPrismInterface3D6N(self, arg0: ModelPart) -> bool: ...
    def TestQuadrilateralInterface2D4N(self, arg0: ModelPart) -> bool: ...
    def TestTetrahedra3D10N(self, arg0: ModelPart) -> bool: ...
    def TestTetrahedra3D4N(self, arg0: ModelPart) -> bool: ...
    def TestTriangle2D3N(self, arg0: ModelPart) -> bool: ...
    def TestTriangle2D6N(self, arg0: ModelPart) -> bool: ...

class GiDPostMode:
    __members__: ClassVar[dict] = ...  # read-only
    GiD_PostAscii: ClassVar[GiDPostMode] = ...
    GiD_PostAsciiZipped: ClassVar[GiDPostMode] = ...
    GiD_PostBinary: ClassVar[GiDPostMode] = ...
    GiD_PostHDF5: ClassVar[GiDPostMode] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class GidIO(IO):
    @overload
    def __init__(self, arg0: str, arg1: GiD_PostMode, arg2, arg3, arg4) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1: GiD_PostMode, arg2, arg3, arg4, arg5: bool) -> None: ...
    def ChangeOutputName(self, arg0: str) -> None: ...
    def CloseResultFile(self) -> None: ...
    def FinalizeMesh(self) -> None: ...
    def FinalizeResults(self) -> None: ...
    def Flush(self) -> None: ...
    def InitializeMesh(self, arg0: float) -> None: ...
    def InitializeResults(self, arg0: float, arg1: Mesh) -> None: ...
    def PrintFlagsOnGaussPoints(self, arg0: Flags, arg1: str, arg2: ModelPart, arg3: float) -> None: ...
    @overload
    def PrintOnGaussPoints(self, arg0: BoolVariable, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def PrintOnGaussPoints(self, arg0: IntegerVariable, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def PrintOnGaussPoints(self, arg0: DoubleVariable, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def PrintOnGaussPoints(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def PrintOnGaussPoints(self, arg0: VectorVariable, arg1: ModelPart, arg2: float) -> None: ...
    @overload
    def PrintOnGaussPoints(self, arg0: MatrixVariable, arg1: ModelPart, arg2: float) -> None: ...
    def WriteCircleMesh(self, arg0: Mesh) -> None: ...
    def WriteClusterMesh(self, arg0: Mesh) -> None: ...
    def WriteLocalAxesOnNodes(self, arg0: Array1DVariable3, arg1: NodesArray, arg2: float, arg3: int) -> None: ...
    def WriteLocalAxesOnNodesNonHistorical(self, arg0: Array1DVariable3, arg1: NodesArray, arg2: float) -> None: ...
    def WriteMesh(self, arg0: Mesh) -> None: ...
    def WriteNodalFlags(self, arg0: Flags, arg1: str, arg2: NodesArray, arg3: float) -> None: ...
    @overload
    def WriteNodalResults(self, arg0: BoolVariable, arg1: NodesArray, arg2: float, arg3: int) -> None: ...
    @overload
    def WriteNodalResults(self, arg0: DoubleVariable, arg1: NodesArray, arg2: float, arg3: int) -> None: ...
    @overload
    def WriteNodalResults(self, arg0: IntegerVariable, arg1: NodesArray, arg2: float, arg3: int) -> None: ...
    @overload
    def WriteNodalResults(self, arg0: Array1DVariable3, arg1: NodesArray, arg2: float, arg3: int) -> None: ...
    @overload
    def WriteNodalResults(self, arg0: VectorVariable, arg1: NodesArray, arg2: float, arg3: int) -> None: ...
    @overload
    def WriteNodalResults(self, arg0: MatrixVariable, arg1: NodesArray, arg2: float, arg3: int) -> None: ...
    @overload
    def WriteNodalResultsNonHistorical(self, arg0: BoolVariable, arg1: NodesArray, arg2: float) -> None: ...
    @overload
    def WriteNodalResultsNonHistorical(self, arg0: DoubleVariable, arg1: NodesArray, arg2: float) -> None: ...
    @overload
    def WriteNodalResultsNonHistorical(self, arg0: IntegerVariable, arg1: NodesArray, arg2: float) -> None: ...
    @overload
    def WriteNodalResultsNonHistorical(self, arg0: Array1DVariable3, arg1: NodesArray, arg2: float) -> None: ...
    @overload
    def WriteNodalResultsNonHistorical(self, arg0: VectorVariable, arg1: NodesArray, arg2: float) -> None: ...
    @overload
    def WriteNodalResultsNonHistorical(self, arg0: MatrixVariable, arg1: NodesArray, arg2: float) -> None: ...
    def WriteNodeMesh(self, arg0: Mesh) -> None: ...
    def WriteSphereMesh(self, arg0: Mesh) -> None: ...

class GlobalConditionPointer:
    def __init__(self, *args, **kwargs) -> None: ...

class GlobalConditionPointersVector:
    def __init__(self, *args, **kwargs) -> None: ...

class GlobalElementPointer:
    def __init__(self, *args, **kwargs) -> None: ...

class GlobalElementPointersVector:
    def __init__(self, *args, **kwargs) -> None: ...

class GlobalNodePointer:
    def __init__(self, *args, **kwargs) -> None: ...

class GlobalNodePointersVector:
    def __init__(self, *args, **kwargs) -> None: ...

class Hexahedra3D20(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node, arg8: Node, arg9: Node, arg10: Node, arg11: Node, arg12: Node, arg13: Node, arg14: Node, arg15: Node, arg16: Node, arg17: Node, arg18: Node, arg19: Node) -> None: ...

class Hexahedra3D27(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node, arg8: Node, arg9: Node, arg10: Node, arg11: Node, arg12: Node, arg13: Node, arg14: Node, arg15: Node, arg16: Node, arg17: Node, arg18: Node, arg19: Node, arg20: Node, arg21: Node, arg22: Node, arg23: Node, arg24: Node, arg25: Node, arg26: Node) -> None: ...

class Hexahedra3D8(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node) -> None: ...

class ILU0Preconditioner(Preconditioner):
    def __init__(self) -> None: ...

class ILUPreconditioner(Preconditioner):
    def __init__(self) -> None: ...

class IO:
    APPEND: ClassVar[Flags] = ...
    IGNORE_VARIABLES_ERROR: ClassVar[Flags] = ...
    MESH_ONLY: ClassVar[Flags] = ...
    READ: ClassVar[Flags] = ...
    SCIENTIFIC_PRECISION: ClassVar[Flags] = ...
    SKIP_TIMER: ClassVar[Flags] = ...
    WRITE: ClassVar[Flags] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def ReadConditions(self, arg0: NodesArray, arg1: PropertiesArray, arg2: ConditionsArray) -> None: ...
    def ReadElements(self, arg0: NodesArray, arg1: PropertiesArray, arg2: ElementsArray) -> None: ...
    def ReadGeometries(self, arg0: NodesArray, arg1) -> None: ...
    @overload
    def ReadInitialValues(self, arg0: NodesArray, arg1: ElementsArray, arg2: ConditionsArray) -> None: ...
    @overload
    def ReadInitialValues(self, arg0: ModelPart) -> None: ...
    def ReadMesh(self, arg0: Mesh) -> None: ...
    def ReadModelPart(self, arg0: ModelPart) -> None: ...
    def ReadNode(self, arg0: Node) -> bool: ...
    def ReadNodes(self, arg0: NodesArray) -> bool: ...
    @overload
    def ReadProperties(self, arg0: Properties) -> None: ...
    @overload
    def ReadProperties(self, arg0: PropertiesArray) -> None: ...
    def WriteConditions(self, arg0: ConditionsArray) -> None: ...
    def WriteElements(self, arg0: ElementsArray) -> None: ...
    def WriteGeometries(self, arg0) -> None: ...
    def WriteModelPart(self, arg0: ModelPart) -> None: ...
    def WriteNodes(self, arg0: NodesArray) -> None: ...

class ImplicitSolvingStrategy(BaseSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool) -> None: ...
    def GetStiffnessMatrixIsBuilt(self) -> bool: ...
    def SetStiffnessMatrixIsBuilt(self, arg0: bool) -> None: ...

class IndexedObject:
    Id: int
    def __init__(self, *args, **kwargs) -> None: ...

class IntegerVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class IntegerVectorVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class IntegrationValuesExtrapolationToNodesProcess(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class IntervalUtility:
    def __init__(self, arg0) -> None: ...
    def GetIntervalBegin(self) -> float: ...
    def GetIntervalEnd(self) -> float: ...
    def IsInInterval(self, arg0: float) -> bool: ...

class IsosurfacePrinterApplication:
    def __init__(self, arg0: ModelPart) -> None: ...
    def AddScalarVarIsosurface(self, arg0: DoubleVariable, arg1: float) -> None: ...
    def AddScalarVarIsosurfaceAndHigher(self, arg0: DoubleVariable, arg1: float) -> None: ...
    def AddScalarVarIsosurfaceAndLower(self, arg0: DoubleVariable, arg1: float) -> None: ...
    def AddSkinConditions(self) -> None: ...
    def ClearData(self) -> None: ...
    def CreateNodesArray(self) -> NodesArray: ...

class IterativeSolver(LinearSolver):
    def __init__(self) -> None: ...

class Kernel:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: bool) -> None: ...
    @staticmethod
    def BuildType() -> str: ...
    @staticmethod
    def Compiler() -> str: ...
    def GetAllVariableNames(self) -> str: ...
    def GetArray4Variable(self, *args, **kwargs): ...
    def GetArray6Variable(self, *args, **kwargs): ...
    def GetArray9Variable(self, *args, **kwargs): ...
    def GetArrayVariable(self, *args, **kwargs): ...
    @overload
    def GetArrayVariableNames(self) -> str: ...
    @overload
    def GetArrayVariableNames(self) -> str: ...
    @overload
    def GetArrayVariableNames(self) -> str: ...
    @overload
    def GetArrayVariableNames(self) -> str: ...
    def GetBoolVariable(self, *args, **kwargs): ...
    def GetBoolVariableNames(self) -> str: ...
    def GetConstitutiveLaw(self, *args, **kwargs): ...
    def GetDoubleVariable(self, *args, **kwargs): ...
    def GetDoubleVariableNames(self) -> str: ...
    def GetFlag(self, *args, **kwargs): ...
    def GetFlagsVariable(self, *args, **kwargs): ...
    def GetFlagsVariableNames(self) -> str: ...
    def GetIntVariable(self, *args, **kwargs): ...
    def GetIntVariableNames(self) -> str: ...
    def GetMatrixVariable(self, *args, **kwargs): ...
    def GetMatrixVariableNames(self) -> str: ...
    def GetStringVariable(self, *args, **kwargs): ...
    def GetStringVariableNames(self) -> str: ...
    def GetUnsignedIntVariable(self, *args, **kwargs): ...
    def GetUnsignedIntVariableNames(self) -> str: ...
    def GetVectorVariable(self, *args, **kwargs): ...
    def GetVectorVariableNames(self) -> str: ...
    def HasArray4Variable(self, arg0: str) -> bool: ...
    def HasArray6Variable(self, arg0: str) -> bool: ...
    def HasArray9Variable(self, arg0: str) -> bool: ...
    def HasArrayVariable(self, arg0: str) -> bool: ...
    def HasBoolVariable(self, arg0: str) -> bool: ...
    def HasConstitutiveLaw(self, arg0: str) -> bool: ...
    def HasDoubleVariable(self, arg0: str) -> bool: ...
    def HasFlag(self, arg0: str) -> bool: ...
    def HasFlagsVariable(self, arg0: str) -> bool: ...
    def HasIntVariable(self, arg0: str) -> bool: ...
    def HasMatrixVariable(self, arg0: str) -> bool: ...
    def HasStringVariable(self, arg0: str) -> bool: ...
    def HasUnsignedIntVariable(self, arg0: str) -> bool: ...
    def HasVariableData(self, arg0: str) -> bool: ...
    def HasVectorVariable(self, arg0: str) -> bool: ...
    def ImportApplication(self, arg0) -> None: ...
    def Initialize(self) -> None: ...
    def InitializeApplication(self, arg0) -> None: ...
    @staticmethod
    def IsDistributedRun() -> bool: ...
    def IsImported(self, arg0: str) -> bool: ...
    @staticmethod
    def OSName() -> str: ...
    def PrintAllVariables(self) -> None: ...
    def PrintArray4Variables(self) -> None: ...
    def PrintArray6Variables(self) -> None: ...
    def PrintArray9Variables(self) -> None: ...
    def PrintArrayVariables(self) -> None: ...
    def PrintBoolVariables(self) -> None: ...
    def PrintDoubleVariables(self) -> None: ...
    def PrintFlagsVariables(self) -> None: ...
    def PrintIntVariables(self) -> None: ...
    def PrintMatrixVariables(self) -> None: ...
    def PrintStringVariables(self) -> None: ...
    def PrintUnsignedIntVariables(self) -> None: ...
    def PrintVectorVariables(self) -> None: ...
    @staticmethod
    def PythonVersion() -> str: ...
    @staticmethod
    def RegisterPythonVersion() -> None: ...
    @staticmethod
    def Version() -> str: ...

class KratosApplication:
    def __init__(self, arg0: str) -> None: ...
    def Register(self) -> None: ...

class LevelSetConvectionProcess2D(Process):
    def __init__(self, *args, **kwargs) -> None: ...

class LevelSetConvectionProcess3D(Process):
    def __init__(self, *args, **kwargs) -> None: ...

class Line2D2(Geometry):
    def __init__(self, arg0: Node, arg1: Node) -> None: ...

class Line2D3(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node) -> None: ...

class Line3D2(Geometry):
    def __init__(self, arg0: Node, arg1: Node) -> None: ...

class Line3D3(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node) -> None: ...

class LineSearchStrategy(ResidualBasedNewtonRaphsonStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4: int, arg5: bool, arg6: bool, arg7: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: ConvergenceCriteria, arg3: BuilderAndSolver, arg4: int, arg5: bool, arg6: bool, arg7: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4: BuilderAndSolver, arg5: int, arg6: bool, arg7: bool, arg8: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: ConvergenceCriteria, arg3: BuilderAndSolver, arg4) -> None: ...

class LinearMasterSlaveConstraint(MasterSlaveConstraint):
    def __init__(self, arg0: int, arg1: list[Dof], arg2: list[Dof], arg3: Matrix, arg4: Vector) -> None: ...

class LinearSolver:
    def __init__(self) -> None: ...
    def Clear(self) -> None: ...
    def GetIterationsNumber(self) -> int: ...
    def Initialize(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...
    @overload
    def Solve(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> bool: ...
    @overload
    def Solve(self, arg0: CompressedMatrix, arg1: CompressedMatrix, arg2: Vector, arg3: Matrix) -> None: ...

class LinearSolverFactory:
    def __init__(self) -> None: ...
    def Create(self, arg0) -> LinearSolver: ...
    def Has(self, arg0: str) -> bool: ...

class Logger:
    class Category:
        __members__: ClassVar[dict] = ...  # read-only
        CHECKING: ClassVar[Logger.Category] = ...
        CRITICAL: ClassVar[Logger.Category] = ...
        PROFILING: ClassVar[Logger.Category] = ...
        STATISTICS: ClassVar[Logger.Category] = ...
        STATUS: ClassVar[Logger.Category] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Severity:
        __members__: ClassVar[dict] = ...  # read-only
        DEBUG: ClassVar[Logger.Severity] = ...
        DETAIL: ClassVar[Logger.Severity] = ...
        INFO: ClassVar[Logger.Severity] = ...
        TRACE: ClassVar[Logger.Severity] = ...
        WARNING: ClassVar[Logger.Severity] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    def __init__(self, arg0: str) -> None: ...
    @staticmethod
    def AddOutput(arg0: LoggerOutput) -> None: ...
    @staticmethod
    def Flush() -> None: ...
    @staticmethod
    def GetDefaultOutput() -> LoggerOutput: ...
    @staticmethod
    def Print(*args, **kwargs) -> None: ...
    @staticmethod
    def PrintInfo(*args, **kwargs) -> None: ...
    @staticmethod
    def PrintInfoOnAllRanks(*args, **kwargs) -> None: ...
    @staticmethod
    def PrintOnAllRanks(*args, **kwargs) -> None: ...
    @staticmethod
    def PrintWarning(*args, **kwargs) -> None: ...
    @staticmethod
    def PrintWarningOnAllRanks(*args, **kwargs) -> None: ...
    @staticmethod
    def RemoveOutput(arg0: LoggerOutput) -> None: ...

class LoggerOutput:
    DEBUG_PREFIX: ClassVar[Flags] = ...
    DETAIL_PREFIX: ClassVar[Flags] = ...
    INFO_PREFIX: ClassVar[Flags] = ...
    TRACE_PREFIX: ClassVar[Flags] = ...
    WARNING_PREFIX: ClassVar[Flags] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def GetCategory(self, *args, **kwargs): ...
    def GetMaxLevel(self) -> int: ...
    def GetOption(self, arg0: Flags) -> bool: ...
    def GetSeverity(self, *args, **kwargs): ...
    def SetCategory(self, arg0) -> None: ...
    def SetMaxLevel(self, arg0: int) -> None: ...
    def SetOption(self, arg0: Flags, arg1: bool) -> None: ...
    def SetSeverity(self, arg0) -> None: ...

class LoggerTableOutput(LoggerOutput):
    def __init__(self, arg0: Parameters) -> None: ...

class MLSShapeFunctionsUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def CalculateShapeFunctions(arg0: int, arg1: int, arg2: Matrix, arg3: Array3, arg4: float, arg5: Vector) -> None: ...
    @staticmethod
    def CalculateShapeFunctionsAndGradients(arg0: int, arg1: int, arg2: Matrix, arg3: Array3, arg4: float, arg5: Vector, arg6: Matrix) -> None: ...

class MPIColoringUtilities:
    def __init__(self) -> None: ...
    def ComputeCommunicationScheduling(self, arg0) -> list[int]: ...
    def ComputeRecvList(self, arg0) -> list[int]: ...

class Mapper:
    ADD_VALUES: ClassVar[Flags] = ...
    FROM_NON_HISTORICAL: ClassVar[Flags] = ...
    REMESHED: ClassVar[Flags] = ...
    SWAP_SIGN: ClassVar[Flags] = ...
    TO_NON_HISTORICAL: ClassVar[Flags] = ...
    USE_TRANSPOSE: ClassVar[Flags] = ...
    def __init__(self, *args, **kwargs) -> None: ...
    def AreMeshesConforming(self) -> int: ...
    def GetInterfaceModelPartDestination(self) -> ModelPart: ...
    def GetInterfaceModelPartOrigin(self) -> ModelPart: ...
    def GetMappingMatrix(self) -> CompressedMatrix: ...
    @overload
    def InverseMap(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...
    @overload
    def InverseMap(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def InverseMap(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: Flags) -> None: ...
    @overload
    def InverseMap(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: Flags) -> None: ...
    @overload
    def Map(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...
    @overload
    def Map(self, arg0: Array1DVariable3, arg1: Array1DVariable3) -> None: ...
    @overload
    def Map(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: Flags) -> None: ...
    @overload
    def Map(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: Flags) -> None: ...
    @overload
    def UpdateInterface(self) -> None: ...
    @overload
    def UpdateInterface(self, arg0: Flags) -> None: ...
    @overload
    def UpdateInterface(self, arg0: float) -> None: ...
    @overload
    def UpdateInterface(self, arg0: Flags, arg1: float) -> None: ...

class MapperFactory:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def CreateMapper(arg0: ModelPart, arg1: ModelPart, arg2: Parameters) -> Mapper: ...
    @staticmethod
    def GetRegisteredMapperNames() -> list[str]: ...
    @staticmethod
    def HasMapper(arg0: str) -> bool: ...

class MasterSlaveConstraint(IndexedObject, Flags):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    def CalculateLocalSystem(self, arg0: Matrix, arg1: Vector, arg2: ProcessInfo) -> None: ...
    def GetMasterDofsVector(self) -> list[Dof]: ...
    def GetSlaveDofsVector(self) -> list[Dof]: ...
    @overload
    def GetValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetValue(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def GetValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def GetValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetValue(self, arg0: IntegerVectorVariable) -> DenseVectorInt: ...
    @overload
    def GetValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def GetValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetValue(self, arg0: StringVariable) -> str: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: StringVariable) -> bool: ...
    def IsActive(self) -> bool: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVectorVariable, arg1: DenseVectorInt) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetValue(self, arg0: StringVariable, arg1: str) -> None: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def __getitem__(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def __getitem__(self, arg0: IntegerVectorVariable) -> DenseVectorInt: ...
    @overload
    def __getitem__(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def __getitem__(self, arg0: IntegerVariable) -> int: ...
    @overload
    def __getitem__(self, arg0: DoubleVariable) -> float: ...
    @overload
    def __getitem__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: StringVariable) -> str: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def __setitem__(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVectorVariable, arg1: DenseVectorInt) -> None: ...
    @overload
    def __setitem__(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def __setitem__(self, arg0: StringVariable, arg1: str) -> None: ...

class MasterSlaveConstraintEraseProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...

class MasterSlaveConstraintsArray:
    def __init__(self) -> None: ...
    def append(self, arg0) -> None: ...
    def clear(self) -> None: ...
    @overload
    def __contains__(self, arg0) -> bool: ...
    @overload
    def __contains__(self, arg0: int) -> bool: ...
    def __getitem__(self, index): ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    @overload
    def __setitem__(self, arg0) -> None: ...
    @overload
    def __setitem__(self, arg0) -> None: ...

class Matrix:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Matrix) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int, arg2: float) -> None: ...
    @overload
    def __init__(self, arg0: Matrix) -> None: ...
    def Resize(self, arg0: int, arg1: int) -> None: ...
    def Size1(self) -> int: ...
    def Size2(self) -> int: ...
    def fill(self, arg0: float) -> None: ...
    def fill_identity(self) -> None: ...
    def transpose(self) -> Matrix: ...
    def __add__(self, arg0: Matrix) -> Matrix: ...
    def __getitem__(self, arg0: tuple[int, int]) -> float: ...
    def __imul__(self, arg0: float) -> Matrix: ...
    def __itruediv__(self, arg0: float) -> Matrix: ...
    def __len__(self) -> int: ...
    @overload
    def __mul__(self, arg0: Matrix) -> Matrix: ...
    @overload
    def __mul__(self, arg0: float) -> Matrix: ...
    @overload
    def __mul__(self, arg0: Vector) -> Vector: ...
    @overload
    def __mul__(self, arg0: Array3) -> Vector: ...
    def __setitem__(self, arg0: tuple[int, int], arg1: float) -> None: ...
    def __sub__(self, arg0: Matrix) -> Matrix: ...
    def __truediv__(self, arg0: float) -> Matrix: ...

class MatrixVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class MemoryInfo:
    def __init__(self) -> None: ...
    @staticmethod
    def GetCurrentMemoryUsage() -> int: ...
    @staticmethod
    def GetPeakMemoryUsage() -> int: ...
    @staticmethod
    def HumanReadableSize(arg0: int) -> str: ...

class MergeVariableListsUtility:
    def __init__(self) -> None: ...
    def Merge(self, arg0: ModelPart, arg1: ModelPart) -> None: ...

class Mesh(DataValueContainer, Flags):
    Conditions: ConditionsArray
    Elements: ElementsArray
    Nodes: NodesArray
    Properties: PropertiesArray
    def __init__(self, *args, **kwargs) -> None: ...
    def ConditionsArray(self) -> list[Condition]: ...
    def ElementsArray(self) -> list[Element]: ...
    def HasCondition(self, arg0: int) -> bool: ...
    def HasElement(self, arg0: int) -> bool: ...
    def HasMasterSlaveConstraint (self, *args, **kwargs): ...
    def HasNode(self, arg0: int) -> bool: ...
    def HasProperties(self, arg0: int) -> bool: ...
    def NodesArray(self) -> list[Node]: ...
    def NumberOfConditions(self) -> int: ...
    def NumberOfElements(self) -> int: ...
    def NumberOfNodes(self) -> int: ...
    def NumberOfProperties(self) -> int: ...
    def PropertiesArray(self) -> list[Properties]: ...

class MixedGenericCriteria(ConvergenceCriteria):
    def __init__(self, arg0: list[tuple[VariableData, float, float]]) -> None: ...

class MixedLinearSolver:
    def __init__(self) -> None: ...
    def Clear(self) -> None: ...
    def Initialize(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...
    def Solve(self, arg0: CompressedMatrix, arg1: CompressedMatrix, arg2: ComplexVector, arg3: ComplexMatrix) -> None: ...

class Model:
    def __init__(self) -> None: ...
    @overload
    def CreateModelPart(self, arg0: str) -> ModelPart: ...
    @overload
    def CreateModelPart(self, arg0: str, arg1: int) -> ModelPart: ...
    def DeleteModelPart(self, arg0: str) -> None: ...
    def GetModelPart(self, arg0: str) -> ModelPart: ...
    def GetModelPartNames(self) -> list[str]: ...
    def HasModelPart(self, arg0: str) -> bool: ...
    def Reset(self) -> None: ...
    def __getitem__(self, arg0: str) -> ModelPart: ...

class ModelPart(DataValueContainer, Flags):
    Conditions: Incomplete
    Elements: Incomplete
    Geometries: GeometriesMapType
    Name: str
    Nodes: Incomplete
    ProcessInfo: Incomplete
    Properties: Incomplete
    SubModelParts: SubModelPartsContainerType
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    def AddCondition(self, arg0) -> None: ...
    @overload
    def AddCondition(self, arg0, arg1: int) -> None: ...
    def AddConditions(self, arg0: list[int]) -> None: ...
    @overload
    def AddElement(self, arg0) -> None: ...
    @overload
    def AddElement(self, arg0, arg1: int) -> None: ...
    def AddElements(self, arg0: list[int]) -> None: ...
    def AddGeometry(self, arg0) -> None: ...
    def AddMasterSlaveConstraint(self, arg0) -> None: ...
    def AddMasterSlaveConstraints(self, arg0: list[int]) -> None: ...
    @overload
    def AddNodalSolutionStepVariable(self, arg0: BoolVariable) -> None: ...
    @overload
    def AddNodalSolutionStepVariable(self, arg0: IntegerVariable) -> None: ...
    @overload
    def AddNodalSolutionStepVariable(self, arg0: DoubleVariable) -> None: ...
    @overload
    def AddNodalSolutionStepVariable(self, arg0: Array1DVariable3) -> None: ...
    @overload
    def AddNodalSolutionStepVariable(self, arg0: VectorVariable) -> None: ...
    @overload
    def AddNodalSolutionStepVariable(self, arg0: MatrixVariable) -> None: ...
    @overload
    def AddNodalSolutionStepVariable(self, arg0: DoubleQuaternionVariable) -> None: ...
    @overload
    def AddNode(self, arg0) -> None: ...
    @overload
    def AddNode(self, arg0, arg1: int) -> None: ...
    def AddNodes(self, arg0: list[int]) -> None: ...
    def AddProperties(self, arg0) -> None: ...
    def AddTable(self, *args, **kwargs): ...
    def Check(self) -> int: ...
    def Clear(self) -> None: ...
    def CloneSolutionStep(self) -> int: ...
    @overload
    def CloneTimeStep(self) -> int: ...
    @overload
    def CloneTimeStep(self, arg0: float) -> int: ...
    def ConditionsArray(self, *args, **kwargs): ...
    def CreateNewCondition(self, *args, **kwargs): ...
    def CreateNewElement(self, *args, **kwargs): ...
    def CreateNewGeometry(self, *args, **kwargs): ...
    def CreateNewMasterSlaveConstraint(self, *args, **kwargs): ...
    def CreateNewNode(self, *args, **kwargs): ...
    def CreateNewProperties(self, *args, **kwargs): ...
    def CreateSolutionStep(self) -> int: ...
    def CreateSubModelPart(self, arg0: str) -> ModelPart: ...
    def CreateTimeStep(self, arg0: float) -> int: ...
    def ElementsArray(self, *args, **kwargs): ...
    def FullName(self) -> str: ...
    def GetBufferSize(self) -> int: ...
    def GetCommunicator(self, *args, **kwargs): ...
    def GetCondition(self, *args, **kwargs): ...
    def GetConditions(self, *args, **kwargs): ...
    def GetElement(self, *args, **kwargs): ...
    def GetElements(self, *args, **kwargs): ...
    def GetGeometry(self, *args, **kwargs): ...
    def GetHistoricalVariablesNames(self) -> Set[str]: ...
    def GetMasterSlaveConstraint(self, *args, **kwargs): ...
    def GetMasterSlaveConstraints(self) -> MasterSlaveConstraintsArray: ...
    def GetMesh(self, *args, **kwargs): ...
    def GetModel(self, *args, **kwargs): ...
    def GetNodalSolutionStepDataSize(self) -> int: ...
    def GetNodalSolutionStepTotalDataSize(self) -> int: ...
    def GetNode(self, *args, **kwargs): ...
    def GetNodes(self, *args, **kwargs): ...
    def GetNonHistoricalVariablesNames(self, *args, **kwargs): ...
    def GetParentModelPart(self) -> ModelPart: ...
    def GetProperties(self, *args, **kwargs): ...
    def GetRootModelPart(self) -> ModelPart: ...
    def GetSubModelPart(self, arg0: str) -> ModelPart: ...
    def GetSubModelPartNames(self) -> list[str]: ...
    def GetTable(self, *args, **kwargs): ...
    @overload
    def HasCondition(self, arg0: int) -> bool: ...
    @overload
    def HasCondition(self, arg0: int, arg1: int) -> bool: ...
    @overload
    def HasElement(self, arg0: int) -> bool: ...
    @overload
    def HasElement(self, arg0: int, arg1: int) -> bool: ...
    @overload
    def HasGeometry(self, arg0: int) -> bool: ...
    @overload
    def HasGeometry(self, arg0: str) -> bool: ...
    def HasMasterSlaveConstraint(self, arg0: int) -> bool: ...
    @overload
    def HasNodalSolutionStepVariable(self, arg0: BoolVariable) -> bool: ...
    @overload
    def HasNodalSolutionStepVariable(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def HasNodalSolutionStepVariable(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def HasNodalSolutionStepVariable(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def HasNodalSolutionStepVariable(self, arg0: VectorVariable) -> bool: ...
    @overload
    def HasNodalSolutionStepVariable(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def HasNodalSolutionStepVariable(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def HasNode(self, arg0: int) -> bool: ...
    @overload
    def HasNode(self, arg0: int, arg1: int) -> bool: ...
    @overload
    def HasProperties(self, arg0: int) -> bool: ...
    @overload
    def HasProperties(self, arg0: str) -> bool: ...
    def HasSubModelPart(self, arg0: str) -> bool: ...
    def IsDistributed(self) -> bool: ...
    def IsSubModelPart(self) -> bool: ...
    def NodesArray(self, *args, **kwargs): ...
    @overload
    def NumberOfConditions(self) -> int: ...
    @overload
    def NumberOfConditions(self, arg0: int) -> int: ...
    @overload
    def NumberOfElements(self) -> int: ...
    @overload
    def NumberOfElements(self, arg0: int) -> int: ...
    def NumberOfGeometries(self) -> int: ...
    @overload
    def NumberOfMasterSlaveConstraints(self) -> int: ...
    @overload
    def NumberOfMasterSlaveConstraints(self, arg0: int) -> int: ...
    def NumberOfMeshes(self) -> int: ...
    @overload
    def NumberOfNodes(self, arg0: int) -> int: ...
    @overload
    def NumberOfNodes(self) -> int: ...
    def NumberOfProperties(self, ThisIndex: int = ...) -> int: ...
    def NumberOfSubModelParts(self) -> int: ...
    def NumberOfTables(self) -> int: ...
    def OverwriteSolutionStepData(self, arg0: int, arg1: int) -> None: ...
    def PropertiesArray(self, *args, **kwargs): ...
    def RecursivelyHasProperties(self, arg0: int) -> bool: ...
    def ReduceTimeStep(self, arg0: ModelPart, arg1: float) -> None: ...
    @overload
    def RemoveCondition(self, arg0: int) -> None: ...
    @overload
    def RemoveCondition(self, arg0: int, arg1: int) -> None: ...
    @overload
    def RemoveCondition(self, arg0) -> None: ...
    @overload
    def RemoveCondition(self, arg0, arg1: int) -> None: ...
    @overload
    def RemoveConditionFromAllLevels(self, arg0: int) -> None: ...
    @overload
    def RemoveConditionFromAllLevels(self, arg0: int, arg1: int) -> None: ...
    @overload
    def RemoveConditionFromAllLevels(self, arg0) -> None: ...
    @overload
    def RemoveConditionFromAllLevels(self, arg0, arg1: int) -> None: ...
    def RemoveConditions(self, arg0: Flags) -> None: ...
    def RemoveConditionsFromAllLevels(self, arg0: Flags) -> None: ...
    @overload
    def RemoveElement(self, arg0: int) -> None: ...
    @overload
    def RemoveElement(self, arg0: int, arg1: int) -> None: ...
    @overload
    def RemoveElement(self, arg0) -> None: ...
    @overload
    def RemoveElement(self, arg0, arg1: int) -> None: ...
    @overload
    def RemoveElementFromAllLevels(self, arg0: int) -> None: ...
    @overload
    def RemoveElementFromAllLevels(self, arg0: int, arg1: int) -> None: ...
    @overload
    def RemoveElementFromAllLevels(self, arg0) -> None: ...
    @overload
    def RemoveElementFromAllLevels(self, arg0, arg1: int) -> None: ...
    def RemoveElements(self, arg0: Flags) -> None: ...
    def RemoveElementsFromAllLevels(self, arg0: Flags) -> None: ...
    @overload
    def RemoveGeometry(self, arg0: int) -> None: ...
    @overload
    def RemoveGeometry(self, arg0: str) -> None: ...
    @overload
    def RemoveGeometryFromAllLevels(self, arg0: int) -> None: ...
    @overload
    def RemoveGeometryFromAllLevels(self, arg0: str) -> None: ...
    @overload
    def RemoveMasterSlaveConstraint(self, arg0: int) -> None: ...
    @overload
    def RemoveMasterSlaveConstraint(self, arg0) -> None: ...
    @overload
    def RemoveMasterSlaveConstraintFromAllLevels(self, arg0: int) -> None: ...
    @overload
    def RemoveMasterSlaveConstraintFromAllLevels(self, arg0) -> None: ...
    def RemoveMasterSlaveConstraints(self, arg0: Flags) -> None: ...
    def RemoveMasterSlaveConstraintsFromAllLevels(self, arg0: Flags) -> None: ...
    @overload
    def RemoveNode(self, arg0: int) -> None: ...
    @overload
    def RemoveNode(self, arg0: int, arg1: int) -> None: ...
    @overload
    def RemoveNode(self, arg0) -> None: ...
    @overload
    def RemoveNode(self, arg0, arg1: int) -> None: ...
    @overload
    def RemoveNodeFromAllLevels(self, arg0: int) -> None: ...
    @overload
    def RemoveNodeFromAllLevels(self, arg0: int, arg1: int) -> None: ...
    @overload
    def RemoveNodeFromAllLevels(self, arg0) -> None: ...
    @overload
    def RemoveNodeFromAllLevels(self, arg0, arg1: int) -> None: ...
    def RemoveNodes(self, arg0: Flags) -> None: ...
    def RemoveNodesFromAllLevels(self, arg0: Flags) -> None: ...
    @overload
    def RemoveProperties(self, arg0: int) -> None: ...
    @overload
    def RemoveProperties(self, arg0) -> None: ...
    @overload
    def RemovePropertiesFromAllLevels(self, arg0: int) -> None: ...
    @overload
    def RemovePropertiesFromAllLevels(self, arg0) -> None: ...
    @overload
    def RemoveSubModelPart(self, arg0: str) -> None: ...
    @overload
    def RemoveSubModelPart(self, arg0: ModelPart) -> None: ...
    def SetBufferSize(self, arg0: int) -> None: ...
    def SetConditions(self, *args, **kwargs): ...
    def SetElements(self, *args, **kwargs): ...
    def SetNodes(self, *args, **kwargs): ...
    def SetProperties(self, *args, **kwargs): ...
    @property
    def MasterSlaveConstraints(self) -> MasterSlaveConstraintsArray: ...

class ModelPartCombinationUtilities:
    def __init__(self, arg0: Model) -> None: ...
    def CombineModelParts(self, arg0) -> ModelPart: ...

class ModelPartGraphUtilities:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def ApplyMinimalScalarFixity(arg0: NodesArray, arg1: DoubleVariable, arg2: Vector, arg3: int) -> list[int]: ...
    @staticmethod
    def ComputeCSRGraph(arg0: ModelPart) -> tuple[DenseVectorUnsignedInt, DenseVectorUnsignedInt]: ...
    @staticmethod
    def ComputeConnectedComponents(arg0: NodesArray, arg1: DenseVectorUnsignedInt, arg2: DenseVectorUnsignedInt) -> tuple[int, Vector]: ...
    @staticmethod
    def ComputeConnectedComponentsWithActiveNodesCheck(arg0: NodesArray, arg1: DenseVectorUnsignedInt, arg2: DenseVectorUnsignedInt, arg3: list[bool]) -> tuple[int, Vector]: ...
    @staticmethod
    def ComputeGraph(*args, **kwargs): ...

class ModelPartIO(IO):
    @overload
    def __init__(self, arg0: os.PathLike) -> None: ...
    @overload
    def __init__(self, arg0: os.PathLike, arg1: Flags) -> None: ...

class ModelPartUtils:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def FromConnectivityGenerateConditions(entity_name: str, entities_connectivities: list[list[int]], nodes: NodesArray, conditions: ConditionsArray, properties: Properties) -> None: ...
    @staticmethod
    def FromConnectivityGenerateElements(entity_name: str, entities_connectivities: list[list[int]], nodes: NodesArray, elements: ElementsArray, properties: Properties) -> None: ...

class Modeler:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Model, arg1) -> None: ...
    def Create(self, arg0: Model, arg1) -> Modeler: ...
    def GenerateMesh(self, arg0: ModelPart, arg1: str, arg2: str) -> None: ...
    def GenerateModelPart(self, arg0: ModelPart, arg1: ModelPart, arg2: str, arg3: str) -> None: ...
    def GenerateNodes(self, arg0: ModelPart) -> None: ...
    def PrepareGeometryModel(self) -> None: ...
    def SetupGeometryModel(self) -> None: ...
    def SetupModelPart(self) -> None: ...

class MpiSerializer(StreamSerializer):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1) -> None: ...

class MultiFileFlag:
    __members__: ClassVar[dict] = ...  # read-only
    MultipleFiles: ClassVar[MultiFileFlag] = ...
    SingleFile: ClassVar[MultiFileFlag] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Node(Point, Flags):
    Id: int
    X0: float
    Y0: float
    Z0: float
    @overload
    def __init__(self, arg0: int, arg1: float, arg2: float, arg3: float) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: Point) -> None: ...
    @overload
    def AddDof(self, arg0: DoubleVariable) -> None: ...
    @overload
    def AddDof(self, arg0: DoubleVariable, arg1: DoubleVariable) -> None: ...
    def Fix(self, arg0: DoubleVariable) -> None: ...
    def Free(self, arg0: DoubleVariable) -> None: ...
    def GetBufferSize(self) -> int: ...
    def GetDof(self, arg0: DoubleVariable) -> Dof: ...
    @overload
    def GetSolutionStepValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetSolutionStepValue(self, arg0: BoolVariable, arg1: int) -> bool: ...
    @overload
    def GetSolutionStepValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetSolutionStepValue(self, arg0: IntegerVariable, arg1: int) -> int: ...
    @overload
    def GetSolutionStepValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetSolutionStepValue(self, arg0: DoubleVariable, arg1: int) -> float: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable3, arg1: int) -> Array3: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable4, arg1: int) -> Array4: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable6, arg1: int) -> Array6: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def GetSolutionStepValue(self, arg0: Array1DVariable9, arg1: int) -> Array9: ...
    @overload
    def GetSolutionStepValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetSolutionStepValue(self, arg0: VectorVariable, arg1: int) -> Vector: ...
    @overload
    def GetSolutionStepValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def GetSolutionStepValue(self, arg0: MatrixVariable, arg1: int) -> Matrix: ...
    @overload
    def GetValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetValue(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def GetValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def GetValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def Has(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    def HasDofFor(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: VectorVariable) -> bool: ...
    @overload
    def HasSolutionStepValue(self, arg0: MatrixVariable) -> bool: ...
    def IsFixed(self, arg0: DoubleVariable) -> bool: ...
    def OverwriteSolutionStepData(self, arg0: int, arg1: int) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: BoolVariable, arg1: int, arg2: bool) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: IntegerVariable, arg1: int, arg2: int) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: DoubleVariable, arg1: int, arg2: float) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable3, arg1: int, arg2: Array3) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable4, arg1: int, arg2: Array4) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable6, arg1: int, arg2: Array6) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: Array1DVariable9, arg1: int, arg2: Array9) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: DoubleQuaternionVariable, arg1) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: DoubleQuaternionVariable, arg1: int, arg2) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: VectorVariable, arg1: int, arg2: Vector) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SetSolutionStepValue(self, arg0: MatrixVariable, arg1: int, arg2: Matrix) -> None: ...
    @overload
    def SetValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleQuaternionVariable, arg1) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SolutionStepsDataHas(self, arg0: BoolVariable) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: VectorVariable) -> bool: ...
    @overload
    def SolutionStepsDataHas(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def __contains__(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: VectorVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: IntegerVariable) -> int: ...
    @overload
    def __getitem__(self, arg0: DoubleVariable) -> float: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def __getitem__(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def __getitem__(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def __setitem__(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleQuaternionVariable, arg1) -> None: ...
    @overload
    def __setitem__(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def __setitem__(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...

class NodeEraseProcess(Process):
    def __init__(self, arg0: ModelPart) -> None: ...

class NodesArray:
    def __init__(self) -> None: ...
    def append(self, arg0: Node) -> None: ...
    def clear(self) -> None: ...
    @overload
    def __contains__(self, arg0: Node) -> bool: ...
    @overload
    def __contains__(self, arg0: int) -> bool: ...
    def __getitem__(self, arg0: int) -> Node: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    @overload
    def __setitem__(self, arg0: Node) -> None: ...
    @overload
    def __setitem__(self, arg0: Node) -> None: ...

class NodesVector:
    def __init__(self) -> None: ...
    def append(self, arg0: Node) -> None: ...
    def __getitem__(self, arg0: int) -> Node: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    def __setitem__(self, arg0: int, arg1: Node) -> None: ...

class NormalCalculationUtils:
    def __init__(self) -> None: ...
    def CalculateNormalShapeDerivativesOnSimplex(self, arg0: ConditionsArray, arg1: int) -> None: ...
    @overload
    def CalculateNormals(self, arg0: ModelPart, arg1: bool, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateNormals(self, arg0: ModelPart, arg1: bool) -> None: ...
    @overload
    def CalculateNormals(self, arg0: ModelPart) -> None: ...
    def CalculateNormalsInConditions(self, arg0: ModelPart, arg1: Array1DVariable3) -> None: ...
    def CalculateNormalsInElements(self, arg0: ModelPart, arg1: Array1DVariable3) -> None: ...
    @overload
    def CalculateNormalsNonHistorical(self, arg0: ModelPart, arg1: bool, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateNormalsNonHistorical(self, arg0: ModelPart, arg1: bool) -> None: ...
    @overload
    def CalculateNormalsNonHistorical(self, arg0: ModelPart) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ConditionsArray, arg1: int) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ConditionsArray, arg1: int, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ModelPart, arg1: int) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ModelPart, arg1: int, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ModelPart) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ModelPart, arg1: Array1DVariable3) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ModelPart, arg1: int, arg2: DoubleVariable) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ModelPart, arg1: int, arg2: IntegerVariable) -> None: ...
    @overload
    def CalculateOnSimplex(self, arg0: ModelPart, arg1: int, arg2: DoubleVariable, arg3: float, arg4: float) -> None: ...
    @overload
    def CalculateOnSimplexNonHistorical(self, arg0: ConditionsArray, arg1: int) -> None: ...
    @overload
    def CalculateOnSimplexNonHistorical(self, arg0: ConditionsArray, arg1: int, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateOnSimplexNonHistorical(self, arg0: ModelPart, arg1: int) -> None: ...
    @overload
    def CalculateOnSimplexNonHistorical(self, arg0: ModelPart, arg1: int, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateOnSimplexNonHistorical(self, arg0: ModelPart) -> None: ...
    @overload
    def CalculateOnSimplexNonHistorical(self, arg0: ModelPart, arg1: Array1DVariable3) -> None: ...
    @overload
    def CalculateUnitNormals(self, arg0: ModelPart, arg1: bool, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateUnitNormals(self, arg0: ModelPart, arg1: bool) -> None: ...
    @overload
    def CalculateUnitNormals(self, arg0: ModelPart) -> None: ...
    @overload
    def CalculateUnitNormalsNonHistorical(self, arg0: ModelPart, arg1: bool, arg2: Array1DVariable3) -> None: ...
    @overload
    def CalculateUnitNormalsNonHistorical(self, arg0: ModelPart, arg1: bool) -> None: ...
    @overload
    def CalculateUnitNormalsNonHistorical(self, arg0: ModelPart) -> None: ...
    def SwapNormals(self, arg0: ModelPart) -> None: ...

class NurbsCurveGeometry2D(Geometry):
    @overload
    def __init__(self, arg0: NodesVector, arg1: int, arg2: Vector) -> None: ...
    @overload
    def __init__(self, arg0: NodesVector, arg1: int, arg2: Vector, arg3: Vector) -> None: ...
    def IsRational(self) -> bool: ...
    def Knots(self) -> Vector: ...
    def NumberOfControlPoints(self) -> int: ...
    def NumberOfKnots(self) -> int: ...
    def PolynomialDegree(self, arg0: int) -> int: ...
    def Weights(self) -> Vector: ...

class NurbsCurveGeometry3D(Geometry):
    @overload
    def __init__(self, arg0: NodesVector, arg1: int, arg2: Vector) -> None: ...
    @overload
    def __init__(self, arg0: NodesVector, arg1: int, arg2: Vector, arg3: Vector) -> None: ...
    def IsRational(self) -> bool: ...
    def Knots(self) -> Vector: ...
    def NumberOfControlPoints(self) -> int: ...
    def NumberOfKnots(self) -> int: ...
    def PolynomialDegree(self, arg0: int) -> int: ...
    def Weights(self) -> Vector: ...

class NurbsSurfaceGeometry3D(Geometry):
    @overload
    def __init__(self, arg0: NodesVector, arg1: int, arg2: int, arg3: Vector, arg4: Vector) -> None: ...
    @overload
    def __init__(self, arg0: NodesVector, arg1: int, arg2: int, arg3: Vector, arg4: Vector, arg5: Vector) -> None: ...
    def IsRational(self) -> bool: ...
    def KnotsU(self) -> Vector: ...
    def KnotsV(self) -> Vector: ...
    def NumberOfControlPointsU(self) -> int: ...
    def NumberOfControlPointsV(self) -> int: ...
    def NumberOfKnotsU(self) -> int: ...
    def NumberOfKnotsV(self) -> int: ...
    def PolynomialDegreeU(self) -> int: ...
    def PolynomialDegreeV(self) -> int: ...
    def Weights(self) -> Vector: ...

class NurbsVolumeGeometry(Geometry):
    def __init__(self, arg0: NodesVector, arg1: int, arg2: int, arg3: int, arg4: Vector, arg5: Vector, arg6: Vector) -> None: ...
    def IsRational(self) -> bool: ...
    def KnotsU(self) -> Vector: ...
    def KnotsV(self) -> Vector: ...
    def KnotsW(self) -> Vector: ...
    def NumberOfControlPointsU(self) -> int: ...
    def NumberOfControlPointsV(self) -> int: ...
    def NumberOfControlPointsW(self) -> int: ...
    def NumberOfKnotsU(self) -> int: ...
    def NumberOfKnotsV(self) -> int: ...
    def NumberOfKnotsW(self) -> int: ...
    def PolynomialDegreeU(self) -> int: ...
    def PolynomialDegreeV(self) -> int: ...
    def PolynomialDegreeW(self) -> int: ...

class OpenMPUtils:
    def __init__(self) -> None: ...
    @staticmethod
    def GetNumThreads() -> int: ...
    @staticmethod
    def GetNumberOfProcessors() -> int: ...
    @staticmethod
    def PrintOMPInfo() -> None: ...
    @staticmethod
    def SetNumThreads(arg0: int) -> None: ...

class Operation:
    def __init__(self) -> None: ...
    def Create(self, arg0, arg1) -> Operation: ...
    def Execute(self) -> None: ...
    def GetDefaultParameters(self, *args, **kwargs): ...

class OrCriteria(ConvergenceCriteria):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0: ConvergenceCriteria, arg1: ConvergenceCriteria) -> None: ...

class OutputController(Controller):
    def __init__(self, model, parameters) -> None: ...
    def GetCurrentControlValue(self) -> int | float: ...
    def GetInterval(self) -> int | float: ...
    def GetNextPossibleEvaluateControlValue(self) -> int | float: ...

class OutputProcess(Process):
    def __init__(self) -> None: ...
    def IsOutputStep(self) -> bool: ...
    def PrintOutput(self) -> None: ...

class ParallelDistanceCalculationProcess2D(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    def FindMaximumEdgeSize(self) -> float: ...

class ParallelDistanceCalculationProcess3D(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0, arg1) -> None: ...
    def FindMaximumEdgeSize(self) -> float: ...

class ParallelEnvironment:
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    @staticmethod
    def CreateCommunicatorFromGlobalParallelism(arg0: ModelPart, arg1: str) -> Communicator: ...
    @overload
    @staticmethod
    def CreateCommunicatorFromGlobalParallelism(arg0: ModelPart, arg1: DataCommunicator) -> Communicator: ...
    @staticmethod
    def CreateFillCommunicator(arg0: ModelPart) -> FillCommunicator: ...
    @overload
    @staticmethod
    def CreateFillCommunicatorFromGlobalParallelism(arg0: ModelPart, arg1: str) -> FillCommunicator: ...
    @overload
    @staticmethod
    def CreateFillCommunicatorFromGlobalParallelism(arg0: ModelPart, arg1: DataCommunicator) -> FillCommunicator: ...
    @staticmethod
    def GetDataCommunicator(arg0: str) -> DataCommunicator: ...
    @staticmethod
    def GetDefaultDataCommunicator() -> DataCommunicator: ...
    @staticmethod
    def GetDefaultDataCommunicatorName() -> str: ...
    @staticmethod
    def GetDefaultRank() -> int: ...
    @staticmethod
    def GetDefaultSize() -> int: ...
    @staticmethod
    def HasDataCommunicator(arg0: str) -> bool: ...
    @staticmethod
    def Info() -> str: ...
    @staticmethod
    def SetDefaultDataCommunicator(arg0: str) -> None: ...
    @staticmethod
    def UnregisterDataCommunicator(arg0: str) -> None: ...
    @property
    def DoNotMakeDefault(self) -> bool: ...
    @property
    def MakeDefault(self) -> bool: ...

class ParallelUtilities:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def GetNumProcs() -> int: ...
    @staticmethod
    def GetNumThreads() -> int: ...
    @staticmethod
    def SetNumThreads(arg0: int) -> None: ...

class Parameters:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0, std) -> None: ...
    @overload
    def __init__(self, arg0: Parameters) -> None: ...
    def AddBool(self, arg0: str, arg1: bool) -> None: ...
    def AddDouble(self, arg0: str, arg1: float) -> None: ...
    def AddEmptyArray(self, arg0: str) -> None: ...
    def AddEmptyList(self, arg0: str) -> None: ...
    def AddEmptyValue(self, arg0: str) -> Parameters: ...
    def AddInt(self, arg0: str, arg1: int) -> None: ...
    def AddMatrix(self, arg0: str, arg1: Matrix) -> None: ...
    def AddMissingParameters(self, arg0: Parameters) -> None: ...
    def AddString(self, arg0: str, arg1: str) -> None: ...
    def AddStringArray(self, arg0: str, arg1: list[str]) -> None: ...
    def AddValue(self, arg0: str, arg1: Parameters) -> None: ...
    def AddVector(self, arg0: str, arg1: Vector) -> None: ...
    @overload
    def Append(self, arg0: int) -> None: ...
    @overload
    def Append(self, arg0: bool) -> None: ...
    @overload
    def Append(self, arg0: float) -> None: ...
    @overload
    def Append(self, arg0: Vector) -> None: ...
    @overload
    def Append(self, arg0: Matrix) -> None: ...
    @overload
    def Append(self, arg0: str) -> None: ...
    @overload
    def Append(self, arg0: Parameters) -> None: ...
    def Clone(self) -> Parameters: ...
    def CopyValuesFromExistingParameters(self, arg0: Parameters, arg1: list[str]) -> None: ...
    def GetBool(self) -> bool: ...
    def GetDouble(self) -> float: ...
    def GetInt(self) -> int: ...
    def GetMatrix(self) -> Matrix: ...
    def GetString(self) -> str: ...
    def GetStringArray(self) -> list[str]: ...
    def GetVector(self) -> Vector: ...
    def Has(self, arg0: str) -> bool: ...
    def HasSameKeysAndTypeOfValuesAs(self, arg0: Parameters) -> bool: ...
    def IsArray(self) -> bool: ...
    def IsBool(self) -> bool: ...
    def IsDouble(self) -> bool: ...
    def IsEquivalentTo(self, arg0: Parameters) -> bool: ...
    def IsInt(self) -> bool: ...
    def IsMatrix(self) -> bool: ...
    def IsNull(self) -> bool: ...
    def IsNumber(self) -> bool: ...
    def IsString(self) -> bool: ...
    def IsStringArray(self) -> bool: ...
    def IsSubParameter(self) -> bool: ...
    def IsVector(self) -> bool: ...
    def PrettyPrintJsonString(self) -> str: ...
    def RecursivelyAddMissingParameters(self, arg0: Parameters) -> None: ...
    def RecursivelyValidateAndAssignDefaults(self, arg0: Parameters) -> None: ...
    def RecursivelyValidateDefaults(self, arg0: Parameters) -> None: ...
    def RemoveValue(self, arg0: str) -> bool: ...
    def RemoveValues(self, arg0: list[str]) -> bool: ...
    def SetBool(self, arg0: bool) -> None: ...
    def SetDouble(self, arg0: float) -> None: ...
    def SetInt(self, arg0: int) -> None: ...
    def SetMatrix(self, arg0: Matrix) -> None: ...
    def SetString(self, arg0: str) -> None: ...
    def SetStringArray(self, arg0: list[str]) -> None: ...
    def SetVector(self, arg0: Vector) -> None: ...
    def ValidateAndAssignDefaults(self, arg0: Parameters) -> None: ...
    def ValidateDefaults(self, arg0: Parameters) -> None: ...
    def WriteJsonString(self) -> str: ...
    def items(self) -> list: ...
    def keys(self) -> list: ...
    def size(self) -> int: ...
    def values(self) -> list: ...
    @overload
    def __copy__(self) -> Parameters: ...
    @overload
    def __copy__(self, arg0: object) -> Parameters: ...
    @overload
    def __deepcopy__(self) -> Parameters: ...
    @overload
    def __deepcopy__(self, arg0: object) -> Parameters: ...
    @overload
    def __getitem__(self, arg0: str) -> Parameters: ...
    @overload
    def __getitem__(self, arg0: int) -> Parameters: ...
    def __iter__(self) -> Iterator: ...
    @overload
    def __setitem__(self, arg0: str, arg1: Parameters) -> None: ...
    @overload
    def __setitem__(self, arg0: int, arg1: Parameters) -> None: ...

class ParticleConvectUtily2D:
    def __init__(self, arg0: BinBasedFastPointLocator2D) -> None: ...
    def MoveParticles_RK4(self, arg0: ModelPart) -> None: ...
    def MoveParticles_Substepping(self, arg0: ModelPart, arg1: int) -> None: ...

class ParticleConvectUtily3D:
    def __init__(self, arg0: BinBasedFastPointLocator3D) -> None: ...
    def MoveParticles_RK4(self, arg0: ModelPart) -> None: ...
    def MoveParticles_Substepping(self, arg0: ModelPart, arg1: int) -> None: ...

class ParticlesUtilities:
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: DoubleVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: DoubleVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: IntegerVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: IntegerVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: DoubleVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: DoubleVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: IntegerVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4: IntegerVariable, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def ClassifyParticlesInElementsNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: int, arg4, arg5: VectorVariable, arg6: float) -> None: ...
    @overload
    @staticmethod
    def CountParticlesInNodesHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: DoubleVariable, arg4: float) -> None: ...
    @overload
    @staticmethod
    def CountParticlesInNodesHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: DoubleVariable, arg4: float) -> None: ...
    @overload
    @staticmethod
    def CountParticlesInNodesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: ModelPart, arg3: DoubleVariable, arg4: float) -> None: ...
    @overload
    @staticmethod
    def CountParticlesInNodesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: ModelPart, arg3: DoubleVariable, arg4: float) -> None: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2: DoubleVariable, arg3: float) -> tuple[BoolVector, list[float]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2: DoubleVariable, arg3: float) -> tuple[BoolVector, list[float]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2: Array1DVariable3, arg3: float) -> tuple[BoolVector, list[Array3]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2: Array1DVariable3, arg3: float) -> tuple[BoolVector, list[Array3]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2: DoubleVariable, arg3: float) -> tuple[BoolVector, list[float]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2: DoubleVariable, arg3: float) -> tuple[BoolVector, list[float]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2, arg3: float) -> tuple[BoolVector, list[int]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: Matrix, arg2: Array1DVariable3, arg3: float) -> tuple[BoolVector, list[Array3]]: ...
    @overload
    @staticmethod
    def InterpolateValuesAtCoordinatesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: Matrix, arg2: Array1DVariable3, arg3: float) -> tuple[BoolVector, list[Array3]]: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: DoubleVariable, arg3: float, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: DoubleVariable, arg3: float, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2: DoubleVariable, arg3: float, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2: DoubleVariable, arg3: float, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesNonHistorical(arg0: BinBasedFastPointLocator2D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...
    @overload
    @staticmethod
    def MarkOutsiderParticlesNonHistorical(arg0: BinBasedFastPointLocator3D, arg1: ModelPart, arg2, arg3: int, arg4: float) -> None: ...

class PiecewiseLinearTable:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Matrix) -> None: ...
    def AddRow(self, arg0: float, arg1: float) -> None: ...
    def Clear(self) -> None: ...
    def GetDerivative(self, arg0: float) -> float: ...
    def GetNearestValue(self, arg0: float) -> float: ...
    def GetValue(self, arg0: float) -> float: ...

class Point(Array3):
    X: float
    Y: float
    Z: float
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float) -> None: ...
    @overload
    def __init__(self, arg0, boost, std) -> None: ...
    @overload
    def __init__(self, arg0: Array3) -> None: ...

class PowerIterationEigenvalueSolver(LinearSolver):
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: int, arg3: LinearSolver) -> None: ...
    @overload
    def __init__(self, arg0, arg1: LinearSolver) -> None: ...

class PowerIterationHighestEigenvalueSolver(LinearSolver):
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: int, arg3: LinearSolver) -> None: ...
    @overload
    def __init__(self, arg0, arg1: LinearSolver) -> None: ...

class Preconditioner:
    def __init__(self) -> None: ...

class PreconditionerFactory:
    def __init__(self) -> None: ...
    def Create(self, arg0: str) -> Preconditioner: ...
    def Has(self, arg0: str) -> bool: ...

class Prism3D15(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node, arg8: Node, arg9: Node, arg10: Node, arg11: Node, arg12: Node, arg13: Node, arg14: Node) -> None: ...

class Prism3D6(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node) -> None: ...

class Process(Flags):
    def __init__(self) -> None: ...
    def Check(self) -> int: ...
    def Clear(self) -> None: ...
    def Create(self, arg0, arg1) -> Process: ...
    def Execute(self) -> None: ...
    def ExecuteAfterOutputStep(self) -> None: ...
    def ExecuteBeforeOutputStep(self) -> None: ...
    def ExecuteBeforeSolutionLoop(self) -> None: ...
    def ExecuteFinalize(self) -> None: ...
    def ExecuteFinalizeSolutionStep(self) -> None: ...
    def ExecuteInitialize(self) -> None: ...
    def ExecuteInitializeSolutionStep(self) -> None: ...
    def GetDefaultParameters(self, *args, **kwargs): ...
    def Info(self) -> str: ...

class ProcessInfo(DataValueContainer, Flags):
    def __init__(self) -> None: ...
    def CreateSolutionStepInfo(self, arg0: int) -> None: ...
    def GetPreviousSolutionStepInfo(self) -> ProcessInfo: ...
    def GetPreviousTimeStepInfo(self) -> ProcessInfo: ...

class Properties(IndexedObject):
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: Properties) -> None: ...
    def AddSubProperties(self, arg0: Properties) -> None: ...
    @overload
    def Erase(self, arg0: Array1DVariable6) -> None: ...
    @overload
    def Erase(self, arg0: Array1DVariable3) -> None: ...
    @overload
    def Erase(self, arg0: VectorVariable) -> None: ...
    @overload
    def Erase(self, arg0: MatrixVariable) -> None: ...
    @overload
    def Erase(self, arg0: StringVariable) -> None: ...
    @overload
    def Erase(self, arg0: BoolVariable) -> None: ...
    @overload
    def Erase(self, arg0: IntegerVariable) -> None: ...
    @overload
    def Erase(self, arg0: DoubleVariable) -> None: ...
    @overload
    def Erase(self, arg0: ConstitutuveLawVariable) -> None: ...
    def GetAccessor(self, *args, **kwargs): ...
    def GetSubProperties(self, arg0: int) -> Properties: ...
    def GetTable(self, *args, **kwargs): ...
    @overload
    def GetValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def GetValue(self, arg0: StringVariable) -> str: ...
    @overload
    def GetValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetValue(self, arg0: BoolVariable, arg1, arg2: Vector, arg3) -> bool: ...
    @overload
    def GetValue(self, arg0: IntegerVariable, arg1, arg2: Vector, arg3) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable, arg1, arg2: Vector, arg3) -> float: ...
    @overload
    def GetValue(self, arg0: VectorVariable, arg1, arg2: Vector, arg3) -> Vector: ...
    @overload
    def GetValue(self, arg0: MatrixVariable, arg1, arg2: Vector, arg3) -> Matrix: ...
    @overload
    def GetValue(self, arg0: Array1DVariable3, arg1, arg2: Vector, arg3) -> Array3: ...
    @overload
    def GetValue(self, arg0: Array1DVariable6, arg1, arg2: Vector, arg3) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable9, arg1, arg2: Vector, arg3) -> Array9: ...
    @overload
    def GetValue(self, arg0: Array1DVariable4, arg1, arg2: Vector, arg3) -> Array4: ...
    @overload
    def GetValue(self, arg0: StringVariable, arg1, arg2: Vector, arg3) -> str: ...
    @overload
    def Has(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def Has(self, arg0: StringVariable) -> bool: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: ConstitutuveLawVariable) -> bool: ...
    @overload
    def HasAccessor(self, arg0: BoolVariable) -> bool: ...
    @overload
    def HasAccessor(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def HasAccessor(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def HasAccessor(self, arg0: VectorVariable) -> bool: ...
    @overload
    def HasAccessor(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def HasAccessor(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def HasAccessor(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def HasAccessor(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def HasAccessor(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def HasAccessor(self, arg0: StringVariable) -> bool: ...
    def HasSubProperties(self, arg0: int) -> bool: ...
    def HasTable(self, arg0: DoubleVariable, arg1: DoubleVariable) -> bool: ...
    def HasTables(self) -> bool: ...
    def HasVariables(self) -> bool: ...
    def IsEmpty(self) -> bool: ...
    def NumberOfSubproperties(self) -> int: ...
    @overload
    def SetAccessor(self, arg0: BoolVariable, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: IntegerVariable, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: DoubleVariable, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: VectorVariable, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: MatrixVariable, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: Array1DVariable3, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: Array1DVariable6, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: Array1DVariable9, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: Array1DVariable4, arg1, std) -> None: ...
    @overload
    def SetAccessor(self, arg0: StringVariable, arg1, std) -> None: ...
    def SetSubProperties(self, *args, **kwargs): ...
    def SetTable(self, *args, **kwargs): ...
    @overload
    def SetValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SetValue(self, arg0: StringVariable, arg1: str) -> None: ...
    @overload
    def SetValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetValue(self, arg0: ConstitutuveLawVariable, arg1) -> None: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def __getitem__(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def __getitem__(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def __getitem__(self, arg0: StringVariable) -> str: ...
    @overload
    def __getitem__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: IntegerVariable) -> int: ...
    @overload
    def __getitem__(self, arg0: DoubleVariable) -> float: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def __setitem__(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def __setitem__(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def __setitem__(self, arg0: StringVariable, arg1: str) -> None: ...
    @overload
    def __setitem__(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: ConstitutuveLawVariable, arg1) -> None: ...

class PropertiesArray:
    def __init__(self) -> None: ...
    def append(self, arg0: Properties) -> None: ...
    def clear(self) -> None: ...
    @overload
    def __contains__(self, arg0: Properties) -> bool: ...
    @overload
    def __contains__(self, arg0: int) -> bool: ...
    def __getitem__(self, arg0: int) -> Properties: ...
    def __iter__(self) -> Iterator: ...
    def __len__(self) -> int: ...
    @overload
    def __setitem__(self, arg0: Properties) -> None: ...
    @overload
    def __setitem__(self, arg0: Properties) -> None: ...

class Pyramid3D13(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node, arg8: Node, arg9: Node, arg10: Node, arg11: Node, arg12: Node) -> None: ...

class Pyramid3D5(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node) -> None: ...

class PythonGenericFunctionUtility(GenericFunctionUtility):
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1) -> None: ...

class Quadrilateral2D4(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node) -> None: ...

class Quadrilateral2D8(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node) -> None: ...

class Quadrilateral2D9(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node, arg8: Node) -> None: ...

class Quadrilateral3D4(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node) -> None: ...

class Quadrilateral3D8(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node) -> None: ...

class Quadrilateral3D9(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node, arg8: Node) -> None: ...

class Quaternion:
    W: float
    X: float
    Y: float
    Z: float
    def __init__(self) -> None: ...
    @staticmethod
    def Identity() -> Quaternion: ...
    def MultiplyQuaternion(self, arg0: Quaternion, arg1: Quaternion) -> Quaternion: ...
    def Normalize(self) -> None: ...
    def ToRotationMatrix(self, arg0: Matrix) -> None: ...

class RBFShapeFunctionsUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    @staticmethod
    def CalculateShapeFunctions(arg0: Matrix, arg1: Array3, arg2: Vector) -> None: ...
    @overload
    @staticmethod
    def CalculateShapeFunctions(arg0: Matrix, arg1: Array3, arg2: float, arg3: Vector) -> None: ...

class RVEPeriodicityUtility:
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: int) -> None: ...
    def AssignPeriodicity(self, arg0: ModelPart, arg1: ModelPart, arg2: Matrix, arg3: Vector, arg4: float) -> None: ...
    def Finalize(self, arg0: Array1DVariable3) -> None: ...

class RadiationSettings:
    def __init__(self) -> None: ...
    def GetDensityVariable(self) -> DoubleVariable: ...
    def GetDiffusionVariable(self) -> DoubleVariable: ...
    def GetMeshVelocityVariable(self) -> Array1DVariable3: ...
    def GetProjectionVariable(self) -> DoubleVariable: ...
    def GetSurfaceSourceVariable(self) -> DoubleVariable: ...
    def GetUnknownVariable(self) -> DoubleVariable: ...
    def GetVolumeSourceVariable(self) -> DoubleVariable: ...
    def SetDensityVariable(self, arg0: DoubleVariable) -> None: ...
    def SetDiffusionVariable(self, arg0: DoubleVariable) -> None: ...
    def SetMeshVelocityVariable(self, arg0: Array1DVariable3) -> None: ...
    def SetProjectionVariable(self, arg0: DoubleVariable) -> None: ...
    def SetSurfaceSourceVariable(self, arg0: DoubleVariable) -> None: ...
    def SetUnknownVariable(self, arg0: DoubleVariable) -> None: ...
    def SetVolumeSourceVariable(self, arg0: DoubleVariable) -> None: ...

class RadiationSettingsVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class RayleighQuotientIterationEigenvalueSolver(LinearSolver):
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: int, arg3: LinearSolver, arg4: float) -> None: ...
    @overload
    def __init__(self, arg0, arg1: LinearSolver) -> None: ...

class ReadMaterialsUtility:
    @overload
    def __init__(self, arg0: Model) -> None: ...
    @overload
    def __init__(self, arg0, arg1: Model) -> None: ...
    def AssignConstitutiveLawToProperty(self, arg0, arg1: Properties) -> None: ...
    def AssignMaterialToProperty(self, arg0, arg1: Properties) -> None: ...
    def AssignTablesToProperty(self, arg0, arg1: Properties) -> None: ...
    def AssignVariablesToProperty(self, arg0, arg1: Properties) -> None: ...
    def ReadMaterials(self, arg0) -> None: ...

class RegistryItem:
    def __init__(self, *args, **kwargs) -> None: ...
    def HasItems(self) -> bool: ...
    def HasValue(self) -> bool: ...
    def Name(self) -> str: ...
    def keys(self) -> list: ...
    def size(self) -> int: ...
    def __iter__(self) -> Iterator: ...

class ReorderAndOptimizeModelPartProcess(Process):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class ReorderConsecutiveModelPartIO(ModelPartIO):
    @overload
    def __init__(self, arg0: os.PathLike) -> None: ...
    @overload
    def __init__(self, arg0: os.PathLike, arg1: Flags) -> None: ...

class Reorderer:
    def __init__(self) -> None: ...
    def Initialize(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...
    def InverseReorder(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...
    def Reorder(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...

class ReplaceElementsAndConditionsProcess(Process):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class ResidualBasedAdjointBossakScheme(Scheme):
    def __init__(self, arg0, arg1) -> None: ...

class ResidualBasedAdjointStaticScheme(Scheme):
    def __init__(self, arg0) -> None: ...
    def SetResponseFunction(self, new_response_function) -> None: ...

class ResidualBasedAdjointSteadyScheme(ResidualBasedAdjointStaticScheme):
    def __init__(self, arg0) -> None: ...

class ResidualBasedBDFCustomScheme(Scheme):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1) -> None: ...

class ResidualBasedBDFDisplacementScheme(Scheme):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...

class ResidualBasedBlockBuilderAndSolver(BuilderAndSolver):
    @overload
    def __init__(self, arg0: LinearSolver) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1) -> None: ...

class ResidualBasedBlockBuilderAndSolverWithLagrangeMultiplier(BuilderAndSolver):
    @overload
    def __init__(self, arg0: LinearSolver) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1) -> None: ...

class ResidualBasedBossakDisplacementScheme(Scheme):
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float) -> None: ...

class ResidualBasedEliminationBuilderAndSolver(BuilderAndSolver):
    @overload
    def __init__(self, arg0: LinearSolver, arg1) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver) -> None: ...

class ResidualBasedEliminationBuilderAndSolverWithConstraints(BuilderAndSolver):
    @overload
    def __init__(self, arg0: LinearSolver) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1: bool) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1: bool, arg2: bool) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1) -> None: ...

class ResidualBasedIncrementalUpdateStaticScheme(Scheme):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self) -> None: ...

class ResidualBasedIncrementalUpdateStaticSchemeSlip(ResidualBasedIncrementalUpdateStaticScheme):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: int) -> None: ...

class ResidualBasedLinearStrategy(ImplicitSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: bool, arg4: bool, arg5: bool, arg6: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: BuilderAndSolver, arg3: bool, arg4: bool, arg5: bool, arg6: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: BuilderAndSolver, arg4: bool, arg5: bool, arg6: bool, arg7: bool) -> None: ...
    def GetReformDofSetAtEachStepFlag(self) -> bool: ...
    def GetResidualNorm(self) -> float: ...
    def GetScheme(self) -> Scheme: ...
    def SetBuilderAndSolver(self, arg0: BuilderAndSolver) -> None: ...
    def SetReformDofSetAtEachStepFlag(self, arg0: bool) -> None: ...

class ResidualBasedNewmarkDisplacementScheme(Scheme):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class ResidualBasedNewtonRaphsonStrategy(ImplicitSolvingStrategy):
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4: int, arg5: bool, arg6: bool, arg7: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: ConvergenceCriteria, arg3: BuilderAndSolver, arg4: int, arg5: bool, arg6: bool, arg7: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: ConvergenceCriteria, arg3: BuilderAndSolver, arg4) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4: BuilderAndSolver, arg5: int, arg6: bool, arg7: bool, arg8: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Scheme, arg2: LinearSolver, arg3: ConvergenceCriteria, arg4: BuilderAndSolver, arg5) -> None: ...
    def GetInitializePerformedFlag(self) -> bool: ...
    def GetKeepSystemConstantDuringIterations(self) -> bool: ...
    def GetMaxIterationNumber(self) -> int: ...
    def GetNonconvergedSolutions(self) -> tuple[Matrix, DofsArrayType]: ...
    def GetReformDofSetAtEachStepFlag(self) -> bool: ...
    def GetUseOldStiffnessInFirstIterationFlag(self) -> bool: ...
    def SetInitializePerformedFlag(self, arg0: bool) -> None: ...
    def SetKeepSystemConstantDuringIterations(self, arg0: bool) -> None: ...
    def SetMaxIterationNumber(self, arg0: int) -> None: ...
    def SetReformDofSetAtEachStepFlag(self, arg0: bool) -> None: ...
    def SetUpNonconvergedSolutionsFlag(self, arg0: bool) -> None: ...
    def SetUseOldStiffnessInFirstIterationFlag(self, arg0: bool) -> None: ...

class ResidualBasedPseudoStaticDisplacementScheme(Scheme):
    @overload
    def __init__(self, arg0: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class ResidualCriteria(ConvergenceCriteria):
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: float) -> None: ...

class ResultType:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: GeometricalObject) -> None: ...
    def Get(self) -> GeometricalObject: ...
    def GetDistance(self) -> float: ...
    def IsDistanceCalculated(self) -> bool: ...
    def IsObjectFound(self) -> bool: ...
    def Reset(self) -> None: ...
    def Set(self, arg0: GeometricalObject) -> None: ...
    def SetDistance(self, arg0: float) -> None: ...

class ScalingSolver(LinearSolver):
    @overload
    def __init__(self, arg0: LinearSolver) -> None: ...
    @overload
    def __init__(self, arg0: LinearSolver, arg1: bool) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class Scheme:
    def __init__(self) -> None: ...
    def CalculateOutputData(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def Check(self, arg0: ModelPart) -> int: ...
    def Clean(self) -> None: ...
    def Clear(self) -> None: ...
    def ConditionsAreInitialized(self) -> bool: ...
    def Create(self, arg0) -> Scheme: ...
    def ElementsAreInitialized(self) -> bool: ...
    def FinalizeNonLinIteration(self, arg0: ModelPart, arg1: CompressedMatrix, arg2: Vector, arg3: Vector) -> None: ...
    def FinalizeSolutionStep(self, arg0: ModelPart, arg1: CompressedMatrix, arg2: Vector, arg3: Vector) -> None: ...
    def GetDefaultParameters(self, *args, **kwargs): ...
    def Info(self) -> str: ...
    def Initialize(self, arg0: ModelPart) -> None: ...
    def InitializeConditions(self, arg0: ModelPart) -> None: ...
    def InitializeElements(self, arg0: ModelPart) -> None: ...
    def InitializeNonLinIteration(self, arg0: ModelPart, arg1: CompressedMatrix, arg2: Vector, arg3: Vector) -> None: ...
    def InitializeSolutionStep(self, arg0: ModelPart, arg1: CompressedMatrix, arg2: Vector, arg3: Vector) -> None: ...
    def MoveMesh(self, arg0: NodesArray) -> None: ...
    def Predict(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...
    def SchemeIsInitialized(self) -> bool: ...
    def Update(self, arg0: ModelPart, arg1: DofsArrayType, arg2: CompressedMatrix, arg3: Vector, arg4: Vector) -> None: ...

class SensitivityBuilder:
    @overload
    def __init__(self, arg0, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0, arg1: ModelPart, arg2, arg3: SensitivityBuilderScheme) -> None: ...
    def Finalize(self) -> None: ...
    def FinalizeSolutionStep(self) -> None: ...
    def Initialize(self) -> None: ...
    def InitializeSolutionStep(self) -> None: ...
    def SetResponseFunction(self, new_response_function) -> None: ...
    def UpdateSensitivities(self) -> None: ...

class SensitivityBuilderScheme:
    def __init__(self) -> None: ...
    def Check(self, arg0: ModelPart, arg1: ModelPart) -> int: ...
    def Clear(self) -> None: ...
    def Finalize(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    def FinalizeSolutionStep(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    def Info(self) -> str: ...
    def Initialize(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    def InitializeSolutionStep(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    def Update(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...

class SensitivityUtilities:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def AssignConditionDerivativesToNodes(arg0: ModelPart, arg1: int, arg2: MatrixVariable, arg3: dict[int, list[int]], arg4: float, arg5: Flags, arg6: bool) -> None: ...
    @staticmethod
    def AssignElementDerivativesToNodes(arg0: ModelPart, arg1: int, arg2: MatrixVariable, arg3: dict[int, list[int]], arg4: float, arg5: Flags, arg6: bool) -> None: ...

class SerialModelPartCombinatorModeler(Modeler):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Model, arg1) -> None: ...

class Serializer:
    MPI: ClassVar[Flags] = ...
    SHALLOW_GLOBAL_POINTERS_SERIALIZATION: ClassVar[Flags] = ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1) -> None: ...
    @overload
    def Load(self, arg0: str, arg1: ModelPart) -> None: ...
    @overload
    def Load(self, arg0: str, arg1) -> None: ...
    @overload
    def Load(self, arg0: str, arg1: Model) -> None: ...
    @overload
    def Load(self, arg0: str, arg1: Flags) -> None: ...
    @overload
    def LoadFromBeginning(self, arg0: str, arg1: ModelPart) -> None: ...
    @overload
    def LoadFromBeginning(self, arg0: str, arg1) -> None: ...
    @overload
    def LoadFromBeginning(self, arg0: str, arg1: Model) -> None: ...
    @overload
    def LoadFromBeginning(self, arg0: str, arg1: Flags) -> None: ...
    def Print(self) -> None: ...
    @overload
    def Save(self, arg0: str, arg1: ModelPart) -> None: ...
    @overload
    def Save(self, arg0: str, arg1) -> None: ...
    @overload
    def Save(self, arg0: str, arg1: Model) -> None: ...
    @overload
    def Save(self, arg0: str, arg1: Flags) -> None: ...
    def Set(self, arg0: Flags) -> None: ...

class SerializerTraceType:
    __members__: ClassVar[dict] = ...  # read-only
    SERIALIZER_NO_TRACE: ClassVar[SerializerTraceType] = ...
    SERIALIZER_TRACE_ALL: ClassVar[SerializerTraceType] = ...
    SERIALIZER_TRACE_ERROR: ClassVar[SerializerTraceType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class SetInitialStateProcess2D(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Vector, arg2: Vector, arg3: Matrix) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Vector, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Matrix) -> None: ...

class SetInitialStateProcess3D(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Vector, arg2: Vector, arg3: Matrix) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Vector, arg2: int) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: Matrix) -> None: ...

class ShiftedBoundaryMeshlessInterfaceUtility:
    def __init__(self, arg0: Model, arg1) -> None: ...
    def CalculateExtensionOperator(self) -> None: ...

class SignedDistanceCalculationUtils2D:
    def __init__(self) -> None: ...
    def CalculateDistances(self, arg0: ModelPart, arg1: DoubleVariable, arg2: float) -> None: ...
    def FindMaximumEdgeSize(self, arg0: ModelPart) -> float: ...

class SignedDistanceCalculationUtils3D:
    def __init__(self) -> None: ...
    def CalculateDistances(self, arg0: ModelPart, arg1: DoubleVariable, arg2: float) -> None: ...
    def FindMaximumEdgeSize(self, arg0: ModelPart) -> float: ...

class SimpleMortarMapperProcess(Process):
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...

class SimpleMortarMapperProcess2D2NDouble(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable, arg4) -> None: ...
    def Map(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess2D2NVector(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4) -> None: ...
    def Map(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D3N4NDouble(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable, arg4) -> None: ...
    def Map(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D3N4NVector(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4) -> None: ...
    def Map(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D3NDouble(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable, arg4) -> None: ...
    def Map(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D3NVector(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4) -> None: ...
    def Map(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D4N3NDouble(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable, arg4) -> None: ...
    def Map(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D4N3NVector(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4) -> None: ...
    def Map(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D4NDouble(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: DoubleVariable, arg3: DoubleVariable, arg4) -> None: ...
    def Map(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: Flags) -> None: ...

class SimpleMortarMapperProcess3D4NVector(Process):
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: ModelPart, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4) -> None: ...
    def Map(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: Flags) -> None: ...

class SkinDetectionProcess2D(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class SkinDetectionProcess3D(Process):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class SkylineLUFactorizationSolver(DirectSolver):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...

class SlipConstraint(LinearMasterSlaveConstraint):
    @overload
    def __init__(self, arg0: int, arg1: Dof, arg2: Dof, arg3: Array3) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: Dof, arg2: Dof, arg3: Dof, arg4: Array3) -> None: ...

class SparseContiguousRowGraph:
    def __init__(self, arg0: int) -> None: ...
    @overload
    def AddEntries(self, arg0: list[int]) -> None: ...
    @overload
    def AddEntries(self, arg0: list[int], arg1: list[int]) -> None: ...
    def AddEntry(self, arg0: int, arg1: int) -> None: ...
    def ExportSingleVectorRepresentation(self) -> list[int]: ...
    def Finalize(self) -> None: ...
    def GetComm(self) -> DataCommunicator: ...
    def GetGraph(self, *args, **kwargs): ...
    def Size(self) -> int: ...

class SparseGraph:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def AddEntries(self, arg0: list[int]) -> None: ...
    @overload
    def AddEntries(self, arg0: list[int], arg1: list[int]) -> None: ...
    def AddEntry(self, arg0: int, arg1: int) -> None: ...
    def ExportSingleVectorRepresentation(self) -> list[int]: ...
    def Finalize(self) -> None: ...
    def GetComm(self) -> DataCommunicator: ...
    def GetGraph(self) -> dict[int, Set[int]]: ...
    def IsEmpty(self) -> bool: ...
    def Size(self) -> int: ...

class SparseMatrixMultiplicationUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def MatrixAdd(arg0: CompressedMatrix, arg1: CompressedMatrix, arg2: float) -> None: ...
    @staticmethod
    def MatrixMultiplication(arg0: CompressedMatrix, arg1: CompressedMatrix, arg2: CompressedMatrix) -> None: ...
    @staticmethod
    def MatrixMultiplicationRMerge(arg0: CompressedMatrix, arg1: CompressedMatrix, arg2: CompressedMatrix) -> None: ...
    @staticmethod
    def MatrixMultiplicationSaad(arg0: CompressedMatrix, arg1: CompressedMatrix, arg2: CompressedMatrix) -> None: ...
    @staticmethod
    def TransposeMatrix(arg0: CompressedMatrix, arg1: CompressedMatrix, arg2: float) -> None: ...

class SpatialSearch:
    def __init__(self) -> None: ...
    @overload
    def SearchConditionsInRadiusExclusive(self, arg0: ModelPart, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchConditionsInRadiusExclusive(self, arg0: ModelPart, arg1: ConditionsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchConditionsInRadiusExclusive(self, arg0: ConditionsArray, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchConditionsInRadiusExclusive(self, arg0: ConditionsArray, arg1: ConditionsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchConditionsInRadiusInclusive(self, arg0: ModelPart, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchConditionsInRadiusInclusive(self, arg0: ModelPart, arg1: ConditionsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchConditionsInRadiusInclusive(self, arg0: ConditionsArray, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchConditionsInRadiusInclusive(self, arg0: ConditionsArray, arg1: ConditionsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusExclusive(self, arg0: ModelPart, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusExclusive(self, arg0: ModelPart, arg1: ElementsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusExclusive(self, arg0: ElementsArray, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusExclusive(self, arg0: ElementsArray, arg1: ElementsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusInclusive(self, arg0: ModelPart, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusInclusive(self, arg0: ModelPart, arg1: ElementsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusInclusive(self, arg0: ElementsArray, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchElementsInRadiusInclusive(self, arg0: ElementsArray, arg1: ElementsArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusExclusive(self, arg0: ModelPart, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusExclusive(self, arg0: ModelPart, arg1: NodesArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusExclusive(self, arg0: NodesArray, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusExclusive(self, arg0: NodesArray, arg1: NodesArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusInclusive(self, arg0: ModelPart, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusInclusive(self, arg0: ModelPart, arg1: NodesArray, arg2: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusInclusive(self, arg0: NodesArray, arg1: list) -> tuple[list, list]: ...
    @overload
    def SearchNodesInRadiusInclusive(self, arg0: NodesArray, arg1: NodesArray, arg2: list) -> tuple[list, list]: ...

class SpatialSearchBinsDynamic(SpatialSearch):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Parameters) -> None: ...

class SpatialSearchBinsStatic(SpatialSearch):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Parameters) -> None: ...

class SpatialSearchKDTree(SpatialSearch):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Parameters) -> None: ...

class SpatialSearchOctree(SpatialSearch):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Parameters) -> None: ...

class SpecializedSpatialSearch(SpatialSearch):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Parameters) -> None: ...

class SplitInternalInterfacesProcess(Process):
    def __init__(self, arg0, arg1) -> None: ...

class StlIO(IO):
    @overload
    def __init__(self, arg0: os.PathLike) -> None: ...
    @overload
    def __init__(self, arg0: os.PathLike, arg1) -> None: ...
    def ReadModelPart(self, arg0: ModelPart) -> None: ...
    def WriteModelPart(self, arg0: ModelPart) -> None: ...

class StrainMeasure:
    __members__: ClassVar[dict] = ...  # read-only
    StrainMeasure_Deformation_Gradient: ClassVar[StrainMeasure] = ...
    StrainMeasure_GreenLagrange: ClassVar[StrainMeasure] = ...
    StrainMeasure_Hencky_Material: ClassVar[StrainMeasure] = ...
    StrainMeasure_Hencky_Spatial: ClassVar[StrainMeasure] = ...
    StrainMeasure_Infinitesimal: ClassVar[StrainMeasure] = ...
    StrainMeasure_Left_CauchyGreen: ClassVar[StrainMeasure] = ...
    StrainMeasure_Right_CauchyGreen: ClassVar[StrainMeasure] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class StreamSerializer(Serializer):
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: str) -> None: ...
    @overload
    def __init__(self, arg0) -> None: ...
    @overload
    def __init__(self, arg0: str, arg1) -> None: ...

class StressMeasure:
    __members__: ClassVar[dict] = ...  # read-only
    StressMeasure_Cauchy: ClassVar[StressMeasure] = ...
    StressMeasure_Kirchhoff: ClassVar[StressMeasure] = ...
    StressMeasure_PK1: ClassVar[StressMeasure] = ...
    StressMeasure_PK2: ClassVar[StressMeasure] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class StringVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class StructuredMeshGeneratorProcess(Process):
    def __init__(self, arg0, arg1: ModelPart, arg2) -> None: ...

class SubModelPartConditionsBooleanOperationUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def Difference(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Intersection(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Union(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...

class SubModelPartConstraintsBooleanOperationUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def Difference(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Intersection(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Union(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...

class SubModelPartElementsBooleanOperationUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def Difference(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Intersection(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Union(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...

class SubModelPartNodesBooleanOperationUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def Difference(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Intersection(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @staticmethod
    def Union(arg0: ModelPart, arg1: ModelPart, arg2: ModelPart) -> None: ...

class SubModelPartSkinDetectionProcess2D(SkinDetectionProcess2D):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class SubModelPartSkinDetectionProcess3D(SkinDetectionProcess3D):
    def __init__(self, arg0: ModelPart, arg1) -> None: ...

class SubModelPartsContainerType:
    def __init__(self, *args, **kwargs) -> None: ...
    def __iter__(self) -> Iterator: ...

class SurfaceInNurbsVolumeGeometry(Geometry):
    def __init__(self, arg0: NurbsVolumeGeometry, arg1: Geometry) -> None: ...

class SystemVector:
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: DataCommunicator) -> None: ...
    @overload
    def __init__(self, arg0: SparseGraph) -> None: ...
    @overload
    def __init__(self, arg0: SparseContiguousRowGraph) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    def Add(self, arg0: float, arg1: SystemVector) -> None: ...
    def Assemble(self, arg0: Vector, arg1: list[int]) -> None: ...
    def Assign(self, arg0: SystemVector) -> None: ...
    @overload
    def BeginAssemble(self) -> None: ...
    @overload
    def BeginAssemble(self) -> None: ...
    def Clear(self) -> None: ...
    def Data(self) -> Vector: ...
    def FinalizeAssemble(self) -> None: ...
    def GetComm(self) -> DataCommunicator: ...
    def SetData(self, arg0: Vector) -> None: ...
    def SetValue(self, arg0: float) -> None: ...
    def Size(self) -> int: ...
    def copy(self) -> SystemVector: ...
    def size(self) -> int: ...
    def __add__(self, arg0: SystemVector) -> SystemVector: ...
    @overload
    def __getitem__(self, arg0: int) -> float: ...
    @overload
    def __getitem__(self, arg0: int) -> float: ...
    def __iter__(self) -> typing.Iterator[float]: ...
    def __iadd__(self, arg0: SystemVector) -> SystemVector: ...
    def __imul__(self, arg0: float) -> SystemVector: ...
    def __isub__(self, arg0: SystemVector) -> SystemVector: ...
    def __itruediv__(self, arg0: float) -> SystemVector: ...
    def __mul__(self, arg0: float) -> SystemVector: ...
    def __rmul__(self, arg0: float) -> SystemVector: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    def __sub__(self, arg0: SystemVector) -> SystemVector: ...

class TFQMRSolver(IterativeSolver):
    @overload
    def __init__(self, arg0: float) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int) -> None: ...
    @overload
    def __init__(self, arg0: float, arg1: int, arg2: Preconditioner) -> None: ...
    @overload
    def __init__(self, arg0, arg1: Preconditioner) -> None: ...

class TableStreamUtility:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: bool) -> None: ...
    def SetOnProcessInfo(self, arg0) -> None: ...

class Tester:
    class Verbosity:
        __members__: ClassVar[dict] = ...  # read-only
        FAILED_TESTS_OUTPUTS: ClassVar[Tester.Verbosity] = ...
        PROGRESS: ClassVar[Tester.Verbosity] = ...
        QUITE: ClassVar[Tester.Verbosity] = ...
        TESTS_LIST: ClassVar[Tester.Verbosity] = ...
        TESTS_OUTPUTS: ClassVar[Tester.Verbosity] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    def __init__(self, *args, **kwargs) -> None: ...
    @staticmethod
    def ListOfAllTestCases() -> None: ...
    @staticmethod
    def NumberOfFailedTestCases() -> int: ...
    @staticmethod
    def ProfileAllDistributedTestCases() -> int: ...
    @staticmethod
    def ProfileAllTestCases() -> int: ...
    @staticmethod
    def ProfileTestSuite(arg0: str) -> int: ...
    @staticmethod
    def ResetAllTestCasesResults() -> None: ...
    @staticmethod
    def RunAllDistributedTestCases() -> int: ...
    @staticmethod
    def RunAllTestCases() -> int: ...
    @staticmethod
    def RunTestCases(arg0: str) -> int: ...
    @staticmethod
    def RunTestSuite(arg0: str) -> int: ...
    @staticmethod
    def SetVerbosity(arg0) -> None: ...

class Tetrahedra3D10(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node, arg6: Node, arg7: Node, arg8: Node, arg9: Node) -> None: ...

class Tetrahedra3D4(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node) -> None: ...

class TetrahedralMeshOrientationCheck(Process):
    ASSIGN_NEIGHBOUR_ELEMENTS_TO_CONDITIONS: ClassVar[Flags] = ...
    COMPUTE_CONDITION_NORMALS: ClassVar[Flags] = ...
    COMPUTE_NODAL_NORMALS: ClassVar[Flags] = ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1: bool, arg2: Flags) -> None: ...
    def SwapAll(self) -> None: ...
    def SwapNegativeElements(self) -> None: ...

class TimeAveragingProcess(Process):
    def __init__(self, arg0, arg1) -> None: ...

class Timer:
    PrintIntervalInformation: bool
    PrintOnScreen: bool
    def __init__(self) -> None: ...
    @staticmethod
    def CloseOuputFile() -> int: ...
    @staticmethod
    def GetPrintIntervalInformation() -> bool: ...
    @staticmethod
    def GetPrintOnScreen() -> bool: ...
    @staticmethod
    def GetTime() -> float: ...
    @overload
    @staticmethod
    def PrintTimingInformation() -> None: ...
    @overload
    @staticmethod
    def PrintTimingInformation(arg0: Timer) -> None: ...
    @staticmethod
    def SetOuputFile(arg0: str) -> int: ...
    @staticmethod
    def SetPrintIntervalInformation(arg0: bool) -> None: ...
    @staticmethod
    def SetPrintOnScreen(arg0: bool) -> None: ...
    @staticmethod
    def Start(arg0: str) -> None: ...
    @staticmethod
    def Stop(arg0: str) -> None: ...

class Triangle2D3(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node) -> None: ...

class Triangle2D6(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node) -> None: ...

class Triangle3D3(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node) -> None: ...

class Triangle3D6(Geometry):
    def __init__(self, arg0: Node, arg1: Node, arg2: Node, arg3: Node, arg4: Node, arg5: Node) -> None: ...

class UblasComplexSparseSpace:
    def __init__(self) -> None: ...
    def ClearMatrix(self, arg0: ComplexCompressedMatrix) -> None: ...
    def ClearVector(self, arg0: ComplexVector) -> None: ...
    def CreateEmptyMatrixPointer(self) -> ComplexCompressedMatrix: ...
    def CreateEmptyVectorPointer(self) -> ComplexVector: ...
    def Mult(self, arg0: ComplexCompressedMatrix, arg1: ComplexVector, arg2: ComplexVector) -> None: ...
    def ResizeMatrix(self, arg0: ComplexCompressedMatrix, arg1: int, arg2: int) -> None: ...
    def ResizeVector(self, arg0: ComplexVector, arg1: int) -> None: ...
    def ScaleAndAdd(self, arg0: float, arg1: ComplexVector, arg2: float, arg3: ComplexVector) -> None: ...
    def SetToZeroMatrix(self, arg0: ComplexCompressedMatrix) -> None: ...
    def SetToZeroVector(self, arg0: ComplexVector) -> None: ...
    def Size(self, arg0: ComplexVector) -> int: ...
    def Size1(self, arg0: ComplexCompressedMatrix) -> int: ...
    def Size2(self, arg0: ComplexCompressedMatrix) -> int: ...
    def UnaliasedAdd(self, arg0: ComplexVector, arg1: float, arg2: ComplexVector) -> None: ...

class UblasSparseSpace:
    def __init__(self) -> None: ...
    def ClearMatrix(self, arg0: CompressedMatrix) -> None: ...
    def ClearVector(self, arg0: Vector) -> None: ...
    def CreateEmptyMatrixPointer(self) -> CompressedMatrix: ...
    def CreateEmptyVectorPointer(self) -> Vector: ...
    def Dot(self, arg0: Vector, arg1: Vector) -> float: ...
    def FastestDirectSolverList(self) -> list[str]: ...
    def IsDistributed(self) -> bool: ...
    def Mult(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...
    def ResizeMatrix(self, arg0: CompressedMatrix, arg1: int, arg2: int) -> None: ...
    def ResizeVector(self, arg0: Vector, arg1: int) -> None: ...
    def ScaleAndAdd(self, arg0: float, arg1: Vector, arg2: float, arg3: Vector) -> None: ...
    def SetToZeroMatrix(self, arg0: CompressedMatrix) -> None: ...
    def SetToZeroVector(self, arg0: Vector) -> None: ...
    @overload
    def Size(self, arg0: Vector) -> int: ...
    @overload
    def Size(self) -> int: ...
    @overload
    def Size1(self, arg0: CompressedMatrix) -> int: ...
    @overload
    def Size1(self) -> int: ...
    @overload
    def Size2(self, arg0: CompressedMatrix) -> int: ...
    @overload
    def Size2(self) -> int: ...
    def TransposeMult(self, arg0: CompressedMatrix, arg1: Vector, arg2: Vector) -> None: ...
    def TwoNorm(self, arg0: Vector) -> float: ...
    def UnaliasedAdd(self, arg0: Vector, arg1: float, arg2: Vector) -> None: ...

class UnvOutput:
    def __init__(self, arg0: ModelPart, arg1: str) -> None: ...
    def InitializeMesh(self) -> None: ...
    @overload
    def PrintOutput(self, arg0: BoolVariable, arg1: float) -> None: ...
    @overload
    def PrintOutput(self, arg0: IntegerVariable, arg1: float) -> None: ...
    @overload
    def PrintOutput(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def PrintOutput(self, arg0: Array1DVariable3, arg1: float) -> None: ...
    def WriteMesh(self) -> None: ...

class VariableData:
    def __init__(self, *args, **kwargs) -> None: ...
    def GetComponentIndex(self) -> int: ...
    def GetSourceVariable(self) -> VariableData: ...
    def IsComponent(self) -> bool: ...
    def Key(self) -> int: ...
    def Name(self) -> str: ...

class VariableRedistributionUtility:
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPoint(arg0: ModelPart, arg1: DoubleVariable, arg2: DoubleVariable) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPoint(arg0: ModelPart, arg1: ElementsArray, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPoint(arg0: ModelPart, arg1: ConditionsArray, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPoint(arg0: ModelPart, arg1: Array1DVariable3, arg2: Array1DVariable3) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPoint(arg0: ModelPart, arg1: ElementsArray, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPoint(arg0: ModelPart, arg1: ConditionsArray, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPointNonHistorical(arg0: ModelPart, arg1: ElementsArray, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPointNonHistorical(arg0: ModelPart, arg1: ConditionsArray, arg2: DoubleVariable, arg3: DoubleVariable) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPointNonHistorical(arg0: ModelPart, arg1: ElementsArray, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    @staticmethod
    def ConvertDistributedValuesToPointNonHistorical(arg0: ModelPart, arg1: ConditionsArray, arg2: Array1DVariable3, arg3: Array1DVariable3) -> None: ...
    @overload
    @staticmethod
    def DistributePointValues(arg0: ModelPart, arg1: DoubleVariable, arg2: DoubleVariable, arg3: float, arg4: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValues(arg0: ModelPart, arg1: ElementsArray, arg2: DoubleVariable, arg3: DoubleVariable, arg4: float, arg5: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValues(arg0: ModelPart, arg1: ConditionsArray, arg2: DoubleVariable, arg3: DoubleVariable, arg4: float, arg5: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValues(arg0: ModelPart, arg1: Array1DVariable3, arg2: Array1DVariable3, arg3: float, arg4: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValues(arg0: ModelPart, arg1: ElementsArray, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4: float, arg5: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValues(arg0: ModelPart, arg1: ConditionsArray, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4: float, arg5: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValuesNonHistorical(arg0: ModelPart, arg1: ElementsArray, arg2: DoubleVariable, arg3: DoubleVariable, arg4: float, arg5: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValuesNonHistorical(arg0: ModelPart, arg1: ConditionsArray, arg2: DoubleVariable, arg3: DoubleVariable, arg4: float, arg5: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValuesNonHistorical(arg0: ModelPart, arg1: ElementsArray, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4: float, arg5: float) -> None: ...
    @overload
    @staticmethod
    def DistributePointValuesNonHistorical(arg0: ModelPart, arg1: ConditionsArray, arg2: Array1DVariable3, arg3: Array1DVariable3, arg4: float, arg5: float) -> None: ...

class VariableUtils:
    def __init__(self) -> None: ...
    @overload
    def AddDof(self, arg0: DoubleVariable, arg1: ModelPart) -> None: ...
    @overload
    def AddDof(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart) -> None: ...
    @overload
    @staticmethod
    def AddDofsList(arg0: list[str], arg1: ModelPart) -> None: ...
    @overload
    @staticmethod
    def AddDofsList(arg0: list[list[str[2]]], arg1: ModelPart) -> None: ...
    @overload
    def ApplyFixity(self, arg0: DoubleVariable, arg1: bool, arg2: NodesArray) -> None: ...
    @overload
    def ApplyFixity(self, arg0: DoubleVariable, arg1: bool, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    def ApplyVector(self, arg0: DoubleVariable, arg1: Vector, arg2: NodesArray) -> None: ...
    def CheckVariableKeys(self) -> bool: ...
    @overload
    def ClearNonHistoricalData(self, arg0: NodesArray) -> None: ...
    @overload
    def ClearNonHistoricalData(self, arg0: ConditionsArray) -> None: ...
    @overload
    def ClearNonHistoricalData(self, arg0: ElementsArray) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: DoubleQuaternionVariable, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartElementalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedConditionVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedElementVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int, arg7: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToHistoricalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalHistoricalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool, arg6: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool, arg5: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToHistoricalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: Flags, arg3: bool, arg4: int) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: Flags, arg5: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartFlaggedNodalNonHistoricalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: DoubleQuaternionVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: IntegerVariable, arg1: IntegerVariable, arg2: ModelPart, arg3: ModelPart, arg4: int, arg5: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: int, arg5: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: int, arg5: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: DoubleQuaternionVariable, arg1: DoubleQuaternionVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: DoubleQuaternionVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: ModelPart, arg2: ModelPart, arg3: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: DoubleQuaternionVariable, arg1: DoubleQuaternionVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    @overload
    def CopyModelPartNodalVarToNonHistoricalVar(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ModelPart, arg3: ModelPart, arg4: int) -> None: ...
    def CopyScalarVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: BoolVariable, arg1: BoolVariable, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: VectorVariable, arg1: VectorVariable, arg2: NodesArray) -> None: ...
    @overload
    def CopyVariable(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: NodesArray) -> None: ...
    def CopyVectorVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: BoolVariable, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: IntegerVariable, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: DoubleVariable, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: VectorVariable, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: MatrixVariable, arg1: NodesArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: BoolVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: IntegerVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: DoubleVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: VectorVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: MatrixVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: BoolVariable, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: IntegerVariable, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: DoubleVariable, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: VectorVariable, arg1: ElementsArray) -> None: ...
    @overload
    def EraseNonHistoricalVariable(self, arg0: MatrixVariable, arg1: ElementsArray) -> None: ...
    @overload
    def FlipFlag(self, arg0: Flags, arg1: NodesArray) -> None: ...
    @overload
    def FlipFlag(self, arg0: Flags, arg1: ConditionsArray) -> None: ...
    @overload
    def FlipFlag(self, arg0: Flags, arg1: ElementsArray) -> None: ...
    @overload
    def FlipFlag(self, arg0: Flags, arg1: MasterSlaveConstraintsArray) -> None: ...
    def GetCurrentPositionsVector(self, arg0: NodesArray, arg1: int) -> Vector: ...
    def GetInitialPositionsVector(self, arg0: NodesArray, arg1: int) -> Vector: ...
    @overload
    def GetSolutionStepValuesVector(self, arg0: NodesArray, arg1: Array1DVariable3, arg2: int, arg3: int) -> Vector: ...
    @overload
    def GetSolutionStepValuesVector(self, arg0: NodesArray, arg1: DoubleVariable, arg2: int) -> Vector: ...
    @overload
    def GetValuesVector(self, arg0: NodesArray, arg1: Array1DVariable3, arg2: int) -> Vector: ...
    @overload
    def GetValuesVector(self, arg0: NodesArray, arg1: DoubleVariable) -> Vector: ...
    @overload
    def ResetFlag(self, arg0: Flags, arg1: NodesArray) -> None: ...
    @overload
    def ResetFlag(self, arg0: Flags, arg1: ConditionsArray) -> None: ...
    @overload
    def ResetFlag(self, arg0: Flags, arg1: ElementsArray) -> None: ...
    @overload
    def ResetFlag(self, arg0: Flags, arg1: MasterSlaveConstraintsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: BoolVariable, arg1: BoolVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: VectorVariable, arg1: VectorVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ConditionsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: BoolVariable, arg1: BoolVariable, arg2: ElementsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: ElementsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: ElementsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: ElementsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: ElementsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: ElementsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: VectorVariable, arg1: VectorVariable, arg2: ElementsArray) -> None: ...
    @overload
    def SaveNonHistoricalVariable(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: ElementsArray) -> None: ...
    def SaveScalarNonHistoricalVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: NodesArray) -> None: ...
    def SaveScalarVar(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: BoolVariable, arg1: BoolVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: DoubleVariable, arg1: DoubleVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: Array1DVariable4, arg1: Array1DVariable4, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: Array1DVariable6, arg1: Array1DVariable6, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: Array1DVariable9, arg1: Array1DVariable9, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: VectorVariable, arg1: VectorVariable, arg2: NodesArray) -> None: ...
    @overload
    def SaveVariable(self, arg0: MatrixVariable, arg1: MatrixVariable, arg2: NodesArray) -> None: ...
    def SaveVectorNonHistoricalVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: NodesArray) -> None: ...
    def SaveVectorVar(self, arg0: Array1DVariable3, arg1: Array1DVariable3, arg2: NodesArray) -> None: ...
    def SelectNodeList(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray) -> NodesArray: ...
    def SetCurrentPositionsVector(self, arg0: NodesArray, arg1: Vector) -> None: ...
    @overload
    def SetFlag(self, arg0: Flags, arg1: bool, arg2: NodesArray) -> None: ...
    @overload
    def SetFlag(self, arg0: Flags, arg1: bool, arg2: ConditionsArray) -> None: ...
    @overload
    def SetFlag(self, arg0: Flags, arg1: bool, arg2: ElementsArray) -> None: ...
    @overload
    def SetFlag(self, arg0: Flags, arg1: bool, arg2: MasterSlaveConstraintsArray) -> None: ...
    @overload
    def SetHistoricalVariableToZero(self, arg0: IntegerVariable, arg1: NodesArray) -> None: ...
    @overload
    def SetHistoricalVariableToZero(self, arg0: DoubleVariable, arg1: NodesArray) -> None: ...
    @overload
    def SetHistoricalVariableToZero(self, arg0: Array1DVariable3, arg1: NodesArray) -> None: ...
    def SetInitialPositionsVector(self, arg0: NodesArray, arg1: Vector) -> None: ...
    @overload
    def SetNonHistoricalScalarVar(self, arg0: IntegerVariable, arg1: int, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalScalarVar(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: IntegerVariable, arg1: int, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: BoolVariable, arg1: bool, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array4, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array6, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array9, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: VectorVariable, arg1: Vector, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: BoolVariable, arg1: bool, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleVariable, arg1: float, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array4, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array6, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array9, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: VectorVariable, arg1: Vector, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: BoolVariable, arg1: bool, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleVariable, arg1: float, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array4, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array6, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array9, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: VectorVariable, arg1: Vector, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: BoolVariable, arg1: bool, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array4, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array6, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array9, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: VectorVariable, arg1: Vector, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: BoolVariable, arg1: bool, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleVariable, arg1: float, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array4, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array6, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array9, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: VectorVariable, arg1: Vector, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: ConditionsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: BoolVariable, arg1: bool, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleVariable, arg1: float, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable4, arg1: Array4, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable6, arg1: Array6, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: Array1DVariable9, arg1: Array9, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: VectorVariable, arg1: Vector, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: ElementsArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: IntegerVariable, arg1: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: DoubleVariable, arg1: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: DoubleVariable, arg1: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: IntegerVariable, arg1: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: DoubleVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: IntegerVariable, arg1: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: DoubleVariable, arg1: MasterSlaveConstraintsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable3, arg1: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable3, arg1: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable3, arg1: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable3, arg1: MasterSlaveConstraintsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable4, arg1: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable4, arg1: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable4, arg1: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable4, arg1: MasterSlaveConstraintsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable6, arg1: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable6, arg1: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable6, arg1: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable6, arg1: MasterSlaveConstraintsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable9, arg1: NodesArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable9, arg1: ElementsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable9, arg1: ConditionsArray) -> None: ...
    @overload
    def SetNonHistoricalVariableToZero(self, arg0: Array1DVariable9, arg1: MasterSlaveConstraintsArray) -> None: ...
    def SetNonHistoricalVectorVar(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray) -> None: ...
    @overload
    def SetScalarVar(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray) -> None: ...
    @overload
    def SetScalarVar(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetScalarVar(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetSolutionStepValuesVector(self, arg0: NodesArray, arg1: Array1DVariable3, arg2: Vector, arg3: int) -> None: ...
    @overload
    def SetSolutionStepValuesVector(self, arg0: NodesArray, arg1: DoubleVariable, arg2: Vector, arg3: int) -> None: ...
    @overload
    def SetValuesVector(self, arg0: NodesArray, arg1: Array1DVariable3, arg2: Vector) -> None: ...
    @overload
    def SetValuesVector(self, arg0: NodesArray, arg1: DoubleVariable, arg2: Vector) -> None: ...
    @overload
    def SetVariable(self, arg0: IntegerVariable, arg1: int, arg2: NodesArray) -> None: ...
    @overload
    def SetVariable(self, arg0: BoolVariable, arg1: bool, arg2: NodesArray) -> None: ...
    @overload
    def SetVariable(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray) -> None: ...
    @overload
    def SetVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray) -> None: ...
    @overload
    def SetVariable(self, arg0: VectorVariable, arg1: Vector, arg2: NodesArray) -> None: ...
    @overload
    def SetVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: NodesArray) -> None: ...
    @overload
    def SetVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: NodesArray) -> None: ...
    @overload
    def SetVariable(self, arg0: IntegerVariable, arg1: int, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVariable(self, arg0: BoolVariable, arg1: bool, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVariable(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVariable(self, arg0: VectorVariable, arg1: Vector, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVariable(self, arg0: BoolVariable, arg1: bool, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: DoubleVariable, arg1: float, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: Array1DVariable4, arg1: Array4, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: Array1DVariable6, arg1: Array6, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: Array1DVariable9, arg1: Array9, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: VectorVariable, arg1: Vector, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: MatrixVariable, arg1: Matrix, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVariable(self, arg0: DoubleQuaternionVariable, arg1: Quaternion, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    @overload
    def SetVectorVar(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray) -> None: ...
    @overload
    def SetVectorVar(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray, arg3: int) -> None: ...
    @overload
    def SetVectorVar(self, arg0: Array1DVariable3, arg1: Array3, arg2: NodesArray, arg3: Flags, arg4: bool) -> None: ...
    def SumConditionScalarVariable(self, arg0: DoubleVariable, arg1: ModelPart) -> float: ...
    def SumConditionVectorVariable(self, arg0: Array1DVariable3, arg1: ModelPart) -> Array3: ...
    def SumElementScalarVariable(self, arg0: DoubleVariable, arg1: ModelPart) -> float: ...
    def SumElementVectorVariable(self, arg0: Array1DVariable3, arg1: ModelPart) -> Array3: ...
    def SumHistoricalNodeScalarVariable(self, arg0: DoubleVariable, arg1: ModelPart, arg2: int) -> float: ...
    def SumHistoricalNodeVectorVariable(self, arg0: Array1DVariable3, arg1: ModelPart, arg2: int) -> Array3: ...
    def SumNonHistoricalNodeScalarVariable(self, arg0: DoubleVariable, arg1: ModelPart) -> float: ...
    def SumNonHistoricalNodeVectorVariable(self, arg0: Array1DVariable3, arg1: ModelPart) -> Array3: ...
    @overload
    def UpdateCurrentPosition(self, arg0: NodesArray) -> None: ...
    @overload
    def UpdateCurrentPosition(self, arg0: NodesArray, arg1: Array1DVariable3) -> None: ...
    @overload
    def UpdateCurrentPosition(self, arg0: NodesArray, arg1: Array1DVariable3, arg2: int) -> None: ...
    def UpdateCurrentToInitialConfiguration(self, arg0: NodesArray) -> None: ...
    def UpdateInitialToCurrentConfiguration(self, arg0: NodesArray) -> None: ...
    @overload
    def WeightedAccumulateConditionVariableOnNodes(self, arg0: ModelPart, arg1: DoubleVariable, arg2: IntegerVariable, arg3: bool) -> None: ...
    @overload
    def WeightedAccumulateConditionVariableOnNodes(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: IntegerVariable, arg3: bool) -> None: ...
    @overload
    def WeightedAccumulateConditionVariableOnNodes(self, arg0: ModelPart, arg1: DoubleVariable, arg2: DoubleVariable, arg3: bool) -> None: ...
    @overload
    def WeightedAccumulateConditionVariableOnNodes(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: bool) -> None: ...
    @overload
    def WeightedAccumulateElementVariableOnNodes(self, arg0: ModelPart, arg1: DoubleVariable, arg2: IntegerVariable, arg3: bool) -> None: ...
    @overload
    def WeightedAccumulateElementVariableOnNodes(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: IntegerVariable, arg3: bool) -> None: ...
    @overload
    def WeightedAccumulateElementVariableOnNodes(self, arg0: ModelPart, arg1: DoubleVariable, arg2: DoubleVariable, arg3: bool) -> None: ...
    @overload
    def WeightedAccumulateElementVariableOnNodes(self, arg0: ModelPart, arg1: Array1DVariable3, arg2: DoubleVariable, arg3: bool) -> None: ...

class VariablesListDataValueContainer:
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def GetValue(self, arg0: BoolVariable) -> bool: ...
    @overload
    def GetValue(self, arg0: IntegerVariable) -> int: ...
    @overload
    def GetValue(self, arg0: DoubleVariable) -> float: ...
    @overload
    def GetValue(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def GetValue(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def GetValue(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def GetValue(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def GetValue(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def GetValue(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def GetValue(self, arg0: StringVariable) -> str: ...
    @overload
    def Has(self, arg0: BoolVariable) -> bool: ...
    @overload
    def Has(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def Has(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def Has(self, arg0: VectorVariable) -> bool: ...
    @overload
    def Has(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def Has(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def Has(self, arg0: StringVariable) -> bool: ...
    @overload
    def SetValue(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def SetValue(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def SetValue(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def SetValue(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def SetValue(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def SetValue(self, arg0: DoubleQuaternionVariable, arg1) -> None: ...
    @overload
    def SetValue(self, arg0: StringVariable, arg1: str) -> None: ...
    @overload
    def __contains__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: IntegerVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: DoubleVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable3) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable4) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable6) -> bool: ...
    @overload
    def __contains__(self, arg0: Array1DVariable9) -> bool: ...
    @overload
    def __contains__(self, arg0: VectorVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: MatrixVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: DoubleQuaternionVariable) -> bool: ...
    @overload
    def __contains__(self, arg0: StringVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: BoolVariable) -> bool: ...
    @overload
    def __getitem__(self, arg0: IntegerVariable) -> int: ...
    @overload
    def __getitem__(self, arg0: DoubleVariable) -> float: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable3) -> Array3: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable4) -> Array4: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable6) -> Array6: ...
    @overload
    def __getitem__(self, arg0: Array1DVariable9) -> Array9: ...
    @overload
    def __getitem__(self, arg0: VectorVariable) -> Vector: ...
    @overload
    def __getitem__(self, arg0: MatrixVariable) -> Matrix: ...
    @overload
    def __getitem__(self, arg0: StringVariable) -> str: ...
    def __len__(self) -> int: ...
    @overload
    def __setitem__(self, arg0: BoolVariable, arg1: bool) -> None: ...
    @overload
    def __setitem__(self, arg0: IntegerVariable, arg1: int) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleVariable, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable3, arg1: Array3) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable4, arg1: Array4) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable6, arg1: Array6) -> None: ...
    @overload
    def __setitem__(self, arg0: Array1DVariable9, arg1: Array9) -> None: ...
    @overload
    def __setitem__(self, arg0: VectorVariable, arg1: Vector) -> None: ...
    @overload
    def __setitem__(self, arg0: MatrixVariable, arg1: Matrix) -> None: ...
    @overload
    def __setitem__(self, arg0: DoubleQuaternionVariable, arg1) -> None: ...
    @overload
    def __setitem__(self, arg0: StringVariable, arg1: str) -> None: ...

class VariationalDistanceCalculationProcess2D(Process):
    CALCULATE_EXACT_DISTANCES_TO_PLANE: ClassVar[Flags] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class VariationalDistanceCalculationProcess3D(Process):
    CALCULATE_EXACT_DISTANCES_TO_PLANE: ClassVar[Flags] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class Vector:
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    @overload
    def __init__(self, arg0: int) -> None: ...
    @overload
    def __init__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __init__(self, arg0: Vector) -> None: ...
    @overload
    def __init__(self, arg0: list) -> None: ...
    @overload
    def __init__(self, arg0: VectorSlice) -> None: ...
    @overload
    def __init__(self, arg0: buffer) -> None: ...
    def Resize(self, arg0: int) -> None: ...
    def Size(self) -> int: ...
    def fill(self, arg0: float) -> None: ...
    def norm_1(self) -> float: ...
    def norm_2(self) -> float: ...
    def norm_inf(self) -> float: ...
    def __add__(self, arg0: Vector) -> Vector: ...
    def __div__(self, arg0: float) -> Vector: ...
    @overload
    def __getitem__(self, arg0: int) -> float: ...
    @overload
    def __getitem__(self, arg0: slice) -> VectorSlice: ...
    @overload
    def __iadd__(self, arg0: float) -> Vector: ...
    @overload
    def __iadd__(self, arg0: Vector) -> Vector: ...
    def __imul__(self, arg0: float) -> Vector: ...
    @overload
    def __isub__(self, arg0: float) -> Vector: ...
    @overload
    def __isub__(self, arg0: Vector) -> Vector: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: float) -> Vector: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> Vector: ...
    def __rdiv__(self, arg0: float) -> None: ...
    def __rmul__(self, arg0: float) -> Vector: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: Vector) -> None: ...
    def __sub__(self, arg0: Vector) -> Vector: ...
    def __truediv__(self, arg0: float) -> Vector: ...

class VectorSlice:
    def __init__(self, *args, **kwargs) -> None: ...
    def Size(self) -> int: ...
    def __add__(self, other): ...
    def __div__(self, arg0: float) -> VectorSlice: ...
    def __getitem__(self, arg0: int) -> float: ...
    @overload
    def __iadd__(self, arg0: float) -> VectorSlice: ...
    @overload
    def __iadd__(self, arg0: VectorSlice) -> VectorSlice: ...
    def __imul__(self, arg0: float) -> VectorSlice: ...
    @overload
    def __isub__(self, arg0: float) -> VectorSlice: ...
    @overload
    def __isub__(self, arg0: VectorSlice) -> VectorSlice: ...
    def __iter__(self) -> Iterator: ...
    def __itruediv__(self, arg0: float) -> VectorSlice: ...
    def __len__(self) -> int: ...
    def __mul__(self, arg0: float) -> VectorSlice: ...
    def __rdiv__(self, arg0: float) -> None: ...
    def __rmul__(self, arg0: float) -> VectorSlice: ...
    @overload
    def __setitem__(self, arg0: int, arg1: float) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1: VectorSlice) -> None: ...
    @overload
    def __setitem__(self, arg0: slice, arg1, boost, std) -> None: ...
    def __sub__(self, other): ...

class VectorVariable(VariableData):
    def __init__(self, *args, **kwargs) -> None: ...

class VoxelMeshGeneratorModeler(Modeler):
    def __init__(self, arg0: Model, arg1) -> None: ...

class VtkOutput(IO):
    @overload
    def __init__(self, arg0: ModelPart) -> None: ...
    @overload
    def __init__(self, arg0: ModelPart, arg1) -> None: ...
    @staticmethod
    def GetDefaultParameters(*args, **kwargs): ...
    def PrintOutput(self, output_filename: str = ...) -> None: ...

class VtuOutput:
    class WriterFormat:
        __members__: ClassVar[dict] = ...  # read-only
        ASCII: ClassVar[VtuOutput.WriterFormat] = ...
        BINARY: ClassVar[VtuOutput.WriterFormat] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None: ...
        def __eq__(self, other: object) -> bool: ...
        def __hash__(self) -> int: ...
        def __index__(self) -> int: ...
        def __int__(self) -> int: ...
        def __ne__(self, other: object) -> bool: ...
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    ASCII: ClassVar[VtuOutput.WriterFormat] = ...
    BINARY: ClassVar[VtuOutput.WriterFormat] = ...
    CONDITIONS: ClassVar[Flags] = ...
    ELEMENTS: ClassVar[Flags] = ...
    NODES: ClassVar[Flags] = ...
    def __init__(self, model_part: ModelPart, is_initial_configuration_considered: bool = ..., binary_output: VtuOutput.WriterFormat = ..., precision: int = ...) -> None: ...
    def AddContainerExpression(self, *args, **kwargs): ...
    def AddFlagVariable(self, flag_variable_name: str, flag: Flags, entity_flags: Flags) -> None: ...
    @overload
    def AddHistoricalVariable(self, int_variable: IntegerVariable) -> None: ...
    @overload
    def AddHistoricalVariable(self, double_variable: DoubleVariable) -> None: ...
    @overload
    def AddHistoricalVariable(self, array3_variable: Array1DVariable3) -> None: ...
    @overload
    def AddHistoricalVariable(self, array4_variable: Array1DVariable4) -> None: ...
    @overload
    def AddHistoricalVariable(self, array6_variable: Array1DVariable6) -> None: ...
    @overload
    def AddHistoricalVariable(self, array9_variable: Array1DVariable9) -> None: ...
    @overload
    def AddNonHistoricalVariable(self, int_variable: IntegerVariable, entity_flags: Flags) -> None: ...
    @overload
    def AddNonHistoricalVariable(self, double_variable: DoubleVariable, entity_flags: Flags) -> None: ...
    @overload
    def AddNonHistoricalVariable(self, array3_variable: Array1DVariable3, entity_flags: Flags) -> None: ...
    @overload
    def AddNonHistoricalVariable(self, array4_variable: Array1DVariable4, entity_flags: Flags) -> None: ...
    @overload
    def AddNonHistoricalVariable(self, array6_variable: Array1DVariable6, entity_flags: Flags) -> None: ...
    @overload
    def AddNonHistoricalVariable(self, array9_variable: Array1DVariable9, entity_flags: Flags) -> None: ...
    def ClearCellContainerExpressions(self) -> None: ...
    def ClearCellFlags(self) -> None: ...
    def ClearCellNonHistoricalVariables(self) -> None: ...
    def ClearHistoricalVariables(self) -> None: ...
    def ClearNodalContainerExpressions(self) -> None: ...
    def ClearNodalFlags(self) -> None: ...
    def ClearNodalNonHistoricalVariables(self) -> None: ...
    def GetModelPart(self) -> ModelPart: ...
    def PrintOutput(self, output_file_name_prefix: str) -> None: ...

class WriteConditionsFlag:
    __members__: ClassVar[dict] = ...  # read-only
    WriteConditions: ClassVar[WriteConditionsFlag] = ...
    WriteConditionsOnly: ClassVar[WriteConditionsFlag] = ...
    WriteElementsOnly: ClassVar[WriteConditionsFlag] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class WriteDeformedMeshFlag:
    __members__: ClassVar[dict] = ...  # read-only
    WriteDeformed: ClassVar[WriteDeformedMeshFlag] = ...
    WriteUndeformed: ClassVar[WriteDeformedMeshFlag] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

def CreateModeler(*args, **kwargs): ...
def HasModeler(arg0: str) -> bool: ...
def Hello() -> str: ...
@overload
def ReadMatrixMarketMatrix(arg0: str, arg1: CompressedMatrix) -> bool: ...
@overload
def ReadMatrixMarketMatrix(arg0: str, arg1: ComplexCompressedMatrix) -> bool: ...
@overload
def ReadMatrixMarketVector(arg0: str, arg1: Vector) -> bool: ...
@overload
def ReadMatrixMarketVector(arg0: str, arg1: ComplexVector) -> bool: ...
@overload
def WriteMatrixMarketMatrix(arg0: str, arg1: CompressedMatrix, arg2: bool) -> bool: ...
@overload
def WriteMatrixMarketMatrix(arg0: str, arg1: ComplexCompressedMatrix, arg2: bool) -> bool: ...
@overload
def WriteMatrixMarketVector(arg0: str, arg1: Vector) -> bool: ...
@overload
def WriteMatrixMarketVector(arg0: str, arg1: ComplexVector) -> bool: ...
